// Dictionary.h: interface for the CDictionary class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __DICTIONARY_H__
#define __DICTIONARY_H__

#if defined(_MSC_VER)
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif

typedef std::map<long, std::string> ourDict;

const SI32 dictCANTOPEN = -1;
const SI32 dictDUPESECTION = -2;
const SI32 dictDUPEOPENBRACE = -3;
const SI32 dictNOOPENBRACE = -4;

class CDictionary
{
public:
					CDictionary();
					CDictionary( std::string filepath, std::string language );
	virtual			~CDictionary();
	std::string 	operator[]( SI32 Num );
	std::string 	GetEntry( SI32 Num );

public:
	void			ShowList( void );
	SI32			LoadDictionary( void );
	size_t			NumberOfEntries( void );
	void			SetValid( bool newVal );
	bool			GetValid( void );

private:
	bool IsValid;
	std::string PathToDictionary;
	std::string Language;
	std::map< long, std::string > Text2;
};

class CDictionaryContainer
{
private:
	CDictionary		*dictList[TOTAL_LANGUAGES];
	UnicodeTypes	defaultLang;
public:
					CDictionaryContainer();
					CDictionaryContainer( std::string filepath );
	virtual 		~CDictionaryContainer();
	SI32			LoadDictionary( void );
	std::string 	operator[]( SI32 Num );	// only default lang
	std::string 	GetEntry( SI32 Num, UnicodeTypes toDisp = ZERO );
	void			SetDefaultLang( UnicodeTypes newType );
};

#endif
