#ifndef __SEFuncs_h__
#define __SEFuncs_h__
// Function prototypes exposed to the Script Engine

// Version History
// 1.0		Abaddon		12th September, 2000
//			Initial implementation, not many functions added
// 1.1		Abaddon		14th September, 2000
//			Declaration of 90 API functions and implementation of around 20 of them
// 1.2		Abaddon		18th September, 2000
//			Addition of more API functions and declarations of them
// 1.3		Zippy		28th October, 2001
//			Addition of File i/o functions.
// 1.4 		Shadowlord	3rd  November, 2001
//			Addition of Tag functions.

typedef JSBool (SEngineFunc)( JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval );

// 90 functions so far
// *	== prototype 
// **	== active function

// Character and Item common functions (7)
SEngineFunc SE_DoDamage;			// Do damage to a char/item					***
SEngineFunc SE_SetSerial;			//											***


// Character related functions (9)

SEngineFunc SE_SpawnNPC;			// Create NPC								*
SEngineFunc SE_GetCharPack;			//											***

SEngineFunc SE_GetTown;				//											**
SEngineFunc SE_SetTown;				//											**
SEngineFunc SE_GetRegion;			//											**
SEngineFunc SE_SetRegion;			//											**

// Effect related functions (3)

SEngineFunc SE_DoMovingEffect;		// Does moving effect						***
SEngineFunc SE_DoTempEffect;		// Does a temp effect						***

// Item related functions (2)

SEngineFunc SE_CreateBlankItem;		// Create an item							***
SEngineFunc SE_CreateDFNItem;		// Create an item							***
SEngineFunc SE_SetDecayTime;		//											***
SEngineFunc SE_GetDecayTime;		//											***

// Speech related functions (7)

SEngineFunc SE_BroadcastMessage;	//											***
SEngineFunc SE_ConsoleMessage;		//											***

// Attack related functions (7)
SEngineFunc SE_AttackTarget;		// A attacks B								***
SEngineFunc SE_Attack;				//											***
SEngineFunc SE_FindNearestTarget;	//											*
SEngineFunc SE_FindStrongestTarget;	//											*
SEngineFunc SE_FindWeakestTarget;	//											*
SEngineFunc SE_FindFirstTarget;		//											*
SEngineFunc SE_FindLastTarget;		//											*
SEngineFunc SE_FindSmartestTarget;	//											*
SEngineFunc SE_FindDumbestTarget;	//											*
SEngineFunc SE_FindQuickestTarget;	//											*
SEngineFunc SE_FindSlowestTarget;	//											*


// Random functions(5)
SEngineFunc ScriptPrintNumber;		//											***
SEngineFunc SetShowLayer;			//											***
SEngineFunc GetShowLayer;			//											***
SEngineFunc SE_RandomNumber;		// Calculates a random number				***
SEngineFunc SE_CalcCharFromSer;		//											***
SEngineFunc SE_CalcItemFromSer;		//											***
SEngineFunc SE_DistanceTo;			// Distance between things					***

// Other functions
SEngineFunc	SE_GetCommand; 
SEngineFunc	SE_GetCommandSize; 
SEngineFunc SE_GetString;			//											***
SEngineFunc SE_GetDWord;			//											***
SEngineFunc SE_CreateBuffer;		//											*
SEngineFunc SE_DestroyBuffer;		//											*
SEngineFunc SE_SendBuffer;			//											*
SEngineFunc SE_SetByte;				//											***
SEngineFunc SE_SetWord;				//											***
SEngineFunc SE_SetDWord;			//											***
SEngineFunc SE_SetString;			//											***
SEngineFunc SE_ReadBytes;			//											***

SEngineFunc SE_UseReagant;			//											***
SEngineFunc SE_UseReagants;			//											***

SEngineFunc SE_GlowItem;			//											*

SEngineFunc SE_MakeMenu;			//											***
SEngineFunc SE_MakeItem;			//											***
SEngineFunc SE_CalcRank;			//											***

SEngineFunc SE_CommandLevelReq;		//											*
SEngineFunc SE_CommandExists;		//											*
SEngineFunc SE_FirstCommand;		//											*
SEngineFunc SE_NextCommand;			//											*
SEngineFunc SE_FinishedCommandList;	//											*

SEngineFunc SE_RegisterCommand;		//											*
SEngineFunc SE_UnregisterCommand;	//											*
SEngineFunc SE_RegisterKey;			//											*
SEngineFunc SE_UnregisterKey;		//											*
SEngineFunc SE_RegisterPacketHandler;	//										*
SEngineFunc SE_UnregisterPacketHandler;	//										*

SEngineFunc SE_GetHour;					//										***
SEngineFunc SE_GetMinute;				//										***
SEngineFunc SE_GetDay;					//										***
SEngineFunc SE_GetSecondsPerUOMinute;	//										***
SEngineFunc SE_GetLightLevel;			//										*

SEngineFunc SE_GetCurrentClock;			//										***
SEngineFunc SE_SubStringSearch;			//										***
SEngineFunc SE_GetMurderThreshold;		//										***
SEngineFunc SE_RollDice;				//										***
SEngineFunc SE_RaceCompare;				//										***
SEngineFunc SE_RaceCompareByRace;		//										***
SEngineFunc SE_FindItemOnLayer;			//										***

SEngineFunc SE_FindMulti;				//										***

SEngineFunc SE_IsRegionGuarded;			//										***
SEngineFunc SE_CanMarkInRegion;			//										***
SEngineFunc SE_CanRecallInRegion;		//										***
SEngineFunc SE_CanGateInRegion;			//										***

SEngineFunc SE_GetGuildType;			//										**
SEngineFunc SE_GetGuildName;			//										**
SEngineFunc SE_GetGuildMaster;			//										**
SEngineFunc SE_SetGuildType;			//										**
SEngineFunc SE_SetGuildName;			//										**
SEngineFunc SE_SetGuildMaster;			//										**
SEngineFunc SE_GetNumGuildMembers;		//										**
SEngineFunc SE_AddToGuild;				//										**
SEngineFunc SE_RemoveFromGuild;			//										**
SEngineFunc SE_CompareGuild;			//										**
SEngineFunc SE_CompareGuildByGuild;		//										**
SEngineFunc SE_GetGuildStone;			//										**

SEngineFunc SE_IsMemberOfTown;			//										***
SEngineFunc SE_GetTownMayor;			//										***
SEngineFunc SE_GetTownRace;				//										***
SEngineFunc SE_SetTownRace;				//										***
SEngineFunc SE_PossessTown;				//										***
SEngineFunc SE_GetTownTax;				//										*
SEngineFunc SE_GetTownTaxResource;		//										***
SEngineFunc SE_SetTownTax;				//										*
SEngineFunc SE_SetTownTaxResource;		//										*

SEngineFunc SE_IsRaceWeakToWeather;		//										***
SEngineFunc SE_GetRaceSkillAdjustment;	//										***

SEngineFunc SE_GetClosestTown;			//										*

SEngineFunc SE_UseDoor;					//										***

SEngineFunc SE_TriggerEvent;			//										*
SEngineFunc SE_GetGuild;				//										**

SEngineFunc SE_SkillBeingUsed;			//										**
SEngineFunc SE_SetSkillUse;				//										**

SEngineFunc SE_GetPrivateBit;			//										*
SEngineFunc SE_SetPrivateBit;			//										*
SEngineFunc SE_GetPrivateWord;			//										*
SEngineFunc SE_SetPrivateWord;			//										*
SEngineFunc SE_GetPrivateBitRange;		//										*
SEngineFunc SE_SetPrivateBitRange;		//										*
SEngineFunc SE_GetPackOwner;			//										***
SEngineFunc SE_CalcTargetedItem;		//										***
SEngineFunc SE_CalcTargetedChar;		//										***
SEngineFunc SE_GetTileIDAtMapCoord;		//										***

SEngineFunc SE_StringToNum;
SEngineFunc SE_NumToString;

SEngineFunc SE_GetRaceCount;
SEngineFunc SE_AreaCharacterFunction;

#endif

