//o--------------------------------------------------------------------------o
//|	File					-	ai.cpp
//|	Date					-	
//|	Developers		-	
//|	Organization	-	UOX3 DevTeam
//|	Status				-	Currently under development
//o--------------------------------------------------------------------------o
//|	Description		-	
//o--------------------------------------------------------------------------o
//| Modifications	-	
//o--------------------------------------------------------------------------o
#include "uox3.h"
#include "cRaces.h"
#include "targeting.h"
#include "cEffects.h"
#include "network.h"
#include "classes.h"
#include "regions.h"
#include "combat.h"

#undef DBGFILE
#define DBGFILE "ai.cpp"

void cCharStuff::CheckAI( CChar *i )
{
	if( i == NULL )
		return;

	const SI16 combatRange	= cwmWorldState->ServerData()->CombatMaxRange();
	UI08 worldNumber		= i->WorldNumber();
	cSocket *mSock			= NULL;
	CChar *realChar			= NULL;
	if( cwmWorldState->GetNextNPCAITime() <= cwmWorldState->GetUICurrentTime() || cwmWorldState->GetOverflow() )
	{
		switch( i->GetNPCAiType() )
		{
			case aiNOAI:		break;
			case aiHEALER_G: // Good Healers
				Network->PushConn();
				for( mSock = Network->FirstSocket(); !Network->FinishedSockets(); mSock = Network->NextSocket() )
				{
					realChar = mSock->CurrcharObj();
					bool inRange = objInRange( i, realChar, DIST_NEARBY );
					if( LineOfSight( mSock, realChar, i->GetX(), i->GetY(), i->GetZ(), WALLS_CHIMNEYS + DOORS + FLOORS_FLAT_ROOFING ) )
					{
						if( realChar->IsDead() && realChar->IsInnocent() && inRange && !realChar->IsCriminal() && !realChar->IsMurderer() )
						{
							npcAction( i, 0x10 );
							Targ->NpcResurrectTarget( realChar );
							Effects->staticeffect( realChar, 0x376A, 0x09, 0x06 );
							i->talkAll( ( 316 + RandomNum( 0, 4 ) ), false );
						}
						else if( realChar->IsDead() && inRange && realChar->IsMurderer() )
							i->talkAll( 322, true );
						else if( realChar->IsDead() && inRange && realChar->IsCriminal() )
							i->talkAll( 770, true );
					}
				}
				Network->PopConn();
				break;
			case aiEVIL: // Monsters, PK's - (stupid NPCs)
				if( !i->IsAtWar() )
				{
					SI16 xOffset = MapRegion->GetGridX( i->GetX() );
					SI16 yOffset = MapRegion->GetGridY( i->GetY() );
					for( SI08 counter1 = -1; counter1 <= 1; ++counter1 )
					{
						for( SI08 counter2 = -1; counter2 <= 1; ++counter2 )
						{
							SubRegion *MapArea = MapRegion->GetGrid( xOffset + counter1, yOffset + counter2, worldNumber );	// check 3 cols... do we really NEED to?
							if( MapArea == NULL )	// no valid region
								continue;
							CChar *tempChar;
							MapArea->PushChar();
							for( tempChar = MapArea->FirstChar(); !MapArea->FinishedChars(); tempChar = MapArea->GetNextChar() )
							{
								if( tempChar == NULL )
									continue;
								if( i == tempChar )
									continue;
								if( i->GetOwnerObj() != NULL && i->GetOwnerObj() == tempChar )
									continue;
								if( !objInRange( i, tempChar, combatRange) )
									continue;
								if( tempChar->IsInvulnerable() || tempChar->GetHidden() != 0 || tempChar->IsDead() )
									continue;
								if( !isOnline( tempChar ) && !tempChar->IsNpc() )
									continue;
								if( tempChar->GetNPCAiType() == aiEVIL || tempChar->GetNPCAiType() == aiHEALER_G )
									continue;
								if( !cwmWorldState->ServerData()->CombatMonstersVsAnimals() && creatures[tempChar->GetID()].IsAnimal() )
									continue;
								if( cwmWorldState->ServerData()->CombatMonstersVsAnimals() && creatures[tempChar->GetID()].IsAnimal() && RandomNum( 1, 100 ) > cwmWorldState->ServerData()->CombatAnimalsAttackChance() )
									continue;
								if( i->GetRace() != 0 && i->GetRace() == tempChar->GetRace() && RandomNum( 0, 100 ) >= 10 )	// 10% chance of turning on own race
									continue;
								SI08 raceComp;
								raceComp = Races->Compare( tempChar, i );
								if( raceComp == 2 )	// Allies
									continue;
								Combat->AttackTarget( i, tempChar );
								MapArea->PopChar();	// restore before returning
								return;
							}
							MapArea->PopChar();
						}
					}
				}
				break;
			case aiGUARD: // Guards
				if( !i->IsAtWar() )
				{
					SI16 xOffset = MapRegion->GetGridX( i->GetX() );
					SI16 yOffset = MapRegion->GetGridY( i->GetY() );
					for( SI08 counter1 = -1; counter1 <= 1; ++counter1 )
					{
						for( SI08 counter2 = -1; counter2 <= 1; ++counter2 )
						{
							SubRegion *MapArea = MapRegion->GetGrid( xOffset + counter1, yOffset + counter2, worldNumber );	// check 3 cols... do we really NEED to?
							if( MapArea == NULL )	// no valid region
								continue;
							CChar *tempChar;
							MapArea->PushChar();
							for( tempChar = MapArea->FirstChar(); !MapArea->FinishedChars(); tempChar = MapArea->GetNextChar() )
							{
								if( tempChar == NULL )
									continue;
								if( tempChar == i )
									continue;
								if( objInRange( i, tempChar, combatRange ) && !tempChar->IsInvulnerable() && !tempChar->IsDead() && tempChar->GetNPCAiType() == aiEVIL )
								{
									Combat->AttackTarget( i, tempChar );
									i->talkAll( 313, true );
									MapArea->PopChar();
									return;
								}
							}
							MapArea->PopChar();
						}
					}
				}
				break;
			case aiBANKER:			break;  // Banker
			case aiPLAYERVENDOR:	break;  // Player Vendors.
			case aiPET_GUARD:				// Guard AI
				CChar *pOwner;
				pOwner = (CChar*)i->GetOwnerObj();
				if( pOwner == NULL )
				{
					i->SetNPCAiType( aiNOAI );	// not guarding because no owner
					return;
				}
				if( pOwner->GetTarg() != INVALIDSERIAL )
					Combat->AttackTarget( i, &chars[pOwner->GetTarg()] );
				break;
			case aiEV_BS://Morrolan EV/BS logic
				if( !i->IsAtWar() )
				{
					SI16 xOffset = MapRegion->GetGridX( i->GetX() );
					SI16 yOffset = MapRegion->GetGridY( i->GetY() );
					for( SI08 counter1 = -1; counter1 <= 1; ++counter1 )
					{
						for( SI08 counter2 = -1; counter2 <= 1; ++counter2 )
						{
							SubRegion *MapArea = MapRegion->GetGrid( xOffset + counter1, yOffset + counter2, worldNumber );
							if( MapArea == NULL )	// no valid region
								continue;
							CChar *tempChar;
							MapArea->PushChar();
							for( tempChar = MapArea->FirstChar(); !MapArea->FinishedChars(); tempChar = MapArea->GetNextChar() )
							{
								if( tempChar == NULL || tempChar == i )
									continue;
								if( i->GetOwnerObj() != NULL && i->GetOwnerObj() == tempChar )
									continue;
								if( !objInRange( i, tempChar, combatRange ) )
									continue;
								if( tempChar->IsInvulnerable() || tempChar->IsDead() )
									continue;
								if( !isOnline( tempChar ) && !tempChar->IsNpc() )
									continue;
								Combat->AttackTarget( i, tempChar );
								MapArea->PopChar();
								return;
							}
							MapArea->PopChar();
						}
					}
				}
				break;
			case aiHEALER_E: //Evil Healers
				Network->PushConn();
				for( mSock = Network->FirstSocket(); !Network->FinishedSockets(); mSock = Network->NextSocket() )
				{
					realChar = mSock->CurrcharObj();
					bool inRange=objInRange( i, realChar, DIST_NEARBY );
					if( realChar->IsDead() && inRange && realChar->IsMurderer() )
					{
						npcAction( i, 0x10 );
						Targ->NpcResurrectTarget( realChar );
						Effects->staticeffect( realChar, 0x3709, 0x09, 0x19 ); //Flamestrike effect
						i->talkAll( ( 323 + RandomNum( 0, 4 ) ), false ); 
					}
					else if( !realChar->IsMurderer() && realChar->IsDead() && inRange )
						i->talkAll( 329, true );
				}
				Network->PopConn();
				break;
			default:
				Console.Error( 2, " cCharStuff::CheckAI-> Error npc %u (%X) has invalid AI type %i", i, i->GetSerial(), i->GetNPCAiType());	//Morrolan
				return;
		}
	}
}
