//o--------------------------------------------------------------------------o
//|	File			-	cBaseobject.cpp
//|	Date			-	7/26/200
//|	Developers		-	Abaddon/EviLDeD
//|	Organization	-	UOX3 DevTeam
//|	Status			-	Currently under development
//o--------------------------------------------------------------------------o
//|	Description		-	Version History
//|									
//|							1.0		Abaddon		26th July, 2000
//|							Initial implementation.  Most, if not all, common between
//|							items and chars is now implemented here	Functions declared
//|							as const where possible
//|									
//|							1.1		EviLDeD		Unknown
//|							Significant fraction of things moved to CBO to support 
//|							future functionality
//|									
//|							1.2		Abaddon		August 27th, 2000
//|							Addition of basic script trigger stuff. Function documentation 
//|							finished for all functions
//o--------------------------------------------------------------------------o
//| Modifications	-	
//o--------------------------------------------------------------------------o
#include <algorithm>
#include "uox3.h"
#include "power.h"
#include "trigger.h"
#include "fileio.h"
#include "cScript.h"

#include "ustring.h"


//o--------------------------------------------------------------------------
//|	Function		-	cBaseObject destructor
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	This function is does basically what the name implies
//o--------------------------------------------------------------------------
cBaseObject::~cBaseObject()
{
	if( multis != NULL )
		RemoveFromMulti( false );
	// Delete all tags.
	tags.erase(tags.begin(),tags.end());
}

const ObjectType	DEFBASE_OBJTYPE		= OT_CBO;
const RACEID		DEFBASE_RACE		= 0;
const SI16			DEFBASE_X			= 100;
const SI16			DEFBASE_Y			= 100;
const SI08			DEFBASE_Z			= 0;
const UI16			DEFBASE_ID			= 1;
const UI16			DEFBASE_COLOUR		= 0;
const UI08			DEFBASE_DIR			= 0;
const SERIAL		DEFBASE_SERIAL		= INVALIDSERIAL;
cBaseObject *		DEFBASE_MULTIS		= NULL;
cBaseObject *		DEFBASE_SPAWNSER	= NULL;
cBaseObject *		DEFBASE_OWNER		= NULL;
const SI16			DEFBASE_ICOUNTER	= 0;
const UI08			DEFBASE_WORLD		= 0;
const SI16			DEFBASE_STR			= 1;
const SI16			DEFBASE_DEX			= 1;
const SI16			DEFBASE_INT			= 1;
const SI16			DEFBASE_HP			= 1;
const SI08			DEFBASE_VISIBLE		= 0;
const bool			DEFBASE_DISABLED	= false;
const UI16			DEFBASE_DEF			= 0;
const SI16			DEFBASE_HIDAMAGE	= 0;
const SI16			DEFBASE_LODAMAGE	= 0;
const SI16			DEFBASE_KILLS		= 0;
const SI16			DEFBASE_KARMA		= 0;
const SI16			DEFBASE_FAME		= 0;
const SI32			DEFBASE_WEIGHT		= 0;
const SI16			DEFBASE_MANA		= 1;
const SI16			DEFBASE_STAMINA		= 1;
const UI16			DEFBASE_SCPTRIG		= 0xFFFF;
const SI16			DEFBASE_STR2		= 0;
const SI16			DEFBASE_DEX2		= 0;
const SI16			DEFBASE_INT2		= 0;
const bool			DEFBASE_SSAVE		= true;
const UI08			DEFBASE_ISDIRTY		= 1;
const SI32			DEFBASE_FP			= -1;
const bool			DEFBASE_SPAWNED		= false;
const UI08			DEFBASE_POISONED	= 0;
const SI16			DEFBASE_CARVE		= -1;

//o--------------------------------------------------------------------------
//|	Function		-	cBaseObject constructor
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	This function is does basically what the name implies
//o--------------------------------------------------------------------------
cBaseObject::cBaseObject( void ) : objType( DEFBASE_OBJTYPE ), race( DEFBASE_RACE ), x( DEFBASE_X ), y( DEFBASE_Y ), 
z( DEFBASE_Z ), id( DEFBASE_ID ), colour( DEFBASE_COLOUR ), dir( DEFBASE_DIR ), serial( DEFBASE_SERIAL ), 
multis( DEFBASE_MULTIS ), spawnserial( DEFBASE_SPAWNSER ), owner( DEFBASE_OWNER ), iCounter( DEFBASE_ICOUNTER ), 
worldNumber( DEFBASE_WORLD ), strength( DEFBASE_STR ), dexterity( DEFBASE_DEX ), intelligence( DEFBASE_INT ), 
hitpoints( DEFBASE_HP ), visible( DEFBASE_VISIBLE ), disabled( DEFBASE_DISABLED ), def( DEFBASE_DEF ), hidamage( DEFBASE_HIDAMAGE ),
lodamage( DEFBASE_LODAMAGE ), kills( DEFBASE_KILLS ), karma( DEFBASE_KARMA ), fame( DEFBASE_FAME ), weight( DEFBASE_WEIGHT ), 
mana( DEFBASE_MANA ), stamina( DEFBASE_STAMINA ), scriptTrig( DEFBASE_SCPTRIG ), st2( DEFBASE_STR2 ), dx2( DEFBASE_DEX2 ), 
in2( DEFBASE_INT2 ), shouldSave( DEFBASE_SSAVE ), isDirty( DEFBASE_ISDIRTY ), FilePosition( DEFBASE_FP ), 
spawned( DEFBASE_SPAWNED ), poisoned( DEFBASE_POISONED ), carve( DEFBASE_CARVE ), postLoaded( false )
{
	name.reserve( MAX_NAME );
	title.reserve( MAX_TITLE );
	genericDWords[0] = genericDWords[1] = genericDWords[2] = genericDWords[3] = 0;
	if( cwmWorldState != NULL && cwmWorldState->GetLoaded() )
		postLoaded = true;
}


//o--------------------------------------------------------------------------o
//|	Function			-	SI32 cBaseObject::GetNumTags( void ) const
//|	Date				-	
//|	Developers			-	
//|	Organization		-	UOX3 DevTeam
//|	Status				-	Currently under development
//o--------------------------------------------------------------------------o
//|	Description			-	
//o--------------------------------------------------------------------------o
//| Modifications		-	
//o--------------------------------------------------------------------------o
size_t cBaseObject::GetNumTags( void ) const 
{
	return tags.size();
}

//o--------------------------------------------------------------------------o
//|	Function			-	jsval cBaseObject::GetTag( std::string tagname ) const 
//|	Date				-	
//|	Developers			-	
//|	Organization		-	UOX3 DevTeam
//|	Status				-	Currently under development
//o--------------------------------------------------------------------------o
//|	Description			-	
//o--------------------------------------------------------------------------o
//| Modifications		-	
//o--------------------------------------------------------------------------o
jsval cBaseObject::GetTag( std::string tagname ) const 
{
	jsval rvalue		= 0;
	TAGMAP_CITERATOR CI = tags.find( tagname );
	if( CI != tags.end() )
	{
		rvalue = CI->second;
	}
	return rvalue;
}

//o--------------------------------------------------------------------------o
//|	Function			-	void cBaseObject::SetTag( std::string tagname, jsval tagval ) 
//|	Date				-	
//|	Developers			-	
//|	Organization		-	UOX3 DevTeam
//|	Status				-	Currently under development
//o--------------------------------------------------------------------------o
//|	Description			-	
//o--------------------------------------------------------------------------o
//| Modifications		-	
//o--------------------------------------------------------------------------o
void cBaseObject::SetTag( std::string tagname, jsval tagval ) 
{
	TAGMAP_ITERATOR I = tags.find( tagname );
	if( I != tags.end() )
	{
		// This tag exists so process it(Do something)
		if( JSVAL_IS_NULL(tagval) )
			tags.erase(I);
		else
		{
			//Change the tag's value.
			if( JSVAL_IS_STRING( tagval ) )
			{
				char *s_tagval = JS_GetStringBytes( JS_ValueToString( jsContext, tagval ) );
				JSString *s_string = JS_NewStringCopyZ( jsContext, s_tagval);
				I->second = STRING_TO_JSVAL(s_string);
			}
			else
			{
				I->second = tagval;
			}
		}
	}
	else
	{
		// We dont want to create an entry if the valie is NULL
		if( !JSVAL_IS_NULL( tagval ) )
		{
			if( JSVAL_IS_STRING( tagval ) )
			{
				char *s_tagval		= JS_GetStringBytes( JS_ValueToString( jsContext, tagval ) );
				JSString *s_string	= JS_NewStringCopyZ( jsContext, s_tagval);
				tags[tagname]		= STRING_TO_JSVAL(s_string);
			}
			else
			{
				tags[tagname] = tagval;
			}
		}
	}
}
//o--------------------------------------------------------------------------
//|	Function		-	SI16 GetX()
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns X location of object
//o--------------------------------------------------------------------------
SI16 cBaseObject::GetX( void ) const
{
	return x;
}

//o--------------------------------------------------------------------------
//|	Function		-	SI16 GetY()
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns Y location of object
//o--------------------------------------------------------------------------
SI16 cBaseObject::GetY( void ) const
{
	return y;
}

//o--------------------------------------------------------------------------
//|	Function		-	SI08 GetZ()
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns Z location of object
//o--------------------------------------------------------------------------
SI08 cBaseObject::GetZ( void ) const
{
	return z;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetX( SI16 newValue )
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the new X value
//o--------------------------------------------------------------------------
void cBaseObject::SetX( SI16 newValue )
{
	x = newValue;
	Dirty();
}

//o--------------------------------------------------------------------------
//|	Function		-	SetY( SI16 newValue )
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the new Y value
//o--------------------------------------------------------------------------
void cBaseObject::SetY( SI16 newValue )
{
	y = newValue;
	Dirty();
}

//o--------------------------------------------------------------------------
//|	Function		-	SetZ( SI08 newValue )
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the new Z value
//o--------------------------------------------------------------------------
void cBaseObject::SetZ( SI08 newValue )
{
	z = newValue;
	Dirty();
}

//o--------------------------------------------------------------------------
//|	Function		-	SetLocation( SI16 newX, SI16 newY, SI08 newZ )
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Moves to new location specified
//o--------------------------------------------------------------------------
void cBaseObject::SetLocation( SI16 newX, SI16 newY, SI08 newZ )
{
#if defined( _MSC_VER )
#pragma note( "Why this warning, if one shouldn't be using this method, then why not make it pure virtual?" )
#endif
	Console << "WARNING: Using cBaseObject::SetLocation for " << (UI32)this << myendl;
	x = newX;
	y = newY;
	z = newZ;
	Dirty();
}

//o--------------------------------------------------------------------------
//|	Function		-	UI16 GetID()
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the ID of the object
//o--------------------------------------------------------------------------
UI16 cBaseObject::GetID( void ) const
{
	return id;
}

//o--------------------------------------------------------------------------
//|	Function		-	UI16 GetColour()
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the colour of the object
//o--------------------------------------------------------------------------
UI16 cBaseObject::GetColour( void ) const
{
	return colour;
}

//o--------------------------------------------------------------------------
//|	Function		-	UI08 GetID( UI08 part )
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns part of the ID
//o--------------------------------------------------------------------------
UI08 cBaseObject::GetID( UI08 part ) const
{
	UI08 rvalue = (UI08)(id>>8);
	if( part == 2 )
	{
		rvalue = (UI08)(id%256);
	}
	return rvalue;
}

//o--------------------------------------------------------------------------
//|	Function		-	UI08 GetColour( UI08 part )
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns part of the colour
//o--------------------------------------------------------------------------
UI08 cBaseObject::GetColour( UI08 part ) const
{
	UI08 rvalue = (UI08)(colour>>8);
	if( part == 2 )
	{
		rvalue = (UI08)(colour%256);
	}
	return rvalue;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetID( UI16 newValue )
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the ID
//o--------------------------------------------------------------------------
void cBaseObject::SetID( UI16 newValue )
{
	id = newValue;
	Dirty();
}

//o--------------------------------------------------------------------------
//|	Function		-	SetColour( UI16 newValue )
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the colour to newValue
//o--------------------------------------------------------------------------
void cBaseObject::SetColour( UI16 newValue )
{
	colour = newValue;
	Dirty();
}

//o--------------------------------------------------------------------------
//|	Function		-	SetID( UI08 newValue, UI08 part )
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets part of the ID
//o--------------------------------------------------------------------------
void cBaseObject::SetID( UI08 newValue, UI08 part )
{
	if( part <= 2 && part > 0 )
	{
		UI08 parts[2];
		parts[0] = (UI08)(id>>8);
		parts[1] = (UI08)(id%256);
		parts[part-1] = newValue;
		id = (UI16)((parts[0]<<8) + parts[1]);
	}
	else
		Console << "Invalid part requested on SetID" << myendl;
}

//o---------------------------------------------------------------------------o
//|   Function    -  SI32 Weight( void ) const
//|   Date        -  Unknown
//|   Programmer  -  Abaddon
//o---------------------------------------------------------------------------o
//|   Purpose     -  Weight of the CHARACTER
//o---------------------------------------------------------------------------o
SI32 cBaseObject::GetWeight( void ) const
{
	return weight;
}
void cBaseObject::SetWeight( SI32 newVal )
{
	weight = newVal;
}

//o--------------------------------------------------------------------------
//|	Function		-	SERIAL GetMulti()
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns SERIAL of multi object we're within
//o--------------------------------------------------------------------------
SERIAL cBaseObject::GetMulti( void ) const
{
	SERIAL rvalue = INVALIDSERIAL;
	if( multis != NULL )
	{
		rvalue = multis->GetSerial();
	}
	return rvalue;
}

//o--------------------------------------------------------------------------
//|	Function		-	cBaseObject *GetMultiObj()
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns multi object we're within
//o--------------------------------------------------------------------------
cBaseObject *cBaseObject::GetMultiObj( void ) const
{
	return multis;
}

//o--------------------------------------------------------------------------
//|	Function		-	SERIAL GetSerial()
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns serial of the item
//o--------------------------------------------------------------------------
SERIAL cBaseObject::GetSerial( void ) const
{
	return serial;
}

//o--------------------------------------------------------------------------
//|	Function		-	SERIAL GetSpawn()
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns SERIAL of thing that spawned it
//o--------------------------------------------------------------------------
SERIAL cBaseObject::GetSpawn( void ) const
{
	SERIAL rvalue = INVALIDSERIAL;
	if( spawnserial != NULL )
	{
		try
		{
			rvalue = spawnserial->GetSerial();
		}
		catch( ... )
		{
			Console << "Unable to obtain serial number for spawn" << myendl;
		}
	}
	return rvalue;
}

//o--------------------------------------------------------------------------
//|	Function		-	cBaseObject *GetSpawnObj()
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns thing that spawned us
//o--------------------------------------------------------------------------
cBaseObject *cBaseObject::GetSpawnObj( void ) const
{
	return spawnserial;
}

//o--------------------------------------------------------------------------
//|	Function		-	SERIAL GetOwner()
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns SERIAL of thing that owns us
//o--------------------------------------------------------------------------
SERIAL cBaseObject::GetOwner( void ) const
{
	SERIAL rvalue = INVALIDSERIAL;
	if( owner != NULL )
		rvalue = owner->GetSerial();
	return rvalue;
}

//o--------------------------------------------------------------------------
//|	Function		-	cBaseObject *GetOwnerObj()
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns thing that owns us
//o--------------------------------------------------------------------------
cBaseObject *cBaseObject::GetOwnerObj( void ) const
{
	return owner;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetMulti( SERIAL newSerial )
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets serial of item we're within
//o--------------------------------------------------------------------------
void cBaseObject::SetMulti( SERIAL newSerial, bool fireTrigger )
{
	RemoveFromMulti( fireTrigger );
	if( (newSerial>>24) >= 0x40 )
	{
		multis = (cBaseObject *)calcItemObjFromSer( newSerial );
		AddToMulti( fireTrigger );
	}
}

//o--------------------------------------------------------------------------
//|	Function		-	SetSerial( SERIAL newSerial )
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets serial of item we are
//o--------------------------------------------------------------------------
void cBaseObject::SetSerial( SERIAL newSerial )
{
	serial = newSerial;
}


//o--------------------------------------------------------------------------
//|	Function		-	SetSpawn( SERIAL newSerial )
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets serial of item that spawned us
//o--------------------------------------------------------------------------
void cBaseObject::SetSpawn( SERIAL newSerial )
{
	if( (newSerial>>24) >= 0x40 )
		spawnserial = (cBaseObject *)calcItemObjFromSer( newSerial );
	else
		spawnserial	= (cBaseObject *)calcCharObjFromSer( newSerial );
}

//o--------------------------------------------------------------------------
//|	Function		-	void IsSpawned( bool setting )
//|	Date			-	15 March, 2002
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets if a obj is spawned, we dont need to save that for now
//o--------------------------------------------------------------------------
void cBaseObject::IsSpawned( bool setting )
{
	spawned = setting;
}

//o--------------------------------------------------------------------------
//|	Function		-	bool IsSpawned( void )
//|	Date			-	15 March, 2002
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	returns if the obj is spawned, we dont need to save that for now
//o--------------------------------------------------------------------------
bool cBaseObject::IsSpawned( void )
{
	return spawned;
}

//o--------------------------------------------------------------------------
//|	Function		-	DumpHeader( ofstream &outStream ) const
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Dumps out header information for world saving
//o--------------------------------------------------------------------------
bool cBaseObject::DumpHeader( std::ofstream &outStream ) const
{
	outStream << "[BASEOBJECT]" << std::endl;
	return true;
}


//o--------------------------------------------------------------------------
//|	Function		-	DumpBody( ofstream &outStream ) const
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Dumps out body information of the object
//|						This is tag/data pairing information
//o--------------------------------------------------------------------------
bool cBaseObject::DumpBody( std::ofstream &outStream ) const
{
	std::string destination;
	std::ostringstream dumping( destination );
	SI16 temp_st2, temp_dx2, temp_in2;


	//no need to check default for these, this should be in for every thing.
	dumping << "Name=" << name << std::endl;
	dumping << "Serial=" << "0x" << std::hex << serial << std::endl;
	dumping << "Location=" << std::dec << x << "," << y << "," << (SI16)z << "," << (SI16)worldNumber << std::endl;
	dumping << "ObjectType=" << (int)objType << std::endl;
	dumping << "ID=" << "0x" << std::hex << id << std::endl;
	dumping << "Colour=" << "0x" << colour << std::endl;
	dumping << "Direction=" << "0x" << (SI16)dir << std::endl;
	dumping << "Title=" << std::dec << title << std::endl;
	dumping << "Reputation=" << fame << "," << karma << "," << kills << std::endl;
	//=========== BUG (= For Characters the dex+str+int malis get saved and get rebuilt on next serverstartup = increasing malis)
	temp_st2 = st2;
	temp_dx2 = dx2;
	temp_in2 = in2;
	if( objType == OT_CHAR )
	{
		CChar *myChar = (CChar*)(this);

		// For every equipped item 
		// We need to reduce Str2+Dex2+Int2
		for( CItem *myItem = myChar->FirstItem(); !myChar->FinishedItems(); myItem = myChar->NextItem() )
		{
			if( myItem != NULL )
			{
				temp_st2 -= myItem->Strength2();
				temp_dx2 -= myItem->Dexterity2();
				temp_in2 -= myItem->Intelligence2();
			}
		}
	}
	//=========== BUGFIX END (by Dark-Storm)
	dumping << "Weight="  << weight << std::endl;
	dumping << "Mana=" << mana << std::endl;
	dumping << "Stamina=" << stamina << std::endl;
	dumping << "Dexterity=" << dexterity << "," << temp_dx2 << std::endl;
	dumping << "Intelligence=" << intelligence << "," << temp_in2 << std::endl;
	dumping << "Strength=" << strength << "," << temp_st2 << std::endl;
	dumping << "HitPoints=" << hitpoints << std::endl;

	if( multis != NULL )
	{
		dumping << "MultiID=" << "0x" << std::hex;
		try
		{
			dumping << multis->GetSerial() << std::endl;
		}
		catch( ... )
		{
			dumping << "FFFFFFFF" << std::endl;
			Console << "EXCEPTION: cBaseObject::DumpBody(" << name << "[" << serial << "]) - 'MultiID' points to invalid memory." << myendl;
		}
	}
	if( spawnserial != NULL )
	{
		dumping << "SpawnerID=" << "0x" << std::hex;
		try
		{
			dumping << spawnserial->GetSerial() << std::endl;
		}
		catch( ... )
		{
			dumping << "FFFFFFFF" << std::endl;
			Console << "EXCEPTION: cBaseObject::DumpBody(" << name << "[" << serial << "]) - 'SpawnSerial' points to invalid memory." << myendl;
		}
	}
	if( owner != NULL )
	{
		dumping << "OwnerID=" << "0x" << std::hex;
		try
		{
			dumping << owner->GetSerial() << std::endl;
		}
		catch( ... )
		{
			dumping << "FFFFFFFF" << std::endl;
			Console << "EXCEPTION: cBaseObject::DumpBody(" << name << "[" << serial << "]) - 'Owner' points to invalid memory." << myendl;
		}
	}
	dumping << "Race=" << std::dec << race << std::endl;
	dumping << "Visible=" << (SI16)visible << std::endl;
	dumping << "Disabled=" << (disabled?"1":"0") << std::endl;
	dumping << "Damage=" << hidamage << "," << lodamage << std::endl;
	dumping << "Poisoned=" << (SI16)poisoned << std::endl;
	dumping << "Carve=" << GetCarve() << std::endl;
	dumping << "Defense=" << def << std::endl;
	dumping << "ScpTrig=" << scriptTrig << std::endl;
	dumping << "DWords=" << genericDWords[0] << "," << genericDWords[1] << "," << genericDWords[2] << "," << genericDWords[3] << std::endl;
	// Ab, does this need to be written to the file? I am going to make it write it but comment or remove it if its not(remember to remove it from the Load routine as well)
	dumping << "iCounter=" << iCounter << std::endl;
	// Spin the character tags to save make sure to dump them too
	TAGMAP_CITERATOR CI;
	for( CI = tags.begin(); CI != tags.end(); ++CI )
	{
		dumping << "TAGNAME=" << CI->first << std::endl;
		if( JSVAL_IS_STRING(CI->second) )
		{
			char *s_tagval = JS_GetStringBytes( JS_ValueToString( jsContext, CI->second ) );
			dumping << "TAGVALS=" << (s_tagval) << std::endl;
		}
		else
		{
			dumping << "TAGVAL=" << ((SI32)CI->second) << std::endl;
		}
	}
	//====================================================================================

	outStream << dumping.str();

	// We can have exceptions, but return no errors ?
	return true;
}
//o--------------------------------------------------------------------------
//|	Function		-	bool Save( ofstream &outStream ) const
//|	Date			-	26 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Saves us out to disk based on mode
//|						0	Text
//|						1	Binary
//o--------------------------------------------------------------------------
bool cBaseObject::Save( std::ofstream &outStream ) const
{
	// One could consider passing the stream buffer, instead of the stream.
	DumpHeader( outStream );
	DumpBody( outStream );
	DumpFooter( outStream );
	return true;
}

//o--------------------------------------------------------------------------
//|	Function		-	cBaseObject *First()
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns first object that it contains
//o--------------------------------------------------------------------------
cBaseObject *cBaseObject::First( void )
{
	return NULL;
}

//o--------------------------------------------------------------------------
//|	Function		-	cBaseObject *Next()
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns next object in the list
//o--------------------------------------------------------------------------
cBaseObject *cBaseObject::Next( void )
{
	return NULL;
}

//o--------------------------------------------------------------------------
//|	Function		-	bool AtEnd()
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns true if at end of the object list
//o--------------------------------------------------------------------------
bool cBaseObject::AtEnd( void )
{
	return true;
}

//o--------------------------------------------------------------------------
//|	Function		-	RACEID GetRace()
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the associated race of the object
//o--------------------------------------------------------------------------
RACEID cBaseObject::GetRace( void ) const
{
	return race;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetRace( RACEID newRace )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the objects Race property
//o--------------------------------------------------------------------------
void cBaseObject::SetRace( RACEID newValue )
{
	race = newValue;
}

//o--------------------------------------------------------------------------
//|	Function		-	const char *GetName()
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the name of the object
//o--------------------------------------------------------------------------
std::string cBaseObject::GetName( void ) const
{
	return name;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetName( const char *newName )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the name of the object
//o--------------------------------------------------------------------------
void cBaseObject::SetName( std::string newName )
{
	name = newName.substr( 0, MAX_NAME - 1 );
}

//o--------------------------------------------------------------------------
//|	Function		-	SI16 GetStrength()
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the strength of the object
//o--------------------------------------------------------------------------
SI16 cBaseObject::GetStrength( void ) const
{
	return strength;
}

//o--------------------------------------------------------------------------
//|	Function		-	SI16 GetDexterity()
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the dexterity of the object
//o--------------------------------------------------------------------------
SI16 cBaseObject::GetDexterity( void ) const
{
	return dexterity;
}

//o--------------------------------------------------------------------------
//|	Function		-	SI16 GetIntelligence()
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the intelligence of the object
//o--------------------------------------------------------------------------
SI16 cBaseObject::GetIntelligence( void ) const
{
	return intelligence;
}

//o--------------------------------------------------------------------------
//|	Function		-	SI16 GetHP()
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the hitpoints of the object
//o--------------------------------------------------------------------------
SI16 cBaseObject::GetHP( void ) const
{
	return hitpoints;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetStrength( SI16 newValue )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the strength of the obhect
//o--------------------------------------------------------------------------
void cBaseObject::SetStrength( SI16 newValue )
{
//	if( newValue > 0 || objType != OT_CHAR )//never set a char's stats to 0
	strength = newValue;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetDexterity( SI16 newValue )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the dexterity of the object
//o--------------------------------------------------------------------------
void cBaseObject::SetDexterity( SI16 newValue )
{
//	if( newValue > 0 || objType != OT_CHAR )//never set a char's stats to 0
	dexterity = newValue;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetIntelligence( SI16 newValue )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the intelligence of the object
//o--------------------------------------------------------------------------
void cBaseObject::SetIntelligence( SI16 newValue )
{
//	if( newValue > 0 || objType != OT_CHAR )//never set a char's stats to 0
	intelligence = newValue;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetHP( SI16 newValue )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the hitpoints of the object
//o--------------------------------------------------------------------------
void cBaseObject::SetHP( SI16 newValue )
{
	hitpoints = newValue;
}

//o--------------------------------------------------------------------------
//|	Function		-	IncHP( SI16 amtToChange )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Increments the hitpoints of the object
//o--------------------------------------------------------------------------
void cBaseObject::IncHP( SI16 amtToChange )
{
	hitpoints += amtToChange;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetDir( UI08 newDir )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the direction of the object
//o--------------------------------------------------------------------------
void cBaseObject::SetDir( UI08 newDir )
{
	dir = newDir;
	Dirty();
}

//o--------------------------------------------------------------------------
//|	Function		-	UI08 GetDir()
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the direction of the object
//o--------------------------------------------------------------------------
UI08 cBaseObject::GetDir( void ) const
{
	return dir;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetVisible( char newValue )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the visibility property of the object
//|						Generally it is
//|						0	Visible
//|						1	Owner||GM / Magically invisible
//|						2	GM only/hidden
//o--------------------------------------------------------------------------
void cBaseObject::SetVisible( SI08 newValue )
{
	visible = newValue;
	Dirty();
}

//o--------------------------------------------------------------------------
//|	Function		-	char GetVisible()
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the visibility property of the object
//o--------------------------------------------------------------------------
SI08 cBaseObject::GetVisible( void ) const
{
	return visible;
}

//o--------------------------------------------------------------------------
//|	Function		-	bool IsVisible()
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns true if the object is visible to all players
//o--------------------------------------------------------------------------
bool cBaseObject::IsVisible( void ) const
{
	return visible == 0;
}

//o--------------------------------------------------------------------------
//|	Function		-	string GetObjType()
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns a string that indicates the item's type
//o--------------------------------------------------------------------------
ObjectType cBaseObject::GetObjType( void ) const
{
	return objType;
}

//o--------------------------------------------------------------------------
//|	Function		-	bool IsDisabled()
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns true if the object is disabled
//o--------------------------------------------------------------------------
bool cBaseObject::IsDisabled( void ) const
{
	return disabled;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetDisabled( bool newValue )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the disabled value of the object
//o--------------------------------------------------------------------------
void cBaseObject::SetDisabled( bool newValue )
{
	disabled = newValue;
}

//o--------------------------------------------------------------------------
//|	Function		-	RemoveFromMulti( bool fireTrigger )
//|	Date			-	15 December, 2001
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Removes object from a multi, selectively firing the trigger
//o--------------------------------------------------------------------------
void cBaseObject::RemoveFromMulti( bool fireTrigger )
{
	if( multis != NULL )
	{
		if( multis->GetObjType() == OT_MULTI )
		{
			CMultiObj *mulObj = static_cast<CMultiObj *>(multis);
			mulObj->RemoveFromMulti( this );
			if( fireTrigger )
			{
				cScript *onLeaving = Trigger->GetScript( GetScriptTrigger() );
				if( onLeaving != NULL )
					onLeaving->OnLeaving( mulObj, this );
			}
		}
		else
			Console.Error( 2, "Object of type %i with serial %X has a bad multi setting of %i", GetObjType(), serial, multis->GetSerial() );
	}
}

//o--------------------------------------------------------------------------
//|	Function		-	AddToMulti( void )
//|	Date			-	15 December, 2001
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Adds object to multi
//o--------------------------------------------------------------------------
void cBaseObject::AddToMulti( bool fireTrigger )
{
	if( multis != NULL )
	{
		if( multis->GetObjType() == OT_MULTI )
		{
			CMultiObj *mulObj = static_cast<CMultiObj *>(multis);
			mulObj->AddToMulti( this );
			if( fireTrigger )
			{
				cScript *onEntrance = Trigger->GetScript( GetScriptTrigger() );
				if( onEntrance != NULL )
					onEntrance->OnEntrance( mulObj, this );
			}
		}
		else
			Console.Error( 2, "Object of type %i with serial %X has a bad multi setting of %X", GetObjType(), serial, multis->GetSerial() );
	}
}

//o--------------------------------------------------------------------------
//|	Function		-	SetMulti( cBaseObject *newMulti )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the object's multi to newMulti
//o--------------------------------------------------------------------------
void cBaseObject::SetMulti( cBaseObject *newMulti, bool fireTrigger )
{
	RemoveFromMulti( fireTrigger );
	multis = newMulti;
	AddToMulti( fireTrigger );
}

//o--------------------------------------------------------------------------
//|	Function		-	SetSpawn( cBaseObject *newSpawn )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the object's spawner to newSpawn
//o--------------------------------------------------------------------------
void cBaseObject::SetSpawn( cBaseObject *newSpawn )
{
	spawnserial = newSpawn;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetOwner( cBaseObject *newOwner )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the object's owner to newOwner
//o--------------------------------------------------------------------------
void cBaseObject::SetOwner( cBaseObject *newOwner )
{
	owner = newOwner;
}

//o--------------------------------------------------------------------------
//|	Function		-	UI08 GetSerial( UI08 part )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns part of a serial #
//o--------------------------------------------------------------------------
UI08 cBaseObject::GetSerial( UI08 part ) const
{
	switch( part )
	{
		case 1:	return (UI08)(serial>>24);
		case 2:	return (UI08)(serial>>16);
		case 3: return (UI08)(serial>>8);
		case 4: return (UI08)(serial%256);
	}
	return 0;
}

//o--------------------------------------------------------------------------
//|	Function		-	UCHAR GetSpawn( UCHAR part )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns part of the item's spawner serial
//o--------------------------------------------------------------------------
UI08 cBaseObject::GetSpawn( UI08 part ) const
{
	UI08 rvalue = 0;
	if( spawnserial != NULL )
		rvalue = spawnserial->GetSerial( part );
	return rvalue;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetOwner( SERIAL newSerial )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the object's serial to newSerial
//o--------------------------------------------------------------------------
void cBaseObject::SetOwner( SERIAL newSerial )
{
	if( newSerial == INVALIDSERIAL )
		owner = NULL;
	if( newSerial >= BASEITEMSERIAL )
		owner = (cBaseObject *)calcItemObjFromSer( newSerial );
	else
		owner = (cBaseObject *)calcCharObjFromSer( newSerial );
}

//o--------------------------------------------------------------------------
//|	Function		-	SI16 GetHiDamage( void )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the high amount of damage that it can do
//o--------------------------------------------------------------------------
SI16 cBaseObject::GetHiDamage( void ) const
{
	return hidamage;
}

//o--------------------------------------------------------------------------
//|	Function		-	SI16 GetLoDamage( void )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the low amount of damage that it can do
//o--------------------------------------------------------------------------
SI16 cBaseObject::GetLoDamage( void ) const
{
	return lodamage;
}

//o--------------------------------------------------------------------------
//|	Function		-	UI16 GetDef( void )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the object's multi to newMulti
//o--------------------------------------------------------------------------
UI16 cBaseObject::GetDef( void ) const
{
	return def;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetHiDamage( SI16 newValue )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the object's high damage value
//o--------------------------------------------------------------------------
void cBaseObject::SetHiDamage( SI16 newValue )
{
	hidamage = newValue;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetLoDamage( SI16 newValue )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the object's multi to newMulti
//o--------------------------------------------------------------------------
void cBaseObject::SetLoDamage( SI16 newValue )
{
	lodamage = newValue;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetDef( UI16 newValue )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the object's defense value
//o--------------------------------------------------------------------------
void cBaseObject::SetDef( UI16 newValue )
{
	def = newValue;
}


//o--------------------------------------------------------------------------
//|	Function		-	SI32 SetFilePosition( LONG filepos )
//|	Date			-	Unknown
//|	Programmer		-	EviLDeD
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the object's file position
//o--------------------------------------------------------------------------
SI32 cBaseObject::SetFilePosition( SI32 filepos )
{
	FilePosition = filepos;
	return FilePosition;
}

//o--------------------------------------------------------------------------
//|	Function		-	SI32 GetFilePosition( void )
//|	Date			-	Unknown
//|	Programmer		-	EviLDeD
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the object's file position
//o--------------------------------------------------------------------------
SI32 cBaseObject::GetFilePosition( void ) const
{
	return FilePosition;
}

//o--------------------------------------------------------------------------
//|	Function		-	SI16 GetStamina( void )
//|	Date			-	unknown
//|	Programmer		-	EviLDeD
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the object's stamina
//o--------------------------------------------------------------------------
SI16 cBaseObject::GetStamina( void ) const
{
	return stamina;
}

//o--------------------------------------------------------------------------
//|	Function		-	GetStamina( SI16 stam )
//|	Date			-	unknown
//|	Programmer		-	EviLDeD
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the object's stamina
//o--------------------------------------------------------------------------
void cBaseObject::SetStamina( SI16 stam )
{
	stamina = stam;
}

//o--------------------------------------------------------------------------
//|	Function		-	SI16 GetMana( void )
//|	Date			-	unknown
//|	Programmer		-	EviLDeD
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the object's mana
//o--------------------------------------------------------------------------
SI16 cBaseObject::GetMana( void ) const 
{
	return mana;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetMana( SI16 mn )
//|	Date			-	unknown
//|	Programmer		-	EviLDeD
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the object's mana
//o--------------------------------------------------------------------------
void cBaseObject::SetMana( SI16 mn )
{
	mana = UOX_MIN( UOX_MAX( static_cast<SI16>(0), mn ), intelligence );
}

//o--------------------------------------------------------------------------
//|	Function		-	SI16 GetKarma( void )
//|	Date			-	unknown
//|	Programmer		-	EviLDeD
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the object's karma
//o--------------------------------------------------------------------------
SI16 cBaseObject::GetKarma( void ) const
{
	return karma;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetKarma( SI16 value )
//|	Date			-	unknown
//|	Programmer		-	EviLDeD
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the object's karma
//o--------------------------------------------------------------------------
void cBaseObject::SetKarma( SI16 value )
{
	karma = value;
}

//o--------------------------------------------------------------------------
//|	Function		-	SI16 GetFame( void )
//|	Date			-	unknown
//|	Programmer		-	EviLDeD
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the object's fame
//o--------------------------------------------------------------------------
SI16 cBaseObject::GetFame( void ) const
{
	return fame;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetFame( SI16 value )
//|	Date			-	unknown
//|	Programmer		-	EviLDeD
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the object's fame
//o--------------------------------------------------------------------------
void cBaseObject::SetFame( SI16 value )
{
	fame = value;
}

//o--------------------------------------------------------------------------
//|	Function		-	SI16 GetKills( void )
//|	Date			-	unknown
//|	Programmer		-	EviLDeD
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the object's kills
//o--------------------------------------------------------------------------
SI16 cBaseObject::GetKills( void ) const
{
	return kills;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetKills( SI16 value )
//|	Date			-	unknown
//|	Programmer		-	EviLDeD
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the object's kills
//o--------------------------------------------------------------------------
void cBaseObject::SetKills( SI16 value )
{
	kills = value;
}

//o--------------------------------------------------------------------------
//|	Function		-	std::string GetTitle( void )
//|	Date			-	unknown
//|	Programmer		-	EviLDeD
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the object's title
//o--------------------------------------------------------------------------
std::string cBaseObject::GetTitle( void ) const
{
	return title;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetTitle( std::string newtitle )
//|	Date			-	unknown
//|	Programmer		-	EviLDeD
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the object's title
//o--------------------------------------------------------------------------
void cBaseObject::SetTitle( std::string newtitle )
{
	title = newtitle.substr( 0, MAX_TITLE - 1 );
}

//o--------------------------------------------------------------------------
//|	Function		-	UI16 GetScriptTrigger( void )
//|	Date			-	August 27th, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the object's script trigger value
//o--------------------------------------------------------------------------
UI16 cBaseObject::GetScriptTrigger( void ) const
{
	return scriptTrig;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetScriptTrigger( UI16 newValue )
//|	Date			-	August 27th, 2000
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the object's script trigger value
//o--------------------------------------------------------------------------
void cBaseObject::SetScriptTrigger( UI16 newValue )
{
	scriptTrig = newValue;
}

//o--------------------------------------------------------------------------
//|	Function		-	point3 GetLocation( void )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns a point3 structure pointing to the object's 
//|						current location
//o--------------------------------------------------------------------------
point3 cBaseObject::GetLocation( void ) const
{
	return point3( x, y, z );
}

//o--------------------------------------------------------------------------
//|	Function		-	void GetLocation( point3 &toSet )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the location of the current object to point3 var
//o--------------------------------------------------------------------------
void cBaseObject::SetLocation( point3 &toSet )
{
	SetLocation( (short)toSet.x, (short)toSet.y, (SI08)toSet.z );
}


//o--------------------------------------------------------------------------
//|	Function		-	SI16 Strength2( void )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the second strength var associated with the 
//|						object.  For chars, it's the bonuses 
//|						(via armour and such)
//o--------------------------------------------------------------------------
SI16 cBaseObject::Strength2( void ) const
{
	return st2;
}

//o--------------------------------------------------------------------------
//|	Function		-	SI16 Dexterity2( void )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the second dexterity var associated with the 
//|						object.  For chars, it's the bonuses 
//|						(via armour and such)
//o--------------------------------------------------------------------------
SI16 cBaseObject::Dexterity2( void ) const
{
	return dx2;
}

//o--------------------------------------------------------------------------
//|	Function		-	SI16 Intelligence2( void )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the second intelligence var associated with
//|						the object.  For chars, it's the bonuses 
//|						(via armour and such)
//o--------------------------------------------------------------------------
SI16 cBaseObject::Intelligence2( void ) const
{
	return in2;
}

//o--------------------------------------------------------------------------
//|	Function		-	void Strength2( SI16 nVal )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the second strength var associated with the
//|						object.  For chars, it's the bonuses 
//|						(via armour and such)
//o--------------------------------------------------------------------------
void cBaseObject::Strength2( SI16 nVal )
{
	st2 = nVal;
}

//o--------------------------------------------------------------------------
//|	Function		-	void Dexterity2( SI16 nVal )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the second dexterity var associated with the 
//|						object.  For chars, it's the bonuses 
//|						(via armour and such)
//o--------------------------------------------------------------------------
void cBaseObject::Dexterity2( SI16 nVal )
{
	dx2 = nVal;
}

//o--------------------------------------------------------------------------
//|	Function		-	void Intelligence2( SI16 nVal )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the second intelligence var associated with
//|						the object.  For chars, it's the bonuses 
//|						(via armour and such)
//o--------------------------------------------------------------------------
void cBaseObject::Intelligence2( SI16 nVal )
{
	in2 = nVal;
}

//o--------------------------------------------------------------------------
//|	Function		-	void IncStrength( SI16 toInc = 1 )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Increments the object's strength value
//o--------------------------------------------------------------------------
void cBaseObject::IncStrength( SI16 toInc )
{
	SetStrength( GetStrength() + toInc );
}

//o--------------------------------------------------------------------------
//|	Function		-	void DecStrength( void )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Decrements the object's strength value by 1
//o--------------------------------------------------------------------------
void cBaseObject::DecStrength( void )
{
	if( GetStrength() > 0 )
		SetStrength( GetStrength() - 1 );
}

//o--------------------------------------------------------------------------
//|	Function		-	void IncDexterity( SI16 toInc = 1 )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Increments the object's dexterity value
//o--------------------------------------------------------------------------
void cBaseObject::IncDexterity( SI16 toInc )
{
	SetDexterity( GetDexterity() + toInc );
}

//o--------------------------------------------------------------------------
//|	Function		-	void DecDexterity( void )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Decrements the object's dexterity value
//o--------------------------------------------------------------------------
void cBaseObject::DecDexterity( void )
{
	if( GetDexterity() > 0 )
		SetDexterity( GetDexterity() - 1 );
}

//o--------------------------------------------------------------------------
//|	Function		-	void IncIntelligence( SI16 toInc = 1 )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Increments the object's intelligence value
//o--------------------------------------------------------------------------
void cBaseObject::IncIntelligence( SI16 toInc )
{
	SetIntelligence( GetIntelligence() + toInc );
}

//o--------------------------------------------------------------------------
//|	Function		-	void IncIntelligence( SI16 toInc = 1 )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Decrements the object's intelligence value
//o--------------------------------------------------------------------------
void cBaseObject::DecIntelligence( void )
{
	if( GetIntelligence() > 0 )
		SetIntelligence( GetIntelligence() - 1 );
}

//o--------------------------------------------------------------------------
//|	Function		-	bool DumpFooter( ofstream &outStream )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Dumps out footer information so that a logical break
//|						between entries can be found without moving file 
//|						pointers
//|						Mode 0 - Text
//|						Mode 1 - Binary
//o--------------------------------------------------------------------------
bool cBaseObject::DumpFooter( std::ofstream &outStream ) const
{
	outStream << std::endl << "o---o" << std::endl << std::endl;
	return true;
}

//o--------------------------------------------------------------------------
//|	Function		-	bool Load( std::ifstream &inStream )
//|	Date			-	28 July, 2000
//|	Programmer		-	Abaddon
//|	Modified		-	Zippy (1/9/02) no longer needs mode
//o--------------------------------------------------------------------------
//|	Purpose			-	Loads object from disk based on mode
//o--------------------------------------------------------------------------
bool cBaseObject::Load( std::ifstream &inStream )
{
	UString tag = "", data = "";
	while( tag != "o---o" )
	{
		FileIO->ReadWorldTagData( inStream, tag, data );
		if( tag != "o---o" )
		{
			if( !HandleLine( tag, data ) )
			{
				Console.Warning( 1, "Unknown world file tag %s with contents of %s", tag.c_str(), data.c_str() );
			}
		}
	}
	return true;
}



//o--------------------------------------------------------------------------
//|	Function		-	bool HandleLine( char *tag, char *data )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Used to handle world lines.  Returns true if the tag
//|						is known.  If known, internal information updated
//|						and load routine continues to next tag.  Otherwise,
//|						passed up inheritance tree (if any)
//o--------------------------------------------------------------------------
bool cBaseObject::HandleLine( UString &tag, UString &data )
{
	static std::string staticTagName = "";
	bool rvalue = false;

	if( tag != "o---o" )
	{
		switch( (tag.data()[0]) )
		{
			case 'C':
				if( tag.upper() == "COLOUR" )
				{
					colour = data.toUShort();
					rvalue = true;
				}
				else if( tag.upper() == "CARVE" )
				{
					carve	= data.toShort();
					rvalue	= true;
				}
				break;
			case 'D':
				if( tag.upper() == "DAMAGE" )
				{
					hidamage	= data.section( ",", 1, 1 ).stripWhiteSpace().toShort();
					lodamage	= data.section( ",", 0, 0 ).stripWhiteSpace().toShort();
					rvalue		= true;
				}
				if( tag.upper() == "DIRECTION" )
				{
					dir		= data.toUByte();
					rvalue	= true;
				}
				else if( tag.upper() == "DEXTERITY" )
				{
					rvalue= true;
					if( data.sectionCount( "," ) != 0 )
					{
						dexterity	= data.section( ",", 0, 0 ).stripWhiteSpace().toShort();
						dx2			= data.section( ",", 1, 1 ).stripWhiteSpace().toShort();
					}
					else
						dexterity = data.toShort();
				}
				else if( tag.upper() == "DEXTERITY2" )
				{
					dx2		= data.toShort();
					rvalue	= true;
				}
				else if( tag.upper() == "DEFENSE" )
				{
					def		= data.toUShort();
					rvalue	= true;
				}
				else if( tag.upper() == "DWORDS" )
				{
					genericDWords[0]	= data.section( ",", 0, 0 ).stripWhiteSpace().toULong();
					genericDWords[1]	= data.section( ",", 1, 1 ).stripWhiteSpace().toULong();
					genericDWords[2]	= data.section( ",", 2, 2 ).stripWhiteSpace().toULong();
					genericDWords[3]	= data.section( ",", 3, 3 ).stripWhiteSpace().toULong();
					rvalue				= true;
				}
				else if( tag.upper() == "DWORD0" )	// Depreciated
				{
					rvalue = true;
				}
				else if( tag.upper() == "DWORD1" )	// Depreciated
				{
					rvalue = true;
				}
				else if( tag.upper() == "DWORD2" )	// Depreciated
				{
					rvalue = true;
				}
				else if( tag.upper() == "DWORD3" )	// Depreciated
				{
					rvalue = true;
				}
				else if( tag.upper() == "DISABLED" )
				{
					SetDisabled( data.toUShort() == 1 );
					rvalue = true;
				}
				break;
			case 'F':
				if( tag.upper() == "FAME" )
				{
					fame	= data.toShort();
					rvalue	= true;
				}
				break;
			case 'H':
				if( tag.upper() == "HITPOINTS" )
				{
					hitpoints	= data.toShort();
					rvalue		= true;
				}
				else if( tag.upper() == "HIDAMAGE" )
				{
					hidamage	= data.toShort();
					rvalue		= true;
				}
				break;
			case 'I':
				if( tag.upper() == "ID" )
				{
					id		= data.toUShort();
					rvalue	= true;
				}
				else if( tag.upper() == "INTELLIGENCE" )
				{
					if( data.sectionCount( "," ) != 0 )
					{
						intelligence	= data.section( ",", 0, 0 ).stripWhiteSpace().toShort();
						in2				= data.section( ",", 1, 1 ).stripWhiteSpace().toShort();
					}
					else
						intelligence = data.toShort();
					rvalue = true;
				}
				else if( tag.upper() == "INTELLIGENCE2" )
				{
					in2		= data.toShort();
					rvalue	= true;
				}
				break;
			case 'i':
				if( tag.upper() == "ICOUNTER" )
				{
					rvalue = true;	// don't process anything about it
				}
				break;
			case 'K':
				if( tag.upper() == "KILLS" )
				{
					kills	= data.toShort();
					rvalue	= true;
				}
				else if( tag.upper() == "KARMA" )
				{
					karma	= data.toShort();
					rvalue	= true;
				}
				break;
			case 'L':
				if( tag.upper() == "LOCATION" )
				{
					x			= data.section( ",", 0, 0 ).stripWhiteSpace().toShort();
					y			= data.section( ",", 1, 1 ).stripWhiteSpace().toShort();
					z			= data.section( ",", 2, 2 ).stripWhiteSpace().toByte();
					worldNumber = data.section( ",", 3, 3 ).stripWhiteSpace().toUByte();
					rvalue		= true;
				}
				else if( tag.upper() == "LODAMAGE" )
				{
					lodamage	= data.toShort();
					rvalue		= true;
				}
				break;
			case 'M':
				if( tag.upper() == "MANA" )
				{
					mana	= data.toShort();
					rvalue	= true;
				}
				else if( tag.upper() == "MULTIID" )
				{
					multis = (cBaseObject *)data.toULong();
					rvalue = true;
				}
				break;
			case 'N':
				if( tag.upper() == "NAME" )
				{
					name = data.substr( 0, MAX_NAME );
					rvalue = true;
				}
				break;
			case 'O':
				if( tag.upper() == "OBJECTTYPE" )
				{
					objType = (ObjectType)data.toUShort();
					rvalue	= true;
				}
				else if( tag.upper() == "OWNERID" )
				{
					owner	= (cBaseObject *)data.toULong();
					rvalue	= true;
				}
				break;
			case 'P':
				if( tag.upper() == "POISONED" )
				{
					poisoned	= data.toUByte();
					rvalue		= true;
				}
				break;
			case 'R':
				if( tag.upper() == "RACE" )
				{
					race	= data.toUShort();
					rvalue	= true;
				}
				else if( tag.upper() == "REPUTATION" )
				{
					fame	= data.section( ",", 0, 0 ).stripWhiteSpace().toShort();
					karma	= data.section( ",", 1, 1 ).stripWhiteSpace().toShort();
					kills	= data.section( ",", 2, 2 ).stripWhiteSpace().toShort();
					rvalue	= true;
				}
				break;
			case 'S':
				if( tag.upper() == "STAMINA" )
				{
					stamina	= data.toShort();
					rvalue	= true;
				}
				else if( tag.upper() == "SPAWNERID" )
				{
					spawnserial = (cBaseObject *)data.toULong();
					rvalue		= true;
				}
				else if( tag.upper() == "SERIAL" )
				{
					serial = data.toULong();
					rvalue = true;
				}
				else if( tag.upper() == "STRENGTH" )
				{
					if( data.sectionCount( "," ) != 0 )
					{
						strength	= data.section( ",", 0, 0 ).stripWhiteSpace().toShort();
						st2			= data.section( ",", 1, 1 ).stripWhiteSpace().toShort();
					}
					else
						strength = data.toShort();
					rvalue = true;
				}
				else if( tag.upper() == "STRENGTH2" )
				{
					st2		= data.toShort();
					rvalue	= true;
				}
				else if( tag.upper() == "SCPTRIG" )
				{
					scriptTrig	= data.toUShort();
					rvalue		= true;
				}
				break;
			case 'T':
				if( tag.upper() == "TITLE" )
				{
					title = data.substr( 0, MAX_TITLE );
					rvalue = true;
				}
				else if( tag.upper() == "TAGNAME" )
				{
					staticTagName	= data;
					rvalue			= true;
				}
				else if( tag.upper() == "TAGVAL" )
				{
					SetTag( staticTagName, static_cast<jsval>(data.toULong() ) );
					rvalue = true;
				}
				else if( tag.upper() == "TAGVALS" )
				{
					JSString *tagvals	= JS_NewStringCopyZ( jsContext, data.c_str() );
					jsval tagvali		= STRING_TO_JSVAL(tagvals);
					SetTag( staticTagName, tagvali );
					rvalue = true;
				}
				break;
			case 'V':
				if( tag.upper() == "VISIBLE" )
				{
					visible	= data.toByte();
					rvalue	= true;
				}
				break;
			case 'W':
				if( tag.upper() == "WEIGHT" )
				{
					SetWeight( data.toLong() );
					rvalue = true;
				}
				else if( tag.upper() == "WORLDNUMBER" )
				{
					worldNumber = data.toUByte();
					rvalue		= true;
				}
				break;
			case 'X':
				if( tag.upper() == "XYZ" )
				{
					x		= data.section( ",", 0, 0 ).stripWhiteSpace().toShort();
					y		= data.section( ",", 1, 1 ).stripWhiteSpace().toShort();
					z		= data.section( ",", 2, 2 ).stripWhiteSpace().toByte();
					rvalue	= true;
				}
				break;
		}
	}
	else
		rvalue = true;
	return rvalue;
}

//o--------------------------------------------------------------------------
//|	Function		-	UI32 GetWord( UI08 wordNum )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns one of the generic words of the object
//|						There are 4 words.  wordNum must be between 0 and 3
//o--------------------------------------------------------------------------
UI32 cBaseObject::GetWord( UI08 wordNum ) const
{
	UI32 rvalue = 0;
	if( wordNum <= 3 )
		rvalue = genericDWords[wordNum];
	return rvalue;
}

//o--------------------------------------------------------------------------
//|	Function		-	bool GetBit( UI08 wordNum, UI08 bitNum )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns true if the bit bitNum in word wordNum is on
//o--------------------------------------------------------------------------
bool cBaseObject::GetBit( UI08 wordNum, UI08 bitNum ) const
{
	bool rvalue = false;
	if( wordNum <= 3 && bitNum <= 31 )
	{
		UI32 mask = power( 2, bitNum );
		rvalue = ( ( genericDWords[wordNum] & mask ) == mask );
	}
	return rvalue;
}

//o--------------------------------------------------------------------------
//|	Function		-	UI32 GetBitRange( UI08 wordNUm, UI08 lowBit, UI08 highBit )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the value of the bit range from lowBit to highBit
//|						in word wordNum.  Note that if lowBit is NOT 0, it's
//|						right shifted by lowBit bits.
//o--------------------------------------------------------------------------
UI32 cBaseObject::GetBitRange( UI08 wordNum, UI08 lowBit, UI08 highBit ) const
{
	UI32 rvalue = 0;
	if( wordNum <= 3 && lowBit <= 31 && highBit <= 31 )
	{
		UI32 mask = 0;
		for( UI08 i = lowBit; i <= highBit; ++i )
			mask |= power( 2, i );

		if( lowBit == 0 )
			rvalue = genericDWords[wordNum]&mask;
		else
			rvalue = (genericDWords[wordNum]&mask)>>lowBit;
	}
	return rvalue;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetWord( UI08 wordNum, UI32 value )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets word wordNum to value.  wordNum must be 0->3
//o--------------------------------------------------------------------------
void cBaseObject::SetWord( UI08 wordNum, UI32 value )
{
	if( wordNum <= 3 )
		genericDWords[wordNum] = value;
}

//o--------------------------------------------------------------------------
//|	Function		-	SetBit( UI08 wordNum, UI08 bitNum, bool value )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Turns on (value==true) or off (value==false) bit bitNum
//|						in word wordNum
//o--------------------------------------------------------------------------
void cBaseObject::SetBit( UI08 wordNum, UI08 bitNum, bool value )
{
	if( wordNum <= 3 && bitNum <= 31 )
	{
		UI32 mask = power( 2, bitNum );
		if( value )
			genericDWords[wordNum]	|= mask;
		else
		{
			UI32 flagMask			= 0xFFFFFFFF;
			flagMask				^= mask;
			genericDWords[wordNum]	&= flagMask;
		}
	}
}

//o--------------------------------------------------------------------------
//|	Function		-	SetBitRange( UI08 wordNum, UI08 lowBit, UI08 highBit, UI32 value )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the range of lowBit to highBit to value in word 
//|						wordNum.  Note it does no range checking to ensure
//|						that value will fit in that bit range
//o--------------------------------------------------------------------------
void cBaseObject::SetBitRange( UI08 wordNum, UI08 lowBit, UI08 highBit, UI32 value )
{
	if( wordNum <= 3 && lowBit <= 31 && highBit <= 31 )
	{
		UI32 mask = 0xFFFFFFFF;	// start with every bit set
		for( UI08 i = lowBit; i <= highBit; ++i )
			mask -= power( 2, i );	// subtract off the bit

		genericDWords[wordNum] &= mask;	// reset the words

		if( lowBit == 0 )
			genericDWords[wordNum] += value;
		else
			genericDWords[wordNum] |= ( value<<lowBit );	// shift the information along lowBit # of bits, so it's in the right spot
	}
}

//o--------------------------------------------------------------------------
//|	Function		-	PostLoadProcessing( UI32 index )
//|	Date			-	Unknown
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Used to setup any pointers that may need adjustment
//|						following the loading of the world
//o--------------------------------------------------------------------------
void cBaseObject::PostLoadProcessing( UI32 index )
{
	SERIAL tmpSerial = INVALIDSERIAL;
	if( multis != NULL )
	{
		tmpSerial = (SERIAL)multis;
		multis = NULL;
		SetMulti( tmpSerial, false );
	}
	if( spawnserial != NULL )
	{
		tmpSerial = (SERIAL)spawnserial;
		spawnserial = NULL;
		SetSpawn( (SERIAL)tmpSerial );
	}
	if( owner != NULL )
	{
		tmpSerial = (SERIAL)owner;
		owner = NULL;
		SetOwner( (SERIAL)tmpSerial );
	}
}

//o--------------------------------------------------------------------------
//|	Function		-	UI08 WorldNumber( void )
//|	Date			-	26th September, 2001
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns the world number that the object belongs in
//o--------------------------------------------------------------------------
UI08 cBaseObject::WorldNumber( void ) const
{
	return worldNumber;
}

//o--------------------------------------------------------------------------
//|	Function		-	WorldNumber( UI08 value )
//|	Date			-	26th September, 2001
//|	Programmer		-	Abaddon
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets the world number that the object belongs in
//o--------------------------------------------------------------------------
void cBaseObject::WorldNumber( UI08 value )
{
//	MapRegion->Remove( this );
	worldNumber = value;
//	MapRegion->Add( this );
}

//o--------------------------------------------------------------------------
//|	Function		-	bool ShouldSave( void )
//|	Date			-	21st December, 2001
//|	Programmer		-	Abaddon for Thyme
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Returns true if the object should be saved out to disk
//o--------------------------------------------------------------------------
bool cBaseObject::ShouldSave( void ) const
{
	return shouldSave;
}

//o--------------------------------------------------------------------------
//|	Function		-	void ShouldSave( bool value )
//|	Date			-	21st December, 2001
//|	Programmer		-	Abaddon for Thyme
//|	Modified		-
//o--------------------------------------------------------------------------
//|	Purpose			-	Sets whether the object should be saved out to disk
//o--------------------------------------------------------------------------
void cBaseObject::ShouldSave( bool value )
{
	shouldSave = value;
}


UI08 cBaseObject::GetPoisoned( void )
{
	return poisoned;
}

void cBaseObject::SetPoisoned( UI08 newValue )
{
	poisoned = newValue;
}

//o---------------------------------------------------------------------------o
//|   Function    -  SI16 Carve()
//|   Date        -  Unknown
//|   Programmer  -  Abaddon
//o---------------------------------------------------------------------------o
//|   Purpose     -  Characters carve value for carve.dfn
//o---------------------------------------------------------------------------o
SI16 cBaseObject::GetCarve( void ) const
{
	return carve;
}
void cBaseObject::SetCarve( SI16 newValue )
{
	carve = newValue;
}
