// HTML Template

// Code added to update when shutting down  -avtotar (16/09/02) 
// Slight modification on avotars fix (19/09/02)

#include "uox3.h"
#include "cHTMLSystem.h"
#include "cVersionClass.h"
#include "cGuild.h"
#include "townregion.h"
#include "cRaces.h"
#include "cServerDefinitions.h"
#include "ssection.h"
#include "gump.h"
#include "scriptc.h"
#include "packets.h"

cHTMLTemplate::cHTMLTemplate()
{
	for( int i = ETT_ONLINE; i < ETT_INVALIDTEMPLATE; ++i )
	{
		Name			= "";
		Loaded			= false;
		ScheduledUpdate = 0;
		Type			= 0xFF;
		UpdateTimer		= 0;
		//InputFile="";
		//OutputFile="";
		//Content="";
	}
}

cHTMLTemplate::~cHTMLTemplate()
{

}

//o--------------------------------------------------------------------------o
//|	Function		-	void cHTMLTemplate::Process( void )
//|	Date			-	1/18/2003 4:43:17 AM
//|	Developers		-	DarkStorm / EviLDeD
//|	Organization	-	UOX3 DevTeam
//|	Status			-	Currently under development
//o--------------------------------------------------------------------------o
//|	Description		-	
//|									
//|	Modification	-	08062003 - EviLDeD - For the record this is some of the 
//|									most fucked up shit I	have EVER SEEN!! Written to truely
//|									handle multiple Templates.
//o--------------------------------------------------------------------------o
//| Modifications	-	
//o--------------------------------------------------------------------------o
void cHTMLTemplate::Process( int nTemplateID )
{
	// Only read the Status Page if it's not already loaded
	if( !Loaded )
		LoadTemplate();

	// Parse the Content...
	std::string ParsedContent = Content;

	//***************************************/
	// Replacing Placeholders
	//***************************************/

	size_t Pos;

	// Account-Count
	UString AccountCount	= UString::number( Accounts->size() );
	Pos						= ParsedContent.find( "%accounts" ); 
	while( Pos != std::string::npos )
	{
		ParsedContent.replace( Pos, 9, AccountCount );
		Pos = ParsedContent.find( "%accounts" );
	}

	// Version
	std::string Version = cVersionClass::GetVersion();
	Version += "(";
	Version += cVersionClass::GetBuild();
	Version += ")";
	Version += " [";
	Version += OS_STR;
	Version += "]";

	Pos = ParsedContent.find( "%version" ); 
	while( Pos != std::string::npos )
	{
		ParsedContent.replace( Pos, 8, Version );
		Pos = ParsedContent.find( "%version" );
	}
	// Character Count
	UString CharacterCount	= UString::number( chars.Count() );
	Pos						= ParsedContent.find( "%charcount" ); 
	while( Pos != std::string::npos )
	{
		ParsedContent.replace( Pos, 10, CharacterCount );
		Pos = ParsedContent.find( "%charcount" );
	}

	// Item Count
	UString ItemCount	= UString::number( items.Count() );
	Pos					= ParsedContent.find( "%itemcount" );
	while( Pos != std::string::npos )
	{
		ParsedContent.replace( Pos, 10, ItemCount );
		Pos = ParsedContent.find( "%itemcount" );
	}

	// Connection Count (GMs, Counselors, Player)
	UI32 gm = 0, cns = 0, ccount = 0;

	// Get all Network Connections
	Network->PushConn();
	cSocket *tSock	= NULL;
	CChar *tChar	= NULL;
	for( tSock = Network->FirstSocket(); !Network->FinishedSockets(); tSock = Network->NextSocket() )
	{
		tChar = tSock->CurrcharObj();
		try
		{
			if( tChar == NULL )
				continue;

			if( tChar->IsGM() )
				++gm;
			else if( tChar->IsCounselor() )
				++cns;
			else
				++ccount;
		}
		catch( ... )
		{
			continue;
		}
	}
	Network->PopConn();

	// GMs
	UString GMCount = UString::number( gm );
	Pos				= ParsedContent.find( "%online_gms" );
	while( Pos != std::string::npos )
	{
		(cwmWorldState->GetKeepRun())?ParsedContent.replace( Pos, 11, GMCount ):ParsedContent.replace( Pos, 11, "0" );
		Pos = ParsedContent.find( "%online_gms" );
	}

	// Counselor
	UString CounsiCount	= UString::number( cns );
	Pos					= ParsedContent.find( "%online_couns" ); 
	while( Pos != std::string::npos )
	{
		(cwmWorldState->GetKeepRun())?ParsedContent.replace( Pos, 13, CounsiCount ):ParsedContent.replace( Pos, 13, "0");
		Pos = ParsedContent.find( "%online_couns" );
	}

	// Player
	UString PlayerCount	= UString::number( ccount );
	Pos					= ParsedContent.find( "%online_player" ); 
	while( Pos != std::string::npos )
	{
		(cwmWorldState->GetKeepRun())?ParsedContent.replace( Pos, 14, PlayerCount ):ParsedContent.replace( Pos, 14, "0" );
		Pos = ParsedContent.find( "%online_player" );
	}

	// Total
	UString AllCount	= UString::number( (ccount + gm + cns) );
	Pos					= ParsedContent.find( "%online_all" ); 
	while( Pos != std::string::npos )
	{
		(cwmWorldState->GetKeepRun())?ParsedContent.replace( Pos, 11, AllCount ):ParsedContent.replace( Pos, 11, "0" );
		Pos = ParsedContent.find( "%online_all" );
	}

	//RealTime( time_str )
	char time_str[80];
	RealTime( time_str );
	Pos = ParsedContent.find( "%time" ); 
	while( Pos != std::string::npos )
	{
		(cwmWorldState->GetKeepRun())?ParsedContent.replace( Pos, 5, time_str ):ParsedContent.replace( Pos, 5, "Down" );
		Pos = ParsedContent.find( "%time" );
	}

	// IP(s) + PORT(s)
	UI16 ServerCount = cwmWorldState->ServerData()->ServerCount();
	if( ServerCount > 0 )
	{
		for( UI16 i = 0; i < ServerCount; ++i )
		{
			physicalServer *mServ = cwmWorldState->ServerData()->ServerEntry( i );
			char ipToken[8]; // i think we'll never get higher than 2 digits, anyway...
			sprintf( ipToken, "%%ip%i", i+1 );

			if( mServ != NULL )
			{
				Pos = ParsedContent.find( ipToken ); 
				while( Pos != std::string::npos )
				{
					(cwmWorldState->GetKeepRun())?ParsedContent.replace( Pos, strlen(ipToken), mServ->getIP().c_str()):ParsedContent.replace( Pos, strlen(ipToken), "Down" );
					Pos = ParsedContent.find( ipToken );
				}
			}

			char portToken[10];	// i think we'll never get higher than 2 digits, anyway...
			sprintf( portToken, "%%port%i", i+1 );

			if( mServ != NULL )
			{
				Pos = ParsedContent.find( portToken ); 
				while( Pos != std::string::npos )
				{
					UString myPort = UString::number( mServ->getPort() );
					(cwmWorldState->GetKeepRun())?ParsedContent.replace( Pos, strlen( portToken ), myPort ):ParsedContent.replace( Pos, strlen( portToken ), "NA" );
					Pos = ParsedContent.find( portToken );
				}
			}
			char serverToken[10]; // i think we'll never get higher than 2 digits, anyway...
			sprintf( serverToken, "%%server%i", i+1 );

			if( mServ != NULL )
			{
				Pos = ParsedContent.find( serverToken );
				while( Pos != std::string::npos )
				{
					(cwmWorldState->GetKeepRun())?ParsedContent.replace( Pos, strlen( serverToken ), mServ->getName().c_str() ):ParsedContent.replace( Pos, strlen( serverToken ), "Down" );
					Pos = ParsedContent.find( serverToken );
				}
			}
		}
	}
	// PLAYERLIST
	Pos = ParsedContent.find( "%playerlist%" ); 
	while( Pos != std::string::npos )
	{
		size_t SecondPos		= ParsedContent.find( "%playerlist%", Pos+1 );
		if( SecondPos == std::string::npos )	// there's no closing part!
			break;
		std::string myInline	= ParsedContent.substr( Pos, SecondPos - Pos + 12 );
		std::string PlayerList;

		Network->PushConn();
		for( tSock = Network->FirstSocket(); !Network->FinishedSockets(); tSock = Network->NextSocket() )
		{
			try
			{
				if( tSock != NULL )
				{
					CChar *tChar = tSock->CurrcharObj();
					if( tChar != NULL )
					{
						std::string parsedInline = myInline;
						parsedInline.replace( 0, 12, "" );
						parsedInline.replace( parsedInline.length()-12, 12, "" );

						//					Tokens for the PlayerList
						//					%playername
						//					%playertitle
						//					%playerip
						//					%playeraccount
						//					%playerx
						//					%playery
						//					%playerz
						//					%playerrace
						//					%playerregion

						// PlayerName
						size_t sPos = parsedInline.find( "%playername" );
						while( sPos != std::string::npos )
						{
							(cwmWorldState->GetKeepRun())?parsedInline.replace( sPos, 11, tChar->GetName() ):parsedInline.replace( sPos, 11, "" );
							sPos = parsedInline.find( "%playername" );
						}

						// PlayerTitle
						sPos = parsedInline.find( "%playertitle" ); 
						while( sPos != std::string::npos )
						{
							(cwmWorldState->GetKeepRun())?parsedInline.replace( sPos, 12, tChar->GetTitle() ):parsedInline.replace( sPos, 12, "" );
							sPos = parsedInline.find( "%playertitle" );
						}

						// PlayerIP
						sPos = parsedInline.find( "%playerip" ); 
						while( sPos != std::string::npos )
						{
							cSocket *mySock = calcSocketObjFromChar( tChar );
							char ClientIP[32];
							sprintf( ClientIP, "%i.%i.%i.%i", mySock->ClientIP4(), mySock->ClientIP3(), mySock->ClientIP3(), mySock->ClientIP1() );
							(cwmWorldState->GetKeepRun())?parsedInline.replace( sPos, 9, ClientIP ):parsedInline.replace( sPos, 9, "" );
							sPos = parsedInline.find( "%playerip" );
						}

						// PlayerAccount
						sPos = parsedInline.find( "%playeraccount" ); 
						while( sPos != std::string::npos )
						{
							ACCOUNTSBLOCK toScan = tChar->GetAccount();
							if( toScan.wAccountIndex != AB_INVALID_ID )
								(cwmWorldState->GetKeepRun())?parsedInline.replace( sPos, 14, toScan.sUsername):parsedInline.replace( sPos, 14, "" );
							sPos = parsedInline.find( "%playeraccount" );
						}

						// PlayerX
						sPos = parsedInline.find( "%playerx" ); 
						while( sPos != std::string::npos )
						{
							UString myX = UString::number( tChar->GetX() );
							(cwmWorldState->GetKeepRun())?parsedInline.replace( sPos, 8, myX ):parsedInline.replace( sPos, 8, "" );
							sPos = parsedInline.find( "%playerx" );
						}

						// PlayerY
						sPos = parsedInline.find( "%playery" ); 
						while( sPos != std::string::npos )
						{
							UString myY = UString::number( tChar->GetY() );
							(cwmWorldState->GetKeepRun())?parsedInline.replace( sPos, 8, myY ):parsedInline.replace( sPos, 8, myY );
							sPos = parsedInline.find( "%playery" );
						}

						// PlayerZ
						sPos = parsedInline.find( "%playerz" );
						while( sPos != std::string::npos )
						{
							UString myZ = UString::number( tChar->GetZ() );
							(cwmWorldState->GetKeepRun())?parsedInline.replace( sPos, 8, myZ ):parsedInline.replace( sPos, 8, "" );
							sPos = parsedInline.find( "%playerz" );
						}

						// PlayerRace -- needs testing
						sPos = parsedInline.find( "%playerrace" );
						while( sPos != std::string::npos )
						{
							RACEID myRace			= tChar->GetRace();
							const std::string rName	= Races->Name( myRace );
							size_t raceLenName		= rName.length();

							if( raceLenName > 0 ) 
								(cwmWorldState->GetKeepRun())?parsedInline.replace( sPos, 11, rName ):parsedInline.replace( sPos, 11, "");
							sPos = parsedInline.find( "%playerrace" );
						}

						// PlayerRegion
						sPos = parsedInline.find( "%playerregion" );
						while( sPos != std::string::npos )
						{
							(cwmWorldState->GetKeepRun())?parsedInline.replace( sPos, 13, region[tChar->GetRegion()]->GetName() ):parsedInline.replace( sPos, 13, "");
							sPos = parsedInline.find( "%playerregion" );
						}

						PlayerList += parsedInline;
					}
				}
			}
			catch( ... )
			{
				Console << "| EXCEPTION: Invalid character/socket pointer found. Ignored." << myendl;
			}
		}
		Network->PopConn();

		(cwmWorldState->GetKeepRun())?ParsedContent.replace( Pos, myInline.length(), PlayerList ):ParsedContent.replace( Pos, myInline.length(), "");
		Pos = ParsedContent.find( "%playerlist%" );
	}

	// GuildCount
	UString GuildCount	= UString::number( GuildSys->NumGuilds() );
	Pos					= ParsedContent.find( "%guildcount" );
	while( Pos != std::string::npos )
	{
		(cwmWorldState->GetKeepRun())?ParsedContent.replace( Pos, 11, PlayerCount ):ParsedContent.replace( Pos, 11, "" );
		Pos = ParsedContent.find( "%guildcount" );
	}

	// GUILDLIST
	Pos = ParsedContent.find( "%guildlist%" );
	while( Pos != std::string::npos )
	{
		size_t SecondPos		= ParsedContent.find( "%guildlist%", Pos+1 );
		if( SecondPos == std::string::npos )	// can't find closing
			break;
		std::string myInline	= ParsedContent.substr( Pos, SecondPos - Pos + 11 );
		std::string GuildList;

		for( SI16 i = 0; i < (SI16)GuildSys->NumGuilds(); ++i )
		{
			std::string parsedInline = myInline;
			parsedInline.replace( 0, 11, "" );
			parsedInline.replace( parsedInline.length()-11, 11, "" );

			//parsedInline += "Yeah it worked";

//			Tokens for the GuildList
//			%guildid
//			%guildname

			// GuildID
			size_t sPos;
			CGuild *myGuild = GuildSys->Guild( i );

			UString GuildID	= UString::number( i );
			sPos			= parsedInline.find( "%guildid" ); 
			while( sPos != std::string::npos )
			{
				(cwmWorldState->GetKeepRun())?parsedInline.replace( sPos, 8, GuildID ):parsedInline.replace( sPos, 8, "" );
				sPos = parsedInline.find( "%guildid" );
			}

			// GuildName
			sPos = parsedInline.find( "%guildname" ); 
			while( sPos != std::string::npos )
			{
				(cwmWorldState->GetKeepRun())?parsedInline.replace( sPos, 10, myGuild->Name() ):parsedInline.replace( sPos, 10, "" );
				sPos = parsedInline.find( "%guildname" );
			}

			GuildList += parsedInline;
		}

		(cwmWorldState->GetKeepRun())?ParsedContent.replace( Pos, myInline.length(), GuildList ):ParsedContent.replace( Pos, myInline.length(), "" );
		Pos = ParsedContent.find( "%guildlist%" );
	}

	//NPCCount
	UI32 npccount = 0;

	if( npccount == 0 )
	{
		for( UI32 a = 0; a < chars.Count(); ++a )
		{
			if( chars[a].isFree() )
				continue;
			if( chars[a].IsNpc() )
				++npccount;
		}
	}

	UString npcs	= UString::number( npccount );
	Pos				= ParsedContent.find( "%npcs" ); 
	while( Pos != std::string::npos )
	{
		(cwmWorldState->GetKeepRun())?ParsedContent.replace( Pos, 5, npcs ):ParsedContent.replace( Pos, 5, "0" );
		Pos = ParsedContent.find( "%npcs" );
	}

	// Performance Dump
	R64 eps	= 0.00000000001;
	Pos		= ParsedContent.find( "%performance" ); 
	while( Pos != std::string::npos )
	{
		std::string performance;
		std::ostringstream myStream( performance );
		if( cwmWorldState->GetKeepRun() )
		{
			myStream << "Network code: " << (R32)((R32)networkTime/(R32)networkTimeCount) << "msec [" << networkTimeCount << " samples] <BR>";
			myStream << "Timer code: " << (R32)((R32)timerTime/(R32)timerTimeCount) << "msec [" << timerTimeCount << " samples] <BR>";
			myStream << "Auto code: " << (R32)((R32)autoTime/(R32)autoTimeCount) << "msec [" << autoTimeCount << " samples] <BR>";
			myStream << "Loop Time: " << (R32)((R32)loopTime/(R32)loopTimeCount) << "msec [" << loopTimeCount << " samples] <BR>";
			if( !( loopTime < eps ||  loopTimeCount < eps ) )
				myStream << "Simulation Cycles: " << (1000.0*(1.0/(R32)((R32)loopTime/(R32)loopTimeCount))) << " per sec <BR>";
			else
				myStream << "Simulation Cycles: Greater than 10000 <BR> ";
		}
		else
		{
			myStream << "Network code: 0" << "<BR>";
			myStream << "Timer code: 0" << "<BR>";
			myStream << "Auto code: 0" << "<BR>";
			myStream << "Loop Time: 0" << "<BR>";
			myStream << "Simulation Cycles: 0<BR>";
		}
		ParsedContent.replace( Pos, 12, myStream.str() );
		Pos = ParsedContent.find( "%performance" );
	}

	// Uptime
	Pos = ParsedContent.find( "%uptime" );
	while( Pos != std::string::npos )
	{
		UI32 total	= (cwmWorldState->GetUICurrentTime() - cwmWorldState->GetStartTime() ) / 1000;
		UI32 ho		= total / 3600;
		total		-= ho * 3600;
		UI32 mi		= total / 60;
		total		-= mi * 60;
		UI32 se		= total;
		total		= 0;
		UString builtString = "";
		if( ho < 10 )
			builtString += "0";
		builtString += UString::number( ho ) + ":";
		if( mi < 10 )
			builtString += "0";
		builtString += UString::number( mi ) + ":";
		if( se < 10 )
			builtString += "0";
		builtString += UString::number( se );
		ParsedContent.replace( Pos, 7, builtString );
		Pos = ParsedContent.find( "%uptime" );
	}

	// Simulation Cycles (whatever that may be...)
	Pos = ParsedContent.find( "%simcycles" );
	while( Pos != std::string::npos )
	{
		std::string simcycles;
		std::ostringstream myStream( simcycles );

		if( cwmWorldState->GetKeepRun() )
		{
			if( !( loopTime < eps ||  loopTimeCount < eps ) )
				myStream << "Simulation Cycles: " << (1000.0*(1.0/(R32)((R32)loopTime/(R32)loopTimeCount))) << " per sec <BR>";
			else
				myStream << "Simulation Cycles: Greater than 10000 <BR> ";
		}
		else
		{
			myStream << "Simulation Cycles: 0<BR> ";
		}
		ParsedContent.replace( Pos, 10, myStream.str() );
		Pos = ParsedContent.find( "%simcycles" );
	}

	// Update Time in SECONDS
	Pos = ParsedContent.find( "%updatetime" ); 
	while( Pos != std::string::npos )
	{
		UString strUpdateTimer = UString::number( UpdateTimer );
		(cwmWorldState->GetKeepRun())?ParsedContent.replace( Pos, 11, strUpdateTimer ):ParsedContent.replace( Pos, 11, "0" );
		Pos = ParsedContent.find( "%updatetime" );
	}

	//***************************************/
	// End Replacing Placeholders
	//***************************************/	

	// Print the Content out to the new file...
	std::ofstream Output( OutputFile );
	if( !Output.is_open() )
	{
		Console.Error( 1, " Couldn't open the template file %s for writing", OutputFile );
		return;
	}
	Output << ParsedContent;
	Output.close();
}

//o---------------------------------------------------------------------------o
//|	Function	-	cHTMLTemplate::Poll
//|	Programmer	-	Dark-Storm
//o---------------------------------------------------------------------------o
//|	Purpose		-	Updates the page if needed
//o---------------------------------------------------------------------------o
void cHTMLTemplate::Poll( int nTemplateID )
{
	if( nTemplateID > ETT_ALLTEMPLATES || ( ScheduledUpdate < cwmWorldState->GetUICurrentTime() ) )
	{
		Process( nTemplateID );
		ScheduledUpdate = BuildTimeValue( (R32)UpdateTimer );
		return;
	}
	else
	{
		// nTemplateID come in as EET_ALLTEMPLATES
		for( int i = 1; i < ETT_INVALIDTEMPLATE; ++i )
		{
			if( i!=ETT_OFFLINE )
			{
				Process( i );
				ScheduledUpdate = BuildTimeValue( (R32)UpdateTimer );
			}
		}
	}
}

//o---------------------------------------------------------------------------o
//|	Function	-	cHTMLTemplate::LoadTemplate
//|	Programmer	-	Dark-Storm
//|
//|	Modification	-	08062003 - Updated this member function to actually handle
//|									loading the different templates for use later.
//o---------------------------------------------------------------------------o
//|	Purpose		-	Loads the Template into memory
//o---------------------------------------------------------------------------o
void cHTMLTemplate::LoadTemplate( void )
{
	Content = "";

	std::ifstream InputFile1( InputFile );

	if( !InputFile1.is_open() )
	{
		Console.Error( 1, "Couldn't open HTML Template File %s", InputFile );
		return;
	}

	while( !InputFile1.eof() && !InputFile1.fail() )
	{
		std::string Line;
		std::getline( InputFile1, Line );
		Content += Line;
	}

	InputFile1.close();

	Loaded = true;
}

//o---------------------------------------------------------------------------o
//|	Function	-	cHTMLTemplate::UnloadTemplate
//|	Programmer	-	Dark-Storm
//o---------------------------------------------------------------------------o
//|	Purpose		-	Unloads the Template (i.e. for reloading)
//|									
//|	Modification	-	08062003 - EviLDeD - Updated to properly unload a template
//|									and to unload the correect template, instead of just the
//|									status template.
//o---------------------------------------------------------------------------o
void cHTMLTemplate::UnloadTemplate( int nTemplateID )
{
	Content="";
	Loaded = false;
}

//o---------------------------------------------------------------------------o
//|	Function	-	cHTMLTemplate::Load
//|	Programmer	-	Dark-Storm
//o---------------------------------------------------------------------------o
//|	Purpose		-	Loads the HTML Template from a ScriptSection
//o---------------------------------------------------------------------------o
void cHTMLTemplate::Load( ScriptSection *found )
{

	UString tag;
	UString data;

	for( tag = found->First(); !found->AtEnd(); tag = found->Next() )
	{
		data = found->GrabData();

		if( tag.upper() == "UPDATE" )
			UpdateTimer = data.toULong();
		else if( tag.upper() == "TYPE" )
		{
			if( data.upper() == "STATUS" )
				Type = ETT_ONLINE;
			else if( data.upper() == "OFFLINE" )
				Type = ETT_OFFLINE;
			else if( data.upper() == "PLAYER" )
				Type = ETT_PLAYER;
			else if( data.upper() == "GUILD" )
				Type = ETT_GUILD;
			else if( data.upper() == "GMSTATUS" )
				Type = ETT_GMSTATUS;
		}
		else if( tag.upper() == "INPUT" )
			sprintf( InputFile, "%s", data.c_str() );
		else if( tag.upper() == "OUTPUT" )
			sprintf( OutputFile, "%s", data.c_str() );
		else if( tag.upper() == "NAME" )
			Name = data;
	}

	ScheduledUpdate = 0;
	//Type[nTemplateID] = nTemplateID;
	Loaded = false;
}

cHTMLTemplates::cHTMLTemplates()
{
}

cHTMLTemplates::~cHTMLTemplates()
{
}

//o---------------------------------------------------------------------------o
//|	Function	-	cHTMLTemplates::Load
//|	Programmer	-	Dark-Storm
//o---------------------------------------------------------------------------o
//|	Purpose		-	Loads the HTML Templates from the scripts
//o---------------------------------------------------------------------------o
void cHTMLTemplates::Load( int nTemplateID )
{
	VECSCRIPTLIST *toWalk = FileLookup->GetFiles( html_def );
	if( toWalk == NULL )
		return;

	for( UI32 i = 0; i < toWalk->size(); ++i )
	{
		if( (*toWalk)[i] != NULL )
		{
			Script *toCheck = (*toWalk)[i];
			if( toWalk == NULL )
				continue;

			size_t NumEntries = toCheck->NumEntries();
			if( NumEntries == 0 )
				continue;

			for( ScriptSection *found = toCheck->FirstEntry(); found != NULL; found = toCheck->NextEntry() )
			{
				cHTMLTemplate *Template = new cHTMLTemplate();
				Template->Load( found );
				Templates.push_back( Template );
			}
		}
	}
	for( size_t j = Templates.size(); j < ETT_INVALIDTEMPLATE; ++j )
		Templates.push_back( NULL );
}

//o---------------------------------------------------------------------------o
//|	Function	-	cHTMLTemplates::Unload
//|	Programmer	-	Dark-Storm
//o---------------------------------------------------------------------------o
//|	Purpose		-	Unloads all Templates
//o---------------------------------------------------------------------------o
void cHTMLTemplates::Unload( int nTemplateID )
{
	if( Templates.size() < 1 )
		return;

	for( UI32 i = 0; i < Templates.size(); ++i )
	{
		delete( Templates[ i ] );
	}

	Templates.clear();
}

//o---------------------------------------------------------------------------o
//|	Function	-	cHTMLTemplates::Poll
//|	Programmer	-	Dark-Storm
//o---------------------------------------------------------------------------o
//|	Purpose		-	Polls the templates for updates
//o---------------------------------------------------------------------------o
void cHTMLTemplates::Poll( int nTemplateID )
{

	if( Templates.size() < 0 || nTemplateID == -1 )
	{
		// Then we want to poll every template
		for( UI08 i = 0; i < ETT_INVALIDTEMPLATE; ++i )
		{
			if( Templates[ i ] != NULL )
				Templates[ i ]->Poll( nTemplateID );
		}
		return;
	}

	if( Templates[ nTemplateID ] != NULL )
		Templates[ nTemplateID ]->Poll(nTemplateID );

	//for( UI32 i = 0; i < Templates.size(); ++i )
	//{
	//	if( Templates[ i ]->GetTemplateType(nTemplateID) != TemplateType )
	//		continue;

	//	if( Templates[ i ] != NULL )
	//		Templates[ i ]->Poll(nTemplateID);
	//}
}

//o---------------------------------------------------------------------------o
//|	Function	-	cHTMLTemplates::TemplateInfoGump
//|	Programmer	-	Dark-Storm
//o---------------------------------------------------------------------------o
//|	Purpose		-	Shows an information gump about current templates
//o---------------------------------------------------------------------------o
void cHTMLTemplates::TemplateInfoGump( cSocket *mySocket )
{
	CGump InfoGump = CGump( false, false );

	InfoGump.SetSerial( 1 ); // Serial for the HTML Status Callback

	InfoGump.StartPage();
	// Add an exit button
	InfoGump.AddButton( 40, 300, cwmWorldState->ServerData()->ButtonCancel(), static_cast<UI16>( cwmWorldState->ServerData()->ButtonCancel() + 1 ), 1, 0, 0 );

	InfoGump.AddBackground( 0, 0, cwmWorldState->ServerData()->BackgroundPic(), 350, 350 );

	// 10 Max Templates per page
	UI32 Entries = 0; // Entries per page
	UI32 CurrentPage = 0; // Page

	for( UI32 i = 0; i < Templates.size(); ++i )
	{
		if( Entries == 0 )
		{
			// We should add a next button if we're not starting the first page
			if( CurrentPage != 0 )
				InfoGump.AddButton( 300, 250, cwmWorldState->ServerData()->ButtonRight(), static_cast<UI16>( cwmWorldState->ServerData()->ButtonRight() + 1 ), 0, static_cast<UI16>( CurrentPage + 1 ), 0 );

			CurrentPage = InfoGump.StartPage();
		}

		// If we're not on the first page add the "back" button
		if( CurrentPage > 1 )
			InfoGump.AddButton( 30, 250, cwmWorldState->ServerData()->ButtonLeft(), static_cast<UI16>( cwmWorldState->ServerData()->ButtonLeft() + 1 ), 0, static_cast<UI16>( CurrentPage - 1 ), 0 );

		++Entries;

		// ~25 pixel per entry
		char tmpName[256];
		sprintf( tmpName, "%s (%i)", Templates[ i ]->GetName(i).c_str(), i );

		InfoGump.AddText( 40, static_cast<UI16>( 40 + (Entries-1)*25 ), cwmWorldState->ServerData()->LeftTextColour(), tmpName );

		if( Entries == 5 )
			Entries = 0;
	}

	InfoGump.Send( mySocket );
}

//o---------------------------------------------------------------------------o
//|	Function	-	cHTMLTemplates::GetName
//|	Programmer	-	Dark-Storm
//o---------------------------------------------------------------------------o
//|	Purpose		-	Returns the name of the Template
//o---------------------------------------------------------------------------o
std::string cHTMLTemplate::GetName( int nTemplateID )
{
	return Name; 
}

//o---------------------------------------------------------------------------o
//|	Function	-	cHTMLTemplates::GetOutput
//|	Programmer	-	Dark-Storm
//o---------------------------------------------------------------------------o
//|	Purpose		-	Gets the Output Filename
//o---------------------------------------------------------------------------o
std::string cHTMLTemplate::GetOutput( int nTemplateID )
{
	return OutputFile; 
}

//o---------------------------------------------------------------------------o
//|	Function	-	cHTMLTemplates::GetInput
//|	Programmer	-	Dark-Storm
//o---------------------------------------------------------------------------o
//|	Purpose		-	Gets the Input Filename
//o---------------------------------------------------------------------------o
std::string cHTMLTemplate::GetInput( int nTemplateID )
{
	return InputFile;
}

//o---------------------------------------------------------------------------o
//|	Function	-	cHTMLTemplates::TemplateInfoGump
//|	Programmer	-	Dark-Storm
//o---------------------------------------------------------------------------o
//|	Purpose		-	Gets the next scheduled Update time
//o---------------------------------------------------------------------------o
UI32 cHTMLTemplate::GetScheduledUpdate( int nTemplateID )
{
	return ScheduledUpdate; 
}

//o---------------------------------------------------------------------------o
//|	Function	-	cHTMLTemplates::GetUpdateTimer
//|	Programmer	-	Dark-Storm
//o---------------------------------------------------------------------------o
//|	Purpose		-	Gets the Update timer
//o---------------------------------------------------------------------------o
UI32 cHTMLTemplate::GetUpdateTimer( int nTemplateID )
{
	return UpdateTimer;
}

//o---------------------------------------------------------------------------o
//|	Function	-	cHTMLTemplate::GetTemplateType
//|	Programmer	-	Dark-Storm
//o---------------------------------------------------------------------------o
//|	Purpose		-	Gets the Template Type
//o---------------------------------------------------------------------------o
UI08 cHTMLTemplate::GetTemplateType( int nTemplateID )
{
	return Type;   
}

//o---------------------------------------------------------------------------o
//|	Function	-	cHTMLTemplates::Refresh
//|	Programmer	-	Dark-Storm
//o---------------------------------------------------------------------------o
//|	Purpose		-	Refreshs a single template
//o---------------------------------------------------------------------------o
bool cHTMLTemplates::Refresh( UI32 TemplateID )
{
	if( Templates.size() < 1 )
		return false;

	if( TemplateID >= Templates.size() )
		return false;

	if( Templates[ TemplateID ] == NULL )
		return false;

	Templates[ TemplateID ]->Poll( true );

	return true;
}

