// cHTMLSystem.h: Schnittstelle fr die Klasse cHTMLSystem.
//
//////////////////////////////////////////////////////////////////////

#ifndef __CHTMLSYSTEM_H__
#define __CHTMLSYSTEM_H__

#if defined(_MSC_VER)
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif

enum ETemplateType
{
	ETT_ALLTEMPLATES = -1,
	ETT_GMSTATUS =0 ,
	ETT_GUILD,
	ETT_OFFLINE,
	ETT_PLAYER,
	ETT_ONLINE,
	ETT_INVALIDTEMPLATE
};

class cHTMLTemplate
{
protected:
	UI32	UpdateTimer;
	char	InputFile[MAX_PATH];
	bool	Loaded;
	UI08	Type;
	std::string	Content;
	char	OutputFile[MAX_PATH];
	std::string	Name;
	UI32	ScheduledUpdate;

public:
	cHTMLTemplate();
	virtual ~cHTMLTemplate();
	void Process( int nTemplateID );
	void Poll( int nTemplateID = 0 );
	void LoadTemplate( void );
	void UnloadTemplate( int nTemplateID );
	void Load( ScriptSection *found );

	// Some Getters
	std::string	GetName( int nTemplateID );
	std::string	GetOutput( int nTemplateID );
	std::string	GetInput( int nTemplateID );
	UI08	GetTemplateType( int nTemplateID );	
	UI32	GetScheduledUpdate( int nTemplateID );
	UI32	GetUpdateTimer( int nTemplateID );
};

class cHTMLTemplates
{
protected:
	std::vector < cHTMLTemplate* > Templates;

public:
	cHTMLTemplates();
	virtual ~cHTMLTemplates();

	void Load( int nTemplateID );
	void Unload( int nTemplateID );
	void Poll( int nTemplateID );
	bool Refresh( UI32 TemplateID );
	void TemplateInfoGump( cSocket *mySocket );
};

#endif
