#ifndef __CITEM_H__
#define __CITEM_H__

class CItem : public cBaseObject
{
private:
	cBaseObject	*	contObj;
	UI32			more;
	UI32			moreb;

	UI08			bools;

	char			name2[MAX_NAME];
	SERIAL			creator;	// Store the serial of the player made this item
	char			desc[100];

	UI08			layer; // Layer if equipped on paperdoll

	UI08			type; // For things that do special things on doubleclicking
	UI08			type2;

	SI08			offspell;

	UI32			morex;
	UI32			morey;
	UI32			morez;

	UI16			amount; // Amount of items in pile

	UI08			doordir; // Reserved for doors

	SI16			maxhp; // Max number of hit points an item can have.

	UI08			spd; //The speed of the weapon

	SI08			movable; // 0=Default as stored in client, 1=Always movable, 2=Never movable, 3=Owner movable.

	TIMERVAL		gatetime;
	TIMERVAL		decaytime;
	TIMERVAL		murdertime; //AntiChrist -- for corpse -- when the people has been killed	// used to be long, don't need THAT long

	UI08			priv; // Bit 0, decay off/on.  Bit 1, newbie item off/on.  Bit 2 Dispellable
	SI32			buyValue;	// Price a shopkeep buys items for
	SI32			sellValue;	// Price a shopkeep sells items for.
	UI16			restock; // Number up to which shopkeeper should restock this item
	ARMORCLASS		armorClass;
	SI08			rank;	// Magius(CHE) --- for rank system, this value is the LEVEL of the item from 1 to 10.  Simply multiply t he rank*10 and calculate the MALUS this item has from the original.
									// for example: RANK 5 --> 5*10 = 50% of malus
									// this item has same values decreased by 50%..
									// RANK 1 --> 1*10=10% this item has 90% of malus!
									// RANK 10 --> 10*10 = 100% this item has no malus! RANK 10 is automatically setted if you select RANKSYSTEM 0.
									// Vars: LODAMAGE, HIDAMAGE, ATT, DEF, HP, MAXHP
	SI16			good; // Store type of GOODs to trade system! (Plz not set as UNSIGNED) --- Magius(CHE)
	SI32			rndvaluerate; // Store the value calculated base on RANDOMVALUE in region.scp. ---- MAgius(CHE) (2)
	SI08			madewith; // Store the skills used to make this item -- Magius(CHE)
	SERIAL			glow;	// LB identifies glowing objects
	COLOUR			glowColour;
	UI08			glow_effect;

	ITEMLIST		Contains;
	bool			remove;

	UI08			weatherBools;	// For elemental weaponry.  So a Heat weapon would be a fire weapon, and does elemental damage to Heat weak races

	void			RemoveSelfFromCont( void );
	void			RemoveSelfFromOwner( void );
	void			AddSelfToOwner( void );

	UI16			entryMadeFrom;

public:

	UI16			EntryMadeFrom( void ) const;
	void			EntryMadeFrom( UI16 newValue );

	bool			GetWeatherDamage( WeatherType effectNum ) const;
	void			SetWeatherDamage( WeatherType effectNum, bool value );

	virtual CItem *	Dupe( void );

	virtual bool	FinishedItems( void ) const;
	virtual CItem *	FirstItem( void ) const;
	virtual CItem *	NextItem( void ) const;

	cBaseObject *	GetCont(   void ) const;
	SERIAL			GetContSerial( void ) const;
	UI32			GetMore(   void ) const;
	UI32			GetMoreB(  void ) const;
	UI08			GetCont(   UI08 part ) const; 
	UI08			GetMore(   UI08 part ) const;
	UI08			GetMoreB(  UI08 part ) const;

	virtual void	SetOwner(  cBaseObject *newValue );
	virtual void	SetSpawn(  SERIAL newValue, ITEM index );
	virtual void	SetSerial( SERIAL newValue, ITEM n );

	bool			SetCont(   cBaseObject *newCont );
	bool			SetContSerial( SERIAL newSerial );
	void			SetMore(   UI32 newValue );
	void			SetMoreB(  UI32 newValue );
	void			SetMore(   UI08 newValue, UI08 part );
	void			SetMoreB(  UI08 newValue, UI08 part );
	void			SetMore(   UI08 part1, UI08 part2, UI08 part3, UI08 part4 );
	void			SetMoreB(  UI08 part1, UI08 part2, UI08 part3, UI08 part4 );
	virtual void	SetGuarded( bool newValue );

	virtual bool	isFree( void ) const;
	bool			isDoorOpen( void ) const;
	bool			isPileable( void ) const;
	bool			isDyeable( void ) const;
	bool			isCorpse( void ) const;
	bool			isWipeable( void ) const;
	bool			isGuarded( void ) const;
	bool			isSpawnerList( void ) const;

	bool			isNewbie( void ) const;
	bool			isDecayable( void ) const;
	bool			isDispellable( void ) const;

	void			SetNewbie( bool newValue );
	void			SetDecayable( bool newValue );
	void			SetDispellable( bool newValue );

	virtual void	SetFree( bool newValue );
	void			SetDoorOpen( bool newValue );
	void			SetPileable( bool newValue );
	void			SetDye( bool newValue );
	void			SetCorpse( bool newValue );
	void			SetWipeable( bool newValue );
	void			SetSpawnerList( bool newValue );

	const char *	GetName2( void ) const;
	SERIAL			GetCreator( void ) const;
	const char *	GetDesc( void ) const;

	void			SetName2( const char *newValue );
	void			SetCreator( SERIAL newValue );
	void			SetDesc( const char *newValue );

	virtual void	SetLocation( const cBaseObject *toSet );
	virtual void	SetLocation( SI16 newX, SI16 newY, SI08 newZ );
	virtual void	SetLocation( SI16 newX, SI16 newY, SI08 newZ, UI08 world );
	void			IncX( SI16 newValue );
	void			IncY( SI16 newValue );
	void			IncZ( SI16 newValue );

	UI08			GetLayer( void ) const;
	void			SetLayer( UI08 newValue );

	UI08			GetType(  void ) const;
	UI08			GetType2( void ) const;

	void			SetType(  UI08 newValue );
	void			SetType2( UI08 newValue );

	SI08			GetOffSpell( void ) const;
	void			SetOffSpell( SI08 newValue );

	UI32			GetMoreX( void ) const;
	UI32			GetMoreY( void ) const;
	UI32			GetMoreZ( void ) const;

	void			SetMoreX( UI32 newValue );
	void			SetMoreY( UI32 newValue );
	void			SetMoreZ( UI32 newValue );

	UI16			GetAmount(  void ) const;
	void			SetAmount(  UI32 newValue );

	UI08			GetDoorDir( void ) const;
	void			SetDoorDir( UI08 neValue );

	void			IncDef( UI16 newValue );
	virtual SI16	GetMaxHP( void ) const;
	virtual void	SetMaxHP( SI16 newValue );

	virtual void	IncHP( SI16 newValue );
	virtual void	IncID( SI16 incAmount );

	UI08			GetSpeed( void ) const;
	void			SetSpeed( UI08 newValue );

	SI08			GetMovable( void ) const;
	void			SetMovable( SI08 newValue );
	
	TIMERVAL		GetGateTime(   void ) const;
	TIMERVAL		GetDecayTime(  void ) const;
	TIMERVAL		GetMurderTime( void ) const;

	void			SetGateTime(   TIMERVAL newValue );
	void			SetDecayTime(  TIMERVAL newValue );
	void			SetMurderTime( TIMERVAL newValue );

	virtual UI08	GetPriv( void ) const;
	virtual void	SetPriv( UI08 newValue );

	SI32			GetBuyValue( void ) const;
	void			SetBuyValue( SI32 newValue );
	SI32			GetSellValue( void ) const;
	void			SetSellValue( SI32 newValue );

	UI16			GetRestock( void ) const;
	void			SetRestock( UI16 newValue );

	virtual ARMORCLASS	GetArmourClass( void ) const;
	virtual void		SetArmourClass( ARMORCLASS newValue );

	SI08			GetRank( void ) const;
	void			SetRank( SI08 newValue );

	SI16			GetGood( void ) const;
	void			SetGood( SI16 newValue );

	SI32			GetRndValueRate( void ) const;
	void			SetRndValueRate( SI32 newValue );

	SI08			GetMadeWith( void ) const;
	void			SetMadeWith( SI08 newValue );

	// Note by Magius: Value range to -ALLSKILLS-1 to ALLSKILLS+1
	// To calculate skill used to made this item:
	// if is a positive value, substract 1 it.
	//    Ex) madewith = 34, 34 - 1 = 33, 33 = STEALING
	// if is a negative value, add 1 from it and invert value.
	//    Ex) madewith = -34, -34 + 1 = -33, Abs(-33) = 33 = STEALING.
	// 0 = NULL
	// So... a positive value is used when the item is made by a 
	// player with 95.0+ at that skill. Infact in this way when
	// you click on the item appear its name and the name of the
	// creator. A negative value if the play is not skilled
	// enough!

	SERIAL			GetGlow( void ) const;
	void			SetGlow( SERIAL newValue );

	COLOUR			GetGlowColour( void ) const;
	void			SetGlowColour( COLOUR newValue );

	UI08			GetGlowEffect( void ) const;
	void			SetGlowEffect( UI08 newValue );

					CItem( ITEM nItem, bool zeroSer );
	virtual			~CItem();

	bool			HoldItem( CItem *toHold );
	bool			ReleaseItem( CItem *index );
	size_t			NumItems( void ) const;
	CItem *			GetItemObj( ITEM index ) const;

	UI32			enhanced;
	bool			WillDecay( void ) const;

	UI08			IsFieldSpell( void ) const;
	bool			IsLockedDown( void ) const;
	bool			IsShieldType( void ) const;
	bool			IsMetalType( void ) const;
	bool			IsLeatherType( void ) const;
	bool			IsBowType( void ) const;
	bool			CanBeLockedDown( void ) const;
	void			LockDown( void );
	bool			IsContType( void ) const;

	void			itemTalk( cSocket *s, SI32 dictEntry, R32 secsFromNow = 0.0f, UI16 Colour = 0 );
	void			Refresh( cSocket *mSock = NULL );
	void			SendToSocket( cSocket *mSock );
	void			SendPackItemToSocket( cSocket *mSock );
	void			RemoveFromSight( void );

	virtual bool	Save( std::ofstream &outStream );
	virtual bool	DumpHeader( std::ofstream &outStream ) const;
	virtual bool	DumpBody( std::ofstream &outStream ) const;
	virtual bool	Load( std::ifstream &inStream, ITEM arrayOffset );
	virtual bool	HandleLine( UString &tag, UString &data );
	virtual bool	LoadRemnants( int arrayOffset );
	virtual void	PostLoadProcessing( UI32 index );
	void			CheckItemIntegrity( void );
	virtual void	Sort( void );
	void			Dirty( void ) const;
};

#endif

