#ifndef __COMBAT_H__
#define __COMBAT_H__

enum WeaponTypes
{
	DEF_SWORDS = 1,
	SLASH_SWORDS,
	ONEHND_LG_SWORDS,
	TWOHND_LG_SWORDS,
	BARDICHE,
	ONEHND_AXES,
	TWOHND_AXES,
	DEF_MACES,
	LG_MACES,
	BOWS,
	XBOWS,
	DEF_FENCING,
	TWOHND_FENCING,
};

class cCombat
{
private:
	void	DoAttack( CChar *cAttack, CChar *cDefend, UI16 playerDistance );
	void	DoNpcSpAttack( CChar *npcAttack, CChar *cDefend, UI16 playerDistance );
	void	CombatHit( CChar *attack, CChar *defend, SI32 weaponType = -1 );
	SI16	calcDamage( CChar *cAttack, CChar *cDefend, cSocket *dSock, CItem *weapon, UI08 getFightSkill );
	void	doSplit( CChar *toSplit );

	bool	StartAttack( CChar *cAttack, CChar *cTarget );

	bool	TimerOk( CChar *c );

//	void	ItemCastSpell( cSocket *s, CChar *c, CItem *i );
	void	ItemSpell( CChar *attacker, CChar *defender );
	bool	CastSpell( CChar *attack, CChar *defend, SI16 spellNum );

	bool	WillResultInCriminal( CChar *attack, CChar *targ );
	void	InvalidateAttacker( CChar *attack );
	void	AdjustRaceDamage( CChar *defend, CItem *weapon, SI16 &bDamage );
	SI08	DoHitMessage( CChar *defend, CChar *attack, cSocket *mSock, SI16 damage );

	void	doSoundEffect( CChar *p, CItem *weapon );
	void	doMissedSoundEffect( CChar *p );
	void	Kill( CChar *attack, CChar *defend );

	CItem *	getArmorDef( CChar *mChar, SI32 &totalDef, UI08 bodyLoc, bool findTotal = false );
	CItem *	checkDef( CItem *checkItem, CItem *currItem, SI32 &currDef );
public:
	void	petGuardAttack( CChar *mChar, CChar *owner, SERIAL guarded );
	void	PlayerAttack( cSocket *s );
	void	AttackTarget( CChar *cAttack, CChar *cTarget );

//	UI16	GetSwingRate( CChar *iNPC, CItem *weapon );
	UI08	getBowType( CChar *i );
	UI08	getWeaponType( CItem *i );
	UI08	getCombatSkill( CChar *i );
	CItem *	getWeapon( CChar *i );
	CItem *	getShield( CChar *i );

	SI16	calcAtt( CChar *p );
	UI16	calcDef( CChar *p, UI08 hitLoc, bool doDamage = false );

	void	CombatOnHorse( CChar *i );
	void	CombatOnFoot( CChar *i );
	void	CombatLoop( CChar *attack );

	void	SpawnGuard( CChar *mChar, CChar *targChar, SI16 x, SI16 y, SI08 z );
};

#endif

