#ifndef __COMMANDS_H__
#define __COMMANDS_H__

#include "cmdtable.h"

#define CMAX 40 // Maximum parameters in one line (Only for memory reasons)

class CPITalkRequest;

class cCommands
{
private:
	std::vector< commandLevel_st *> clearance;
	CmdTableIterator				cmdPointer;
	UI08							numArguments;			// Amount of arguments in a command
	char *							comm[CMAX];

	void			splitline( char *toSplit );
	void			InitClearance( void );
	void			CommandReset( void );
public:
	UI08			GetNumArguments( void );
	void			SetNumArguments( UI08 newVal );
	SI32			GetArgument( UI08 argNum );
	char *			GetComm( UI08 part );
	void			SetComm( UI08 part, char *value );

	commandLevel_st *GetClearance( const char *clearName );			// return by command name
	commandLevel_st *GetClearance( UI08 commandLevel );	// return by command level
	UI16			GetColourByLevel( UI08 commandLevel );
	void			showQue( cSocket *s, bool isGM );
	void			nextCall( cSocket *s, bool isGM );
	void			closeCall( cSocket *s, bool isGM );
	void			KillSpawn( cSocket *s, SI32 r );
	void			RegSpawnMax( cSocket *s, cSpawnRegion *spawnReg );
	void			RegSpawnNum( cSocket *s, cSpawnRegion *spawnReg, SI32 n );
	void			KillAll( cSocket *s, SI32 percent, const char * sysmsg );
	void			AddHere( cSocket *s, SI08 z );
	void			Wipe( cSocket *s );
	void			CPage( cSocket *s, const char * reason );
	void			GMPage( cSocket *s, const char * reason );
	void			MakePlace( cSocket *s, SI32 i );
	void			Command( CPITalkRequest *pckTalk );
	void			TCommand(cSocket *s, CChar *c, char* text) ;
	void			MakeShop( CChar *c );
	void			DyeTarget( cSocket *s );
	CItem *			DupeItem( cSocket *s, CItem *i, UI32 amount );
	void			Load( void );
	void			Log( std::string command, CChar *player1, CChar *player2, std::string extraInfo );

	bool			CommandExists( const char *cmdName );
	const char *	FirstCommand( void );
	const char *	NextCommand( void );
	bool			FinishedCommandList( void );

	cmdtable_mapentry *CommandDetails( const char *cmdName );

	cCommands();
};

#endif

