#include "uox3.h"
#include "gump.h"
#include "cGuild.h"
#include "townregion.h"
#include "cServerDefinitions.h"
#include "wholist.h"
#include "skills.h"
#include "cMagic.h"
#include "cVersionClass.h"
#include "ssection.h"
#include "trigger.h"
#include "cScript.h"
#include "cEffects.h"
#include "packets.h"
#include "regions.h"
#include "classes.h"

#undef DBGFILE
#define DBGFILE "gumps.cpp"

std::string GetStrFromSock( cSocket *sock, UI16 offset, UI16 length );
std::string GetUniStrFromSock( cSocket *sock, UI16 offset, UI16 length );

//o--------------------------------------------------------------------------o
//|	Function			-	void HandleAccountButton( cSocket *s, long button, CChar *j )
//|	Date					-	
//|	Developers		-	EviLDeD
//|	Organization	-	UOX3 DevTeam
//|	Status				-	Currently under development
//o--------------------------------------------------------------------------o
//|	Description		-	Handles the accounts gump button
//o--------------------------------------------------------------------------o
//| Modifications	-	
//o--------------------------------------------------------------------------o
void HandleAccountButton( cSocket *s, long button, CChar *j )
{
	if( j == NULL )
		return;
	CChar *mChar = s->CurrcharObj();
	ACCOUNTSBLOCK actbTemp;
	if( !Accounts->GetAccountByID(j->GetAccount().wAccountIndex,actbTemp) )
		return;
	//
	cSocket *targSocket = calcSocketObjFromChar( j );
	switch( button )
	{
		case 2:
			if( mChar->IsGM() && !j->IsNpc() )
			{
				s->sysmessage( 487 );
				targSocket->sysmessage( 488 );
				actbTemp.wFlags|=AB_FLAGS_BANNED;	// Banned
				if( isOnline( j ) ) 
					Network->Disconnect( calcCharFromSer( j->GetSerial() ) );
			}
			else 
				s->sysmessage( 489 );
			break;
		case 3:
			if( mChar->IsGM() && !j->IsNpc() )
			{
				s->sysmessage( 490 );
				targSocket->sysmessage( 491 );
				actbTemp.wFlags|=AB_FLAGS_BANNED;
				actbTemp.wTimeBan=static_cast<UI16>(BuildTimeValue( 60 * 60 * 24 ));

				if( isOnline( j ) ) 
					Network->Disconnect( calcCharFromSer( j->GetSerial() ) );
			}
			else 
				s->sysmessage( 492 );
			break;
		case 4:		
		case 5:		
		case 6:		
		case 7:
			s->sysmessage( 489 + button );
			break;
	}
}

//o---------------------------------------------------------------------------o
//|   Function    :  void HandleTweakItemButton( cSocket *s, long button, SERIAL ser, long type )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Handles button pressed in tweak item gump
//o---------------------------------------------------------------------------o
void HandleTweakItemButton( cSocket *s, long button, SERIAL ser, long type )
{
	button -= 6;
	if( button <= 0 )
	{
		s->sysmessage( 1700 );
		return;
	}
	switch( button )
	{
		case 15:	// Low Damage
		case 16:	// High Damage
		case 17:	// Defense
		case 18:	// Speed
		case 19:	// Rank
			entrygump( s, ser, static_cast<char>(type), static_cast<char>(button), 4, 495 + button );	// allow 0x for hex value
			break;
		case 1:		// ID
		case 4:		// Colour
		case 5:		// Layer
		case 6:		// Type
		case 8:		// X
		case 9:		// Y
		case 10:	// Z
		case 13:	// Hit Points
		case 14:	// Max HitPoints
		case 20:	// More
		case 21:	// More X
		case 22:	// More Y
		case 23:	// More Z
		case 24:	// More B
		case 28:	// Good
		case 29:	// Buy Value
		case 30:	// Sell Value
		case 31:	// Carve
			entrygump( s, ser, static_cast<char>(type), static_cast<char>(button), 6, 495 + button );	// allow 0x for hex value
			break;
		case 7:		// Moveable
		case 25:	// Poisoned
		case 27:	// Decay
		case 32:	// Stackable
		case 33:	// Dyable
		case 34:	// Corpse
		case 35:	// Visible
			entrygump( s, ser, static_cast<char>(type), static_cast<char>(button), 1, 495 + button );
			break;
		case 11:	// Amount
		case 12:	// Strength
		case 26:	// Weight
			entrygump( s, ser, static_cast<char>(type), static_cast<char>(button), 7, 495 + button );	// allow 0x for hex value
			break;
		case 2:		// Name
		case 3:		// Name 2
		case 36:	// Creator
		case 37:	// Spawnobj/Spawnobjlist
			entrygump( s, ser, static_cast<char>(type), static_cast<char>(button), 50, 495 + button );
			break;
		default:	Console << Dictionary->GetEntry( 533 ) << (SI32)button << myendl;	break;
	}
}

//o---------------------------------------------------------------------------o
//|   Function    :  void HandleTweakCharButton( cSocket *s, long button, SERIAL ser, long type )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Handles button pressed in tweak char gump
//o---------------------------------------------------------------------------o
void HandleTweakCharButton( cSocket *s, long button, SERIAL ser, long type )
{
	button -= 6;
	if( button <= 0 )
	{
		s->sysmessage( 1700 );
		return;
	}

	switch( button )
	{
		case 1:		// Name
		case 2:		// Title
			entrygump( s, ser, static_cast<char>(type), static_cast<char>(button), 50, 1700 + button );
			break;
		case 3:		// Body
		case 4:		// Skin
		case 5:		// Race
		case 6:		// X
		case 7:		// Y
		case 8:		// Z
		case 9:		// Direction
		case 13:	// Hitpoints
		case 14:	// Stamina
		case 15:	// Mana
		case 21:	// Kills
		case 27:	// Carve
			entrygump( s, ser, static_cast<char>(type), static_cast<char>(button), 6, 1700 + button );	// allow 0x for hex
			break;
		case 10:	// Strength
		case 11:	// Dexterity
		case 12:	// Intelligence
		case 19:	// Fame
		case 20:	// Karma
		case 26:	// Weight
			entrygump( s, ser, static_cast<char>(type), static_cast<char>(button), 7, 1700 + button );	// allow 0x for hex
			break;

		case 16:	// Low Damage
		case 17:	// High Damage
		case 18:	// Defense
		case 22:	// AI Type
		case 24:	// Hunger
			entrygump( s, ser, static_cast<char>(type), static_cast<char>(button), 4, 1700 + button );	// allow 0x for hex
			break;
		case 23:	// NPC Wander
		case 25:	// Poison
		case 28:	// Visible
			entrygump( s, ser, static_cast<char>(type), static_cast<char>(button), 1, 1700 + button );
			break;
	}
}

//o---------------------------------------------------------------------------o
//|   Function    :  void HandleTownstoneButton( cSocket *s, long button, SERIAL ser, long type )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Handles button pressed in townstone gump
//o---------------------------------------------------------------------------o
void HandleTownstoneButton( cSocket *s, long button, SERIAL ser, long type )
{
	CChar *mChar = s->CurrcharObj();
	UI08 targetRegion;
	switch( button )
	{
		// buttons 2-20 are for generic town members
		// buttons 21-40 are for mayoral functions
		// buttons 41-60 are for potential candidates
		// buttons 61-80 are for enemy towns
		case 2:		// leave town
			bool result;
			// safe to assume we want to remove ourselves from our only town!
			result = region[mChar->GetTown()]->RemoveTownMember( (*mChar) );
			if( !result )
				s->sysmessage( 540 );
			break;
		case 3:		// view taxes
			targetRegion = calcRegionFromXY( mChar->GetX(), mChar->GetY(), mChar->WorldNumber() );
			if( targetRegion != 0xFF )
				region[targetRegion]->ViewTaxes( s );
			else
				s->sysmessage( 541 );
			break;
		case 4:		// toggle town title
			mChar->SetTownTitle( !mChar->GetTownTitle() );
			region[mChar->GetTown()]->DisplayTownMenu( NULL, s );
			break;
		case 5:		s->target( 0, TARGET_VOTEFORMAYOR, 542 );								break;		// vote for town mayor
		case 6:		entrygump(  s, ser, static_cast<char>(type), static_cast<char>(button), 6, 543 );	break;		// gold donation
		case 7:		region[mChar->GetTown()]->ViewBudget( s );			break;		// View Budget
		case 8:		region[mChar->GetTown()]->SendAlliedTowns( s );		break;		// View allied towns
		case 9:		region[mChar->GetTown()]->SendEnemyTowns( s );		break;
		case 20:	// access mayoral functions, never hit here if we don't have mayoral access anyway!
					// also, we'll only get access, if we're in our OWN region
			region[mChar->GetTown()]->DisplayTownMenu( NULL, s, 0x01 );	// mayor
			break;
		case 21:	s->sysmessage( 544 );				break;	// set taxes
		case 22:	region[mChar->GetTown()]->DisplayTownMembers( s );	break;	// list town members
		case 23:	region[mChar->GetTown()]->ForceEarlyElection();		break;	// force early election
		case 24:	s->sysmessage( 545 );	break;	// purchase more guards
		case 25:	s->sysmessage( 546 );	break;	// fire a guard
		case 26:	s->target( 0, TARGET_TOWNALLY, 547 );								break;	// make a town an ally
		case 40:	region[mChar->GetTown()]->DisplayTownMenu( NULL, s );	break;	// we can't return from mayor menu if we weren't mayor!
		case 41:	// join town!
			if( !(region[calcRegionFromXY( mChar->GetX(), mChar->GetY(), mChar->WorldNumber() )]->AddAsTownMember( (*mChar) ) ) )
				s->sysmessage( 548 );
			break;
		case 61:	// seize townstone!
			if( !Skills->CheckSkill( mChar, STEALING, 950, 1000 )	) // minimum 95.0 stealing
			{
				targetRegion = calcRegionFromXY( mChar->GetX(), mChar->GetY(), mChar->WorldNumber() );
				if( targetRegion != 0xFF )
				{
					int chanceToSteal	= RandomNum( 0, region[targetRegion]->GetHealth() / 2 );
					int fudgedStealing	= RandomNum( mChar->GetSkill( STEALING ), static_cast< UI16 >(mChar->GetSkill( STEALING ) * 2) );
					if( fudgedStealing >= chanceToSteal )
					{
						// redo stealing code here
						s->sysmessage( 549, region[targetRegion]->GetName().c_str() );
						region[targetRegion]->DoDamage( region[targetRegion]->GetHealth() / 2 );	// we reduce the region's health by half
						SI16 xOffset = MapRegion->GetGridX( mChar->GetX() );
						SI16 yOffset = MapRegion->GetGridY( mChar->GetY() );
						UI08 worldNumber = mChar->WorldNumber();
						for( SI08 counter1 = -1; counter1 <= 1; ++counter1 )
						{
							for( SI08 counter2 = -1; counter2 <= 1; ++counter2 )
							{
								SubRegion *toCheck = MapRegion->GetGrid( xOffset + counter1, yOffset + counter2, worldNumber );
								if( toCheck == NULL )	
									continue;
								toCheck->PushItem();
								// Handle the STL
								ITEMLIST_ITERATOR I;
								for( I=toCheck->itemData.begin(); I!=toCheck->itemData.end(); ++I )
								{
									CItem *itemCheck;
									itemCheck=(*I);
									if( itemCheck == NULL || I == toCheck->itemData.end() )		
										continue;
									if( itemCheck->GetType() == 35 && itemCheck->GetID() != 0x14F0 )
									{	// found our townstone
										CItem *charPack = getPack( mChar );
										if( charPack != NULL )
										{
											itemCheck->SetCont( charPack );
											itemCheck->SetMoreX( targetRegion );
											s->sysmessage( 550 );
											region[targetRegion]->TellMembers( 551, mChar->GetName().c_str() );
											toCheck->PopItem();
											return;	// dump out
										}
									}
								}
								toCheck->PopItem();
							}
						}
					}
					else
						s->sysmessage( 552 );
				}
				else
					s->sysmessage( 553 );
			}
			else
				s->sysmessage( 554 );
			break;
		case 62:	// attack townstone
			targetRegion = calcRegionFromXY( mChar->GetX(), mChar->GetY(), mChar->WorldNumber() );
			for( UI08 counter = 0; counter < RandomNum( 5, 10 ); ++counter )
			{
				Effects->movingeffect( mChar, mChar->GetX() + RandomNum( -6, 6 ), mChar->GetY() + RandomNum( -6, 6 ), mChar->GetZ(), 0x36E4, 17, 0, ( RandomNum( 0, 1 ) == 1 ) );
				Effects->staticeffect( mChar->GetX() + RandomNum( -6, 6 ), mChar->GetY() + RandomNum( -6, 6 ), mChar->GetZ(), 0x373A + RandomNum( 0, 4 ) * 0x10, 0x09, 0, 0 );
			}
			region[targetRegion]->DoDamage( RandomNum( 0, region[targetRegion]->GetHealth() / 8) );	// we reduce the region's health by half
			break;
	}
}

//o---------------------------------------------------------------------------o
//|   Function    :  void HandleHairDyeButton( cSocket *s, CItem *j )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Handles button pressed in hair dye gump
//o---------------------------------------------------------------------------o
void HandleHairDyeButton( cSocket *s, CItem *j )
{
	if( j == NULL )
		return;

	// we only HAVE one button, so we'll assume safely that the colour has changed if we hit here
	CChar *dest	= s->CurrcharObj();
	if( dest = NULL )
		return;

	UI16 dyeColour = s->GetWord( 21 );
	CItem *beardobject = dest->GetItemAtLayer( 0x10 );
	CItem *hairobject = dest->GetItemAtLayer( 0x0B );

	if( hairobject != NULL )
		hairobject->SetColour( dyeColour );
	if( beardobject != NULL )
		beardobject->SetColour( dyeColour );
	Items->DeleItem( j );
}

//o---------------------------------------------------------------------------o
//|   Function    :  void HandleAccountModButton( cSocket *s, long button )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Handles button pressed in account gump
//o---------------------------------------------------------------------------o
void HandleAccountModButton( CPIGumpMenuSelect *packet )
{
	cSocket *s = packet->GetSocket();

	std::string username	= "";
	std::string password	= "";
	std::string emailAddy	= "";

	for( unsigned int i = 0; i < packet->TextCount(); ++i )
	{
		UI16 textID = packet->GetTextID( i );
		switch( textID )
		{
			case 1000:	username	= packet->GetTextUString( i );	break;
			case 1001:	password	= packet->GetTextUString( i );	break;
			case 1002:	emailAddy	= packet->GetTextUString( i );	break;
			default:
				Console.Warning( 1, "Unknown textID %i with string %s", textID, packet->GetTextUString( i ).c_str() );
		}
	}

	ACCOUNTSBLOCK actbAccountFind;
	if( Accounts->GetAccountByName( username, actbAccountFind ) )
	{
		s->sysmessage( 555 );
		return;
	}
	Console.Print( "Attempting to add username %s with password %s at emailaddy %s", username.c_str(), password.c_str(), emailAddy.c_str() );
//	Accounts->AddAccount( username, password, emailAddy );
}

//o---------------------------------------------------------------------------o
//|   Function    :  void HandleHouseButton( cSocket *s, long button, CItem *j )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Handles button pressed in house gump
//o---------------------------------------------------------------------------o
void HandleHouseButton( cSocket *s, long button, CItem *j )
{
	if( j == NULL )
		return;

	if( button != 20 && button != 2 ) 
		s->AddID( j->GetSerial() );
	switch( button )
	{
		case 20: // Change house sign's appearance
			if( s->GetWord( 21 ) > 0 ) 
			{
				s->SetDWord( 7, s->AddID() );
				s->AddID1( s->GetByte( 21 ) );
				s->AddID2( s->GetByte( 22 ) );
				Targ->IDtarget( s );
				s->sysmessage( 556 );
			}
			return;
		case 0:		return;
		case 2:	s->target( 0, TARGET_HOUSEOWNER, 557 );			return;  // Bestow ownership upon someone else
		case 3:	
			deedHouse( s, static_cast<CMultiObj *>(j) );
			//Items->DeleItem(j);
			return;  // Turn house into a deed
		case 4:	s->target( 0, TARGET_HOUSEEJECT, 558 );			return;  // Kick someone out of house
		case 5:	s->target( 0, TARGET_HOUSEBAN, 559 );			return;  // Ban somebody
		case 6:
		case 8:	s->target( 0, TARGET_HOUSEUNLIST, 560 );		return; // Remove someone from house list
		case 7:	s->target( 0, TARGET_HOUSEFRIEND, 561 );		return; // Make someone a friend
		default:
			char temp[1024];
			sprintf( temp, "HouseGump Called - Button=%i", button );
			s->sysmessage( temp );
			return;
	}
}

//o---------------------------------------------------------------------------o
//|   Function    :  void HandleAddMenuButton( cSocket *s, long button )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Handles button pressed in add menu gump
//o---------------------------------------------------------------------------o
void HandleAddMenuButton( cSocket *s, long button )
{
	CChar *mChar	= s->CurrcharObj();
	SI32 addMenuLoc	= s->AddX();
	char sect[512];
	sprintf( sect, "ITEMMENU %i", addMenuLoc );
	ScriptSection *ItemMenu = FileLookup->FindEntry( sect, items_def );
	if( ItemMenu == NULL )
		return;

	UString tag		= ItemMenu->First();
	UString data	= ItemMenu->GrabData();	// let's skip the title
	UI08 counter	= 7;

	for( tag = ItemMenu->Next(); !ItemMenu->AtEnd(); tag = ItemMenu->Next(), ++counter )
	{	// let's skip over the name, and get straight to where we should be headed
		tag = ItemMenu->Next();
		data = ItemMenu->GrabData();
		if( counter == button )
		{	// we've found it
			scriptcommand( s, tag.c_str(), data.c_str() );
			break;
		}
		
	}
}

extern void HandleHowTo( cSocket *sock, int cmdNumber );
 
void HandleHowToButton( cSocket *s, long button )
{
	HandleHowTo( s, button - 2 );
}

//o---------------------------------------------------------------------------o
//|   Function    :  void void cGump::Button( CPIGumpMenuSelect *packet )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Handles button press in gumps
//o---------------------------------------------------------------------------o
void cGump::Button( CPIGumpMenuSelect *packet )
{
	if( packet == NULL )
		return;
	cSocket *s = packet->GetSocket();
	if( s == NULL )
		return;
	CChar *mChar = s->CurrcharObj();

	UI32 button = packet->ButtonID();
	if( button > 10000 ) 
	{
		button -= 10000;
		Menu( s, button );
		return;
	}
	SERIAL serial = packet->ID();
	SERIAL gumpID = packet->GumpID();
	if( gumpID >= 8000 && gumpID <= 8020 )
	{
		GuildSys->GumpChoice( s );
		// guild collection call goes here
		return;
	}
	else if( gumpID == 20 )	// script gump
	{
		UI16 gumpTrig = (UI16)s->TempInt();
		cScript *toExecute = Trigger->GetScript( gumpTrig );
		if( toExecute != NULL )
			toExecute->HandleGumpPress( packet );
	}
	else if( gumpID == 21 ) // Multi functional gump
	{
		MultiGumpCallback( s, serial, button );
		return;
	}
	else if( gumpID == 0x01CD )
	{
#if defined( _MSC_VER )
#pragma note( "Newly passed button press due to the pentagram in the 2D and 3D clients" )
#pragma note( "The question is... what does it DO?" )
#endif
	}
	else if( gumpID > 13 ) 
		return; //increase this value with each new gump added.
	if( button == 1 ) 
	{
		if( gumpID == 4 )
			WhoList->GMLeave();
		else if( gumpID == 11 )
			OffList->GMLeave();
		return;
	}

	// gump types
	// TBD  To Be Done
	// TBR  To Be Replaced
	// TBDU To Be Decided Upon
	// 1	Tweak Item
	// 2	Tweak Char
	// 3	Townstones
	// 4	WhoList
	// 5	House functions (TBR)
	// 6	Hair Dye Menu
	// 7	Accounts (TBR)
	// 8	Racial editor (TBDU)
	// 9	Add menu
	// 10	Safe sex window (TBD)
	// 11	Who's Offline
	// 12	New Make Menu
	// 13	HOWTO

#ifdef DEBUG
	Console << "Type is " << gumpID << " button is " <<  button << myendl;
#endif

	SERIAL is;
	CItem *j;
	switch( gumpID )
	{
		case 1:	HandleTweakItemButton( s, button, serial, gumpID );			break;	// Tweak Item
		case 2:	HandleTweakCharButton( s, button, serial, gumpID );			break;	// Tweak Char
		case 3:	HandleTownstoneButton( s, button, serial, gumpID );			break;	// Townstones
		case 4:	WhoList->ButtonSelect( s, static_cast<UI16>(button), static_cast<UI08>(gumpID) );					break;	// Wholist
		case 5:																		// House Functions
			is = s->AddID();
			j = calcItemObjFromSer( is );
			if( j != NULL ) 
			{
				is = j->GetMore(); 
				j = calcItemObjFromSer( is );
			}
			HandleHouseButton( s, button, j );
			break;
		case 6:																		// Hair Dye Menu
			is = s->AddID();
			j = calcItemObjFromSer( is );
			HandleHairDyeButton( s, j );
			break;
		case 7:																		// Accounts
			CChar *c;
			c = calcCharObjFromSer( serial );
			HandleAccountButton( s, button, c );
			break;
		case 8:	HandleAccountModButton( packet );							break;	// Race Editor
		case 9:	HandleAddMenuButton( s, button );							break;	// Add Menu
		case 11: OffList->ButtonSelect( s, static_cast<UI16>(button), static_cast<UI08>(gumpID) );				break;	// Who's Offline
		case 12: Skills->HandleMakeMenu( s, button, static_cast<int>(s->AddID()));	break;	// New Make Menu
		case 13: HandleHowToButton( s, button );							break;	// Howto
	}
}

//o---------------------------------------------------------------------------o
//|   Function    :  void HandleTweakItemText( cSocket *s, long index )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Handles new values for 'tweak items
//o---------------------------------------------------------------------------o
void HandleTweakItemText( cSocket *s, long index )
{
	CChar *mChar	= s->CurrcharObj();
	UString text	= (char *)&(s->Buffer()[12]);
	SERIAL serial	= s->GetDWord( 3 );

	if( mChar->IsGM() )
	{
		CItem *j = calcItemObjFromSer( serial );
		if( j == NULL ) 
			return;
		if( s->GetByte( 9 ) == 0 )
		{
			tweakItemMenu( s, j );
			return;
		}
		switch( index )
		{
			case 1:		j->SetID( text.toUShort() );			break;	// ID
			case 2:		j->SetName( text.c_str() );				break;	// Name
			case 3:		j->SetName2( text.c_str() );			break;	// Name 2
			case 4:		j->SetColour( text.toUShort() );		break;	// Colour
			case 5:		j->SetLayer( text.toUByte() );			break;	// Layer
			case 6:		j->SetType( text.toUByte() );			break;	// Type
			case 7:		j->SetMovable( text.toByte() );			break;	// Moveable
			case 8:
				MapRegion->RemoveItem( j );
				j->SetX( text.toShort() );
				MapRegion->AddItem( j );
				break;	// X
			case 9:		
				MapRegion->RemoveItem( j );
				j->SetY( text.toShort() );					
				MapRegion->AddItem( j );
				break;	// Y
			case 10:	j->SetZ( text.toByte() );				break;	// Z
			case 11:	j->SetAmount( text.toUShort() );		break;	// Amount
			case 12:	j->SetStrength( text.toShort() );		break;	// Strength
			case 13:	j->SetHP( text.toShort() ); 			break;	// Hit Points
			case 14:	j->SetMaxHP( text.toShort() );			break;	// Max HP
			case 15:	j->SetLoDamage( text.toShort() );		break;	// Low Damage
			case 16:	j->SetHiDamage( text.toShort() );		break;	// High Damage
			case 17:	j->SetDef( text.toUShort() );			break;	// Defense
			case 18:	j->SetSpeed( text.toUByte() );			break;	// Speed
			case 19:	j->SetRank( text.toByte() );			break;	// Rank
			case 20:	j->SetMore( text.toULong() );			break;	// More
			case 21:	j->SetMoreX( text.toULong() );			break;	// More X
			case 22:	j->SetMoreY( text.toULong() );			break;	// More Y
			case 23:	j->SetMoreZ( text.toULong() );			break;	// More Z
			case 24: 	j->SetMoreB( text.toULong() );			break;	// More B
			case 25:	j->SetPoisoned( text.toUByte() );		break;	// Poisoned
			case 26:	j->SetWeight( text.toLong() );			break;	// Weight
			case 27:	j->SetDecayable( text.toUByte() != 0 );	break;	// Decay
			case 28:	j->SetGood( text.toShort() );			break;	// Good
			case 29:	j->SetBuyValue( text.toLong() );		break;	// Buy Value
			case 30:	j->SetSellValue( text.toLong() );		break;	// Sell Value - Not implimented yet
			case 31:	j->SetCarve( text.toShort() );			break;	// Carve
			case 32: 	j->SetPileable( text.toUByte() != 0 );	break;	// Stackable
			case 33:	j->SetDye( text.toUByte() != 0 );		break;	// Dyable
			case 34:	j->SetCorpse( text.toUByte() != 0 );	break;	// Corpse
			case 35:	j->SetVisible( text.toByte() );			break;	// Visible
			case 36:	j->SetCreator( text.toULong() );		break;	// Creator
			case 37:	j->SetDesc( text.c_str() );				break;	// Spawnobj/Spawnobjlist
		}
		j->Dirty();
		tweakItemMenu( s, j );
	}
}

//o---------------------------------------------------------------------------o
//|   Function    :  void HandleTweakCharText( cSocket *s, long index )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Handles new values for 'tweak chars
//o---------------------------------------------------------------------------o
void HandleTweakCharText( cSocket *s, long index )
{
	CChar *mChar	= s->CurrcharObj();
	UString text	= (char *)&(s->Buffer()[12]);
	SERIAL serial	= s->GetDWord( 3 );
	if( mChar->IsGM() )
	{
		CChar *j = calcCharObjFromSer( serial );
		if( j == NULL ) 
			return;

		if( s->GetByte( 9 ) == 0 )
		{
			tweakCharMenu( s, j );
			return;
		}
		UI16 k;
		switch( index )
		{
			case 1:		j->SetName( text.c_str() );				break;	// Name
			case 2:		j->SetTitle( text.c_str() );			break;	// Title
			case 3:													// Body
				k = text.toUShort();
				if( k <= 0x3e1 ) // body-values >0x3e crash the client
				{ 
					j->SetID( k );
					j->SetOrgID( k );
				}
				break;
			case 4:													// Skin
				k = text.toUShort();
				j->SetColour( k );
				j->SetOrgSkin( k );
				break;
			case 5:		j->SetRace( text.toUShort() );			break;	// Race
			case 6:		
				MapRegion->RemoveChar( j );
				j->SetX( text.toShort() );
				MapRegion->AddChar( j );
				break;	// X
			case 7:		
				MapRegion->RemoveChar( j );
				j->SetY( text.toShort() );			
				MapRegion->AddChar( j );
				break;	// Y
			case 8:													// Z
				j->SetZ( text.toByte() );
				j->SetDispZ( text.toByte() );
				break;
			case 9:		j->SetDir( static_cast<UI08>((text.toUByte())&0x0F) );		break;	// Direction
			case 10:												// Strength
				if( text.toShort() > 0 ) 
					j->SetStrength( text.toShort() ); 
				break;
			case 11:												// Dexterity
				if( text.toShort() > 0 ) 
					j->SetDexterity( text.toShort() );
				break;
			case 12:												// Intelligence
				if( text.toShort() > 0 ) 
					j->SetIntelligence( text.toShort() ); 
				break;
			case 13:												// Hitpoints
				if( text.toShort() > 0 )
					j->SetHP( text.toShort() );
				break;
			case 14:												// Stamina
				if( text.toUShort() > 0 )
					j->SetStamina( text.toUShort() );
				break;
			case 15:												// Mana
				if( text.toShort() > 0 )
					j->SetMana( text.toShort() );
				break;
			case 16:	j->SetHiDamage( text.toShort() );		break;	// Low Damage
			case 17:	j->SetLoDamage( text.toShort() );		break;	// High Damage
			case 18:	j->SetDef( text.toUShort() );			break;	// Defense
			case 19:	j->SetFame( text.toShort() );			break;	// Fame
			case 20:	j->SetKarma( text.toShort() );			break;	// Karma
			case 21:	j->SetKills( text.toShort() );			break;	// Kills
			case 22:												// AI Type
				if( j->IsNpc() )
					j->SetNPCAiType( text.toShort() );
				break;
			case 23:												// NPC Wander
				if( j->IsNpc() )
					j->SetNpcWander( text.toByte() );
				break;
			case 24:	j->SetHunger( text.toByte() );			break;	// Hunger
			case 25:	j->SetPoisonStrength( text.toUByte() );	break;	// Poison
			case 26:	j->SetWeight( text.toShort() );			break;	// Weight
			case 27:	j->SetCarve( text.toShort() );			break;	// Carve
			case 28:	j->SetVisible( text.toByte() );			break;	// Visible
		}
		j->Teleport();
		tweakCharMenu( s, j );
	}
}

//o---------------------------------------------------------------------------o
//|   Function    :  void HandleTownstoneText( cSocket *s, long index )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Handles new values for townstones
//o---------------------------------------------------------------------------o
void HandleTownstoneText( cSocket *s, long index )
{
	CChar *mChar	= s->CurrcharObj();
	UI16 resourceID;
	UI32 amountToDonate;
	UString text( (char *)&(s->Buffer()[12]) );
	switch( index )
	{
		case 6:	// it's our donate resource button
		{
			amountToDonate = text.toULong();
			if( amountToDonate == 0 )
			{
				s->sysmessage( 562 );
				return;
			}
			resourceID			= region[mChar->GetTown()]->GetResourceID();
			UI32 numResources	= GetAmount( mChar, resourceID );

			if( amountToDonate > numResources )
				s->sysmessage( 563, numResources );
			else
			{
				DeleteQuantity( mChar, resourceID, amountToDonate );
				region[mChar->GetTown()]->DonateResource( s, amountToDonate );
			}
		}
			break;
	}
}

//o---------------------------------------------------------------------------o
//|   Function    :  void cGump::Input( cSocket *s )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Handles new values for gumps
//o---------------------------------------------------------------------------o
void cGump::Input( cSocket *s )
{
	char type	= s->GetByte( 7 );
	char index	= s->GetByte( 8 );

	switch( type )
	{
		case 1:		HandleTweakItemText( s, index );	break;
		case 2:		HandleTweakCharText( s, index );	break;
		case 3:		HandleTownstoneText( s, index );	break;
		case 20:
			{
				UI16 gumpTrig = static_cast<UI16>(s->TempInt());
				cScript *toExecute = Trigger->GetScript( gumpTrig );
				if( toExecute != NULL )
					toExecute->HandleGumpInput( s );
				break;
			}
		case 100:	GuildSys->GumpInput( s );			break;
	}

}

//o---------------------------------------------------------------------------o
//|   Function    :  void cGump::Menu( cSocket *s, int m )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Pull gump info from misc.scp
//o---------------------------------------------------------------------------o
void cGump::Menu( cSocket *s, int m )
{
	char sect[512];

	CPSendGumpMenu toSend;
	toSend.UserID( INVALIDSERIAL );

	sprintf( sect, "GUMPMENU %i", m );
	ScriptSection *gump = FileLookup->FindEntry( sect, misc_def );
	if( gump == NULL )
		return;
	UString tag;
	char temp[512];
	UI08 targType = 0x12;
	for( tag = gump->First(); !gump->AtEnd(); tag = gump->Next() )
	{
		sprintf( temp, "%s %s", tag.c_str(), gump->GrabData().c_str() );
		if( strncmp( temp, "type ", 5 ) )
			toSend.AddCommand( temp );
		else
			targType = UString( &temp[5] ).toUByte();
	}
	sprintf( sect, "GUMPTEXT %i", m );
	gump = FileLookup->FindEntry( sect, misc_def );
	if( gump == NULL )
		return;
	for( tag = gump->First(); !gump->AtEnd(); tag = gump->Next() )
	{
		toSend.AddText( "%s %s", tag.c_str(), gump->GrabData().c_str() );
	}
	toSend.GumpID( targType );
	toSend.Finalize();
	s->Send( &toSend );
}

//o---------------------------------------------------------------------------o
//|   Function    :  void tweakCharMenu( cSocket *s, CChar *c )
//|   Date        :  Unknown
//|   Programmer  :  Zane
//o---------------------------------------------------------------------------o
//|   Purpose     :  Handle new tweak character menu
//o---------------------------------------------------------------------------o
void tweakCharMenu( cSocket *s, CChar *c )
{
	if( c == NULL )
		return;

	GumpDisplay tweakChar( s, 350, 345 );
	tweakChar.SetTitle( "Tweak Character Menu" );

	UI16 charID = c->GetID();
	UI16 getSkin = c->GetSkin();

	if( !c->GetName().empty() )
		tweakChar.AddData( "Name", c->GetName().c_str() );
	else
		tweakChar.AddData( "Name", "None" );
	if( !c->GetTitle().empty() )
		tweakChar.AddData( "Title", c->GetTitle().c_str() );
	else
		tweakChar.AddData( "Title", "None" );
	tweakChar.AddData( "Body", charID, 5 );
	tweakChar.AddData( "Skin", getSkin, 5 );
	tweakChar.AddData( "Race", c->GetRace() );
	tweakChar.AddData( "X coord", c->GetX() );
	tweakChar.AddData( "Y coord", c->GetY() );
	tweakChar.AddData( "Z coord", c->GetZ() );
	tweakChar.AddData( "Direction", c->GetDir() );
	tweakChar.AddData( "Strength", c->GetStrength() );
	tweakChar.AddData( "Dexterity", c->GetDexterity() );
	tweakChar.AddData( "Intelligence", c->GetIntelligence() );
	tweakChar.AddData( "Hitpoints", c->GetHP() );
	tweakChar.AddData( "Stamina", c->GetStamina() );
	tweakChar.AddData( "Mana", c->GetMana() );
	tweakChar.AddData( "LowDamage", c->GetLoDamage() );
	tweakChar.AddData( "HighDamage", c->GetHiDamage() );
	tweakChar.AddData( "Defense", c->GetDef() );
	tweakChar.AddData( "Fame", c->GetFame() );
	tweakChar.AddData( "Karma", c->GetKarma() );
	tweakChar.AddData( "Kills", c->GetKills() );
	tweakChar.AddData( "AI Type", c->GetNPCAiType()  );
	tweakChar.AddData( "NPC Wander", c->GetNpcWander() );
	tweakChar.AddData( "Hunger", c->GetHunger() );
	tweakChar.AddData( "Poison", c->GetPoisonStrength() );
	tweakChar.AddData( "Weight", c->GetWeight() );
	tweakChar.AddData( "Carve", c->GetCarve() );
	tweakChar.AddData( "Visible", c->GetVisible() );
	tweakChar.Send( 2, true, c->GetSerial() );
}

//o---------------------------------------------------------------------------o
//|   Function    :  void tweakItemMenu( cSocket *s, CItem *c )
//|   Date        :  Unknown
//|   Programmer  :  Zane
//o---------------------------------------------------------------------------o
//|   Purpose     :  Handle new tweak item menu
//o---------------------------------------------------------------------------o
void tweakItemMenu( cSocket *s, CItem *i )
{
	if( i == NULL )
		return;
	GumpDisplay tweakItem( s, 350, 345 );
	tweakItem.SetTitle( "Tweak Item Menu" );

	UI16 itemID		= i->GetID();
	UI16 itemColour = i->GetColour();

	tweakItem.AddData( "ID", itemID, 5 );
	if( !i->GetName().empty() )
		tweakItem.AddData( "Name", i->GetName().c_str() );
	else
		tweakItem.AddData( "Name", "#" );
	if( i->GetName2() != NULL && i->GetName2()[0] > 0 )
		tweakItem.AddData( "Name2", i->GetName2() );
	else
		tweakItem.AddData( "Name2", "#" );
	tweakItem.AddData( "Colour", itemColour, 5 );
	tweakItem.AddData( "Layer", i->GetLayer() );
	tweakItem.AddData( "Type", i->GetType() );
	tweakItem.AddData( "Moveable", i->GetMovable() );
	tweakItem.AddData( "X coord", i->GetX() );
	tweakItem.AddData( "Y coord", i->GetY() );
	tweakItem.AddData( "Z coord", i->GetZ() );
	tweakItem.AddData( "Amount", i->GetAmount() );
	tweakItem.AddData( "Strength", i->GetStrength() );
	tweakItem.AddData( "HP", i->GetHP() );
	tweakItem.AddData( "Max HP", i->GetMaxHP() );
	tweakItem.AddData( "LowDamage", i->GetLoDamage() );
	tweakItem.AddData( "HighDamage", i->GetHiDamage() );
	tweakItem.AddData( "Defense", i->GetDef() );
	tweakItem.AddData( "Speed", i->GetSpeed() );
	tweakItem.AddData( "Rank", i->GetRank() );
	tweakItem.AddData( "More", i->GetMore() );
	tweakItem.AddData( "More X", i->GetMoreX() );
	tweakItem.AddData( "More Y", i->GetMoreY() );
	tweakItem.AddData( "More Z", i->GetMoreZ() );
	tweakItem.AddData( "More B", i->GetMoreB() ); 
	tweakItem.AddData( "Poisoned", i->GetPoisoned() );
	tweakItem.AddData( "Weight", i->GetWeight() );
	tweakItem.AddData( "Decay", i->isDecayable()?1:0 );
	tweakItem.AddData( "Good", i->GetGood() );
	tweakItem.AddData( "Buy Value", i->GetBuyValue() );
	tweakItem.AddData( "Sell Value", i->GetSellValue() );
	tweakItem.AddData( "Carve", i->GetCarve() );
	tweakItem.AddData( "Stackable", i->isPileable()?1:0 );
	tweakItem.AddData( "Dyeable", i->isDyeable()?1:0 );
	tweakItem.AddData( "Corpse", i->isCorpse()?1:0 );
	tweakItem.AddData( "Visible", i->GetVisible() );
	tweakItem.AddData( "Creator", i->GetCreator() );
	if( i->isSpawnerList() )
		tweakItem.AddData( "Spawnobjlist", i->GetDesc() );
	else
		tweakItem.AddData( "Spawnobj", i->GetDesc() );
	tweakItem.Send( 1, true, i->GetSerial() );
}

//o---------------------------------------------------------------------------o
//|   Function    :  void entrygump( cSocket *s, SERIAL ser, char type, char index, SI16 maxlength, char *text1 )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Open entry gump with specified text message and max value length
//o---------------------------------------------------------------------------o
void entrygump( cSocket *s, SERIAL ser, char type, char index, SI16 maxlength, const char *txt )
{
	if( s == NULL )
		return;
	if( txt == NULL )
	{
		Console.Error( 2, "Invalid text in entrygump()" );
		return;
	}

	char temp[32];
	sprintf( temp, "(%i chars max)", maxlength );
	CPGumpTextEntry toSend( txt, temp );
	toSend.Serial( ser );
	toSend.ParentID( type );
	toSend.ButtonID( index );
	toSend.Cancel( 1 );
	toSend.Style( 1 );
	toSend.Format( maxlength );
	s->Send( &toSend );
}

//o---------------------------------------------------------------------------o
//|   Function    :  void entrygump( cSocket *s, SERIAL ser, char type, char index, SI16 maxlength, SI32 dictEntry )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Open entry gump with specified dictionary message and max value length
//o---------------------------------------------------------------------------o
void entrygump( cSocket *s, SERIAL ser, char type, char index, SI16 maxlength, SI32 dictEntry )
{
	std::string txt = Dictionary->GetEntry( dictEntry, s->Language() );
	entrygump( s, ser, type, index, maxlength, txt.c_str() );
}

//o---------------------------------------------------------------------------o
//|		Function    :	void choice( cSocket *s )
//|		Date        :	Unknown
//|		Programmer  :	Unknown
//|		Modified	:	Zane - 2/10/2003	
//o---------------------------------------------------------------------------o
//|   Purpose     :  Handles choice "Help" menu, Tracking Menu, and Polymorph menu
//o---------------------------------------------------------------------------o
void choice( cSocket *s )
{
	char sect[512];
	DEFINITIONCATEGORIES script;
	
	UI16 main = s->GetWord( 5 );
	UI16 sub = s->GetWord( 7 );
	CChar *mChar = s->CurrcharObj();

	if( main < ITEMMENUOFFSET ) // GM Menus
	{
		sprintf(sect, "GMMENU %i", main);
		script = menus_def;
	}
	// PolyMorph spell menu (scriptable) by AntiChrist (9/99)
	else if( main >= POLYMORPHMENUOFFSET && main < POLYMORPHMENUOFFSET + 50 )
	{
		if( mChar->IsOnHorse() )
			DismountCreature( s->CurrcharObj() );		// can't be polymorphed on a horse
		Magic->Polymorph( s, POLYMORPHMENUOFFSET, sub );
		return;
	}
	else // Tracking
	{
		if( main >= TRACKINGMENUOFFSET + 1 && main <= TRACKINGMENUOFFSET + 3 )
		{
			if( !sub ) 
				return;
			if( !Skills->CheckSkill( mChar, TRACKING, 0, 1000 ) )
			{
				s->sysmessage( 575 );
				return;
			}
			Skills->TrackingMenu( s, static_cast<int>(sub - 1) );
		}
		sprintf( sect, "TRACKINGMENU %i", main );
		script = tracking_def;
	}
	
	ScriptSection *sectionData = FileLookup->FindEntry( sect, script );
	if( sectionData == NULL )
		return;

	char lscomm[512], lsnum[512];
	UString data;
	UString tag = sectionData->First();
	tag = sectionData->Next();
	for( UI16 i = 0; !sectionData->AtEnd(); tag = sectionData->Next() )
	{
		++i;
		tag = sectionData->Next();
		if( i == sub )
		{
			data = sectionData->GrabData();
			strcpy( lscomm, tag.c_str() );
			strcpy( lsnum, data.c_str() );
			scriptcommand( s, lscomm, lsnum );
			break;
		}
	}
}

//o---------------------------------------------------------------------------o
//|   Function    :  void gmmenu( cSocket *s, int m )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Opens the GM Call menu
//o---------------------------------------------------------------------------o
void gmmenu( cSocket *s, int m )
{
	char sect[512];
	UI16 gmnumber	= 0;
	CChar *mChar	= s->CurrcharObj();
	
	sprintf( sect, "GMMENU %i", m );
	ScriptSection *GMMenu = FileLookup->FindEntry( sect, menus_def );
	if( GMMenu == NULL )
		return;

	char line[1024];
	CPOpenGump toSend( *mChar );
	toSend.GumpIndex( m );
	UString tag		= GMMenu->First();
	UString data	= GMMenu->GrabData();
	sprintf( line, "%s %s", tag.c_str(), data.c_str() );
	toSend.Question( line );
	for( tag = GMMenu->Next(); !GMMenu->AtEnd(); tag = GMMenu->Next() )
	{
		data = GMMenu->GrabData();
		sprintf( line, "%s %s", tag.c_str(), data.c_str() );
		toSend.AddResponse( gmnumber++, 0, line );
		tag = GMMenu->Next();
	}
	toSend.Finalize();
	s->Send( &toSend );
}

//o---------------------------------------------------------------------------o
//|   Function    :  void cGump::Open( cSocket *s, CChar *i, UI08 num1, UI08 num2)
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Opens shopping gump
//o---------------------------------------------------------------------------o
void cGump::Open( cSocket *s, CChar *i, UI16 gumpNum )
{
	CPDrawContainer toSend;
	toSend.Serial( i->GetSerial() );
	toSend.Model( gumpNum );
	s->Send( &toSend );
}

//o---------------------------------------------------------------------------o
//|   Function    :  void GumpDisplay::AddData( GumpInfo *toAdd )
//|   Date        :  Unknown
//|   Programmer  :  Abaddon
//o---------------------------------------------------------------------------o
//|   Purpose     :  Adds the data to the gump to send
//o---------------------------------------------------------------------------o
void GumpDisplay::AddData( GumpInfo *toAdd )
{
	GumpInfo *gAdd		= new GumpInfo;
	gAdd->name			= toAdd->name;
	gAdd->value			= toAdd->value;
	gAdd->type			= toAdd->type;
	gAdd->stringValue	= toAdd->stringValue;
	gumpData.push_back( gAdd );
}

//o---------------------------------------------------------------------------o
//|   Function    :  void GumpDisplay::AddData( const char *toAdd, long int value, UI08 type )
//|   Date        :  Unknown
//|   Programmer  :  Abaddon
//o---------------------------------------------------------------------------o
//|   Purpose     :  Adds the data to the gump to send
//o---------------------------------------------------------------------------o
void GumpDisplay::AddData( const char *toAdd, long int value, UI08 type )
{
	GumpInfo *gAdd = new GumpInfo;
	gAdd->name = toAdd;
	gAdd->stringValue = "";
	gAdd->value = value;
	gAdd->type = type;
	gumpData.push_back( gAdd );
}

//o---------------------------------------------------------------------------o
//|   Function    :  void GumpDisplay::AddData( const char *toAdd, const char *toSet, UI08 type )
//|   Date        :  Unknown
//|   Programmer  :  Abaddon
//o---------------------------------------------------------------------------o
//|   Purpose     :  Adds the data to the gump to send
//o---------------------------------------------------------------------------o
void GumpDisplay::AddData( const char *toAdd, const char *toSet, UI08 type )
{
	if( toSet == NULL )
		return;

	if( toSet[0] == 0 )
		return;

	GumpInfo *gAdd = new GumpInfo;
	gAdd->name = toAdd;
	gAdd->stringValue = toSet;
	gAdd->type = type;
	gumpData.push_back( gAdd );
}

//o---------------------------------------------------------------------------o
//|   Function    :  GumpDisplay::GumpDisplay( cSocket *target ) : toSendTo( target )
//|   Date        :  Unknown
//|   Programmer  :  Abaddon
//o---------------------------------------------------------------------------o
//|   Purpose     :  Begin GumpDisplay stuff by setting the target, clearing any existing data, and setting the w / h
//o---------------------------------------------------------------------------o
GumpDisplay::GumpDisplay( cSocket *target ) : toSendTo( target )
{
	gumpData.resize( 0 );
	width = 340;
	height = 320;
}

//o---------------------------------------------------------------------------o
//|   Function    :  GumpDisplay::GumpDisplay( cSocket *target, UI16 gumpWidth, UI16 gumpHeight ) : 
//|						width( gumpWidth ), height( gumpHeight ), toSendTo( target )
//|   Date        :  Unknown
//|   Programmer  :  Abaddon
//o---------------------------------------------------------------------------o
//|   Purpose     :  Begin GumpDisplay stuff by setting the target, clearing any existing data, and setting the w / h
//o---------------------------------------------------------------------------o
GumpDisplay::GumpDisplay( cSocket *target, UI16 gumpWidth, UI16 gumpHeight ) : 
	width( gumpWidth ), height( gumpHeight ), toSendTo( target )
{
	gumpData.resize( 0 );
}

//o---------------------------------------------------------------------------o
//|   Function    :  GumpDisplay::~GumpDisplay()
//|   Date        :  Unknown
//|   Programmer  :  Abaddon
//o---------------------------------------------------------------------------o
//|   Purpose     :  Clear any existing GumpDisplay data
//o---------------------------------------------------------------------------o
GumpDisplay::~GumpDisplay()
{
	for( UI32 i = 0; i < gumpData.size(); ++i )
		delete gumpData[i];
	Delete();
	gumpData.resize( 0 );
}

//o---------------------------------------------------------------------------o
//|   Function    :	 void GumpDisplay::Delete( void )
//|   Date        :  Unknown
//|   Programmer  :  Abaddon
//o---------------------------------------------------------------------------o
//|   Purpose     :  Delete all GumpDisplay entries
//o---------------------------------------------------------------------------o
void GumpDisplay::Delete( void )
{
	one.resize( 0 );
	two.resize( 0 );
}

//o---------------------------------------------------------------------------o
//|   Function    :	 void GumpDisplay::SetTitle( const char *newTitle )
//|   Date        :  Unknown
//|   Programmer  :  Abaddon
//o---------------------------------------------------------------------------o
//|   Purpose     :  Set a gumps title
//o---------------------------------------------------------------------------o
void GumpDisplay::SetTitle( const char *newTitle )
{
	title = newTitle;
}

//o---------------------------------------------------------------------------o
//|   Function    :	 void SendVecsAsGump( cSocket *sock, stringList& one, stringList& two, long type, SERIAL serial )
//|   Date        :  Unknown
//|   Programmer  :  Abaddon
//o---------------------------------------------------------------------------o
//|   Purpose     :  Sends to socket sock the data in one and two.  One is control, two is data
//o---------------------------------------------------------------------------o
void SendVecsAsGump( cSocket *sock, STRINGLIST& one, STRINGLIST& two, long type, SERIAL serial )
{
	CPSendGumpMenu toSend;
	toSend.GumpID( type );
	toSend.UserID( serial );

	UI32 line = 0;
	for( line = 0; line < one.size(); ++line )
		toSend.AddCommand( one[line].c_str() );

	for( line = 0; line < two.size(); ++line )
		toSend.AddText( two[line].c_str() );

	toSend.Finalize();
	sock->Send( &toSend );
}

//o---------------------------------------------------------------------------o
//|   Function    :	 void NewAddMenu( cSocket *s, int m )
//|   Date        :  Unknown
//|   Programmer  :  Abaddon
//o---------------------------------------------------------------------------o
//|   Purpose     :  Menu for item creation based on ITEMMENU entries in items.scp
//o---------------------------------------------------------------------------o
void NewAddMenu( cSocket *s, int m )
{
	UI32 pagenum = 1, position = 40, linenum = 1, buttonnum = 7;
	UI08 i = 0;

	char sect[512];
	CChar *mChar = s->CurrcharObj();

	if( !mChar->IsGM() && m < 990 && m > 999 )
	{
		s->sysmessage( 337 );
		return;
	}

	CPSendGumpMenu toSend;
	toSend.UserID( INVALIDSERIAL );
	toSend.GumpID( 9 );

	////////////////////////////////////////////////
	s->AddX( m );	// Store what menu they are in

	sprintf( sect, "ITEMMENU %i", m );
	ScriptSection *ItemMenu = FileLookup->FindEntry( sect, items_def );
	if( ItemMenu == NULL )
		return;

	// page header
//	toSend.AddCommand( "nomove" );
	toSend.AddCommand( "noclose" );
	toSend.AddCommand( "page 0" );
	toSend.AddCommand( "resizepic 0 0 %u 320 340", cwmWorldState->ServerData()->BackgroundPic() );
	toSend.AddCommand( "button 280 10 %u %i 1 0 1", cwmWorldState->ServerData()->ButtonCancel(), cwmWorldState->ServerData()->ButtonCancel() + 1); //OKAY
	toSend.AddCommand( "text 70 10 %u 0", cwmWorldState->ServerData()->TitleColour() );           //text <Spaces from Left> <Space from top> <Length, Color?> <# in order>
	UString tag		= ItemMenu->First();
	UString data	= ItemMenu->GrabData();
	toSend.AddText( "%s %s", tag.c_str(), data.c_str() );	// our title

	toSend.AddCommand( "text 140 310 %u %i", cwmWorldState->ServerData()->TitleColour(), linenum++ );           //text <Spaces from Left> <Space from top> <Length, Color?> <# in order>
	toSend.AddText( "Menu %i", m );

	toSend.AddCommand( "page 1" );

	UI08 numCounter = 0;
	for( tag = ItemMenu->Next(); !ItemMenu->AtEnd(); tag = ItemMenu->Next() )
	{
		data = ItemMenu->GrabData();

		if( numCounter > 0 && (!(numCounter % 13 ) ) )
		{
			position = 40;
			++pagenum;
			toSend.AddCommand( "page %i", pagenum );
		}

		toSend.AddCommand( "text 50 %i %i %i", position, cwmWorldState->ServerData()->LeftTextColour(), linenum ); 
		toSend.AddCommand( "button 20 %i %i %i 1 0 %i",position, cwmWorldState->ServerData()->ButtonRight(), cwmWorldState->ServerData()->ButtonRight() + 1, buttonnum);
		toSend.AddText( data.c_str() );
		if( tag.data()[0] != '<' && tag.data()[0] != ' ' )	// it actually has a picture, well bugger me! :>
		{
			if( numCounter % 2 == 0 )
				toSend.AddCommand( "tilepic 220 %i %i", position, tag.toLong() );
			else
				toSend.AddCommand( "tilepic 270 %i %i", position, tag.toLong() );
		}

		position += 20;
		++linenum;
		++buttonnum;
		++numCounter;

		tag = ItemMenu->Next();
	}
	pagenum = 1;
	for( i = 0; i < numCounter; i += 13 )
	{
		toSend.AddCommand( "page %i", pagenum );
		if( i >= 10 )
			toSend.AddCommand( "button 50 300 %i %i  0 %i", cwmWorldState->ServerData()->ButtonLeft(), cwmWorldState->ServerData()->ButtonLeft() + 1, pagenum-1); //back button
		if( ( numCounter > 13 ) && ( ( i + 13 ) < numCounter ) )
			toSend.AddCommand( "button 260 300 %i %i  0 %i", cwmWorldState->ServerData()->ButtonRight(), cwmWorldState->ServerData()->ButtonRight() + 1, pagenum + 1 );
		++pagenum;
	}		

	toSend.Finalize();
	s->Send( &toSend );
}

//o---------------------------------------------------------------------------o
//|   Function    :	 void GumpDisplay::Send( long gumpNum, bool isMenu, SERIAL serial )
//|   Date        :  Unknown
//|   Programmer  :  Abaddon
//o---------------------------------------------------------------------------o
//|   Purpose     :  Sends gump data to the socket
//o---------------------------------------------------------------------------o
void GumpDisplay::Send( long gumpNum, bool isMenu, SERIAL serial )
{
	char temp[512];
	int i;
	UI32 pagenum = 1, position = 40, linenum = 1, buttonnum = 7;
	UI08 numToPage = 10, stringWidth = 10;

	if( one.size() > 0 && two.size() > 0 )
	{
		SendVecsAsGump( toSendTo, one, two, gumpNum, serial );
		return;
	}
	UI08 ser1, ser2, ser3, ser4;
	//--static pages
	one.push_back( "noclose" );
	one.push_back( "page 0"  );
	sprintf( temp, "resizepic 0 0 %i %i %i", cwmWorldState->ServerData()->BackgroundPic(), width, height );
	one.push_back( temp );
	sprintf( temp, "button %i 15 %i %i 1 0 1", width - 40, cwmWorldState->ServerData()->ButtonCancel(), cwmWorldState->ServerData()->ButtonCancel() + 1 );
	one.push_back( temp );
	sprintf( temp, "text 45 15 %i 0", cwmWorldState->ServerData()->TitleColour() );
	one.push_back( temp );

	sprintf( temp, "page %i", pagenum );
	one.push_back( temp );

	if( title.length() == 0 )
		strcpy( temp, "General Gump" );
	else
		strcpy( temp, title.c_str() );
	two.push_back( temp );

	numToPage = (UI08)((( height - 30 ) / 20) - 2);
	stringWidth = (UI08)( ( width / 2 ) / 10 );
	UI32 lineForButton;
	for( i = 0, lineForButton = 0; static_cast<unsigned int>(i) < gumpData.size(); ++i, ++lineForButton )
	{
		if( lineForButton > 0 && ( !( lineForButton % numToPage ) ) )
		{
			position = 40;
			++pagenum;
			sprintf( temp, "page %i", pagenum );
			one.push_back( temp );
		}
		if( gumpData[i]->type != 7 )
		{
			sprintf( temp, "text 50 %i %i %i",position, cwmWorldState->ServerData()->LeftTextColour(), linenum++ ); 
			one.push_back( temp );
			if( isMenu )
			{
				sprintf( temp, "button 20 %i %i %i 1 0 %i",position, cwmWorldState->ServerData()->ButtonRight(), cwmWorldState->ServerData()->ButtonRight() + 1, buttonnum);
				one.push_back( temp );
			}
			sprintf( temp, "text %i %i %i %i", (width / 2) + 10, position, cwmWorldState->ServerData()->RightTextColour(), linenum++);
			one.push_back( temp );
			two.push_back( gumpData[i]->name );
		}
		else
		{
			sprintf( temp, "text 30 %i %i %i",position, cwmWorldState->ServerData()->LeftTextColour(), linenum++ ); 
			one.push_back( temp );
		}

//		const char *sVal	= gumpData[i]->stringValue.c_str();
		long value			= gumpData[i]->value;
		switch( gumpData[i]->type )
		{
			case 0:		// all numbers of sorts
				sprintf( temp, "%li", value );
				break;
			case 1:
				sprintf( temp, "%lx", value );
				break;
			case 2:
				ser1 = (UI08)(value>>24);
				ser2 = (UI08)(value>>16);
				ser3 = (UI08)(value>>8);
				ser4 = (UI08)(value%256);
				sprintf( temp, "%i %i %i %i", ser1, ser2, ser3, ser4 );
				break;
			case 3:
				ser1 = (UI08)(value>>24);
				ser2 = (UI08)(value>>16);
				ser3 = (UI08)(value>>8);
				ser4 = (UI08)(value%256);
				sprintf( temp, "%x %x %x %x", ser1, ser2, ser3, ser4 );
				break;
			case 4:
				if( gumpData[i]->stringValue.size() == 0 )
					strcpy( temp, "NULL POINTER" );
				else
					strcpy( temp, gumpData[i]->stringValue.c_str() );
				if( strlen( temp ) > stringWidth )	// too wide for one line, CRAP!
				{
					char temp2[512], temp3[512];
					size_t tempWidth = strlen( temp ) - stringWidth;
					strncpy( temp2, temp, stringWidth );
					temp2[stringWidth] = 0;
					two.push_back( temp2 );
					for( UI32 tempCounter = 0; tempCounter < tempWidth / ( stringWidth * 2 ) + 1; ++tempCounter )
					{
						position += 20;
						++lineForButton;
						sprintf( temp3, "text %i %i %i %i", 30, position, cwmWorldState->ServerData()->RightTextColour(), linenum++ );
						one.push_back( temp3 );
						strncpy( temp2, &temp[stringWidth + tempCounter * stringWidth * 2], stringWidth * 2 );
						temp2[stringWidth * 2] = 0;
						two.push_back( temp2 );
					}
					// be stupid for the moment and do no text wrapping over pages
				}
				else
					two.push_back( temp );
				break;
			case 5:
				ser1 = (UI08)(value>>8);
				ser2 = (UI08)(value%256);
				sprintf( temp, "%x %x", ser1, ser2 );
				break;
			case 6:
				ser1 = (UI08)(value>>8);
				ser2 = (UI08)(value%256);
				sprintf( temp, "%i %i", ser1, ser2 );
				break;
			case 7:
				if( gumpData[i]->stringValue.size() == 0 )
					strcpy( temp, "NULL POINTER" );
				else
					strcpy( temp, gumpData[i]->stringValue.c_str() );
				int sWidth;
				sWidth = stringWidth * 2;
				if( strlen( temp ) > static_cast<size_t>(sWidth) )	// too wide for one line, CRAP!
				{
					char temp2[512], temp3[512];
					size_t tempWidth = strlen( temp ) - sWidth;
					strncpy( temp2, temp, sWidth );
					temp2[sWidth] = 0;
					two.push_back( temp2 );
					for( UI32 tempCounter = 0; tempCounter < tempWidth / sWidth + 1; ++tempCounter )
					{
						position += 20;
						++lineForButton;
						sprintf( temp3, "text %i %i %i %i", 30, position, cwmWorldState->ServerData()->LeftTextColour(), linenum++ );
						one.push_back( temp3 );
						strncpy( temp2, &temp[(tempCounter + 1) * sWidth], sWidth );
						temp2[sWidth] = 0;
						two.push_back( temp2 );
					}
					// be stupid for the moment and do no text wrapping over pages
				}
				else
					two.push_back( temp );
				break;
			default:
				sprintf( temp, "%li", value );
				break;
		}
		if( gumpData[i]->type != 4 && gumpData[i]->type != 7 )
			two.push_back( temp );
		position += 20;
		++buttonnum;
	}
	
	pagenum = 1; 
	for( i = 0; static_cast<UI32>(i) <= lineForButton; i += numToPage )
	{
		sprintf( temp, "page %i", pagenum );
		one.push_back( temp );
		if( i >= 10 )
		{
			sprintf( temp, "button 10 %i %i %i 0 %i", height - 40, cwmWorldState->ServerData()->ButtonLeft(), cwmWorldState->ServerData()->ButtonLeft() + 1, pagenum-1); //back button
			one.push_back( temp );
		}
		if( lineForButton > numToPage && static_cast<UI32>(( i + numToPage )) < lineForButton )
		{
			sprintf( temp, "button %i %i %i %i 0 %i", width - 40, height - 40, cwmWorldState->ServerData()->ButtonRight(), cwmWorldState->ServerData()->ButtonRight() + 1, pagenum+1); //forward button
			one.push_back( temp );
		}
		++pagenum;
	}		
	SendVecsAsGump( toSendTo, one, two, gumpNum, serial );
}

//o---------------------------------------------------------------------------o
//|   Function    :	 string GetStrFromSock( cSocket *sock, UI16 offset, UI16 length )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Get string data from the socket
//o---------------------------------------------------------------------------o
std::string GetStrFromSock( cSocket *sock, UI16 offset, UI16 length )
{
	char temp[512];
	strncpy( temp, (const char *)&(sock->Buffer()[offset]), length );
	temp[length] = 0;
	return temp;
}

//o---------------------------------------------------------------------------o
//|   Function    :	 string GetUniStrFromSock( cSocket *sock, UI16 offset, UI16 length )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Get string data from the socket
//o---------------------------------------------------------------------------o
std::string GetUniStrFromSock( cSocket *sock, UI16 offset, UI16 length )
{
	char temp[512];
	for( int counter = 0; counter < length; ++counter )
		temp[counter] = sock->GetByte( offset + counter * 2 + 1 );
	temp[length] = 0;
	return temp;
}
