// -- Region class  Added by Tauriel 3/6/1999 To lookup items by region
//									This should help for now. BTW- my first attempt at C++
//									So forgive any newbie mistakes :)
//									-- Side note, I wanted regions to be more generic, but
//									now that I have to do this, time doesn't allow for it yet.

#ifndef __Region_h
#define __Region_h

#include "mapstuff.h"

typedef UI32 vIterator;

class SubRegion
{
public:
	SubRegion(); //constructor
	virtual			~SubRegion(); //destructor
	CItem *	GetCurrentItem( void );
	CChar *	GetCurrentChar( void );

	CItem *	FirstItem( void );
	CChar *	FirstChar( void );

	CItem *	GetNextItem( void );
	CChar *	GetNextChar( void );

	bool	FinishedItems( void );
	bool	FinishedChars( void );

	virtual bool	AddItem( CItem *toAdd );
	virtual bool	AddChar( CChar *toAdd );

	virtual bool	RemoveItem( CItem *toRemove );
	virtual bool	RemoveChar( CChar *toRemove );

	void	SaveToDisk( std::ofstream& writeDestination, std::ofstream &houseDestination );
	void	LoadFromDisk( std::ifstream& readDestination );

	void	PopItem( void );
	void	PopChar( void );
	void	PushItem( void );
	void	PushChar( void );

	CHARLIST charData;
	ITEMLIST itemData;
	std::vector< vIterator > charIteratorBackup;
	std::vector< vIterator > itemIteratorBackup;

	vIterator charCounter;
	vIterator itemCounter;

};

const SI16 MapColSize = 32;
const SI16 MapRowSize = 128;

const SI16 UpperX = (SI16)(6144 / MapColSize);
const SI16 UpperY = (SI16)(4096 / MapRowSize);

class cMapRegion
{
private:
	SubRegion		internalRegions[UpperX][UpperY][NumberOfWorlds];
	SubRegion		overFlow;
	void	LoadHouseMulti( std::ifstream &houseDestination );

public:
						cMapRegion(); //constructor
	virtual				~cMapRegion(); //destructor

	SubRegion *	GetCell( SI16 x, SI16 y, UI08 worldNumber );

	virtual bool		AddItem( CItem *nItem );
	virtual bool		RemoveItem( CItem *nItem );

	virtual bool		AddChar( CChar *toAdd );
	virtual bool		RemoveChar( CChar *toRemove );

	void		Save( void );
	void		Load( void );

	int			GetGridIndex( SI16 x, SI16 y );
//	SubRegion *	GetGrid( int gridIndex, UI08 worldNumber );
	SubRegion *	GetGrid( int xOffset, int yOffset, UI08 worldNumber );

	SI16		GetGridX( SI16 x );
	SI16		GetGridY( SI16 y );

	bool		Add( cBaseObject *toAdd );
	bool		Remove( cBaseObject *toRemove );
};

#endif

