#ifndef __TARGETING_H__
#define __TARGETING_H__

typedef void (TargetFunc)( cSocket *s );

class cTargets
{
private:
	TargetFunc AddNpcTarget;
	TargetFunc AddTarget;
	TargetFunc AllSetTarget;
	TargetFunc AmountTarget;
	TargetFunc AreaCommand;
	TargetFunc AttackTarget;
	TargetFunc AxeTarget;
	TargetFunc BanTarg;
	TargetFunc BoltTarget;
	TargetFunc BuyShopTarget;
	TargetFunc CanTrainTarget;
	TargetFunc CloseTarget;
	TargetFunc CnsTarget;
	TargetFunc ColorsTarget;
	TargetFunc CommandLevel;
	TargetFunc CorpseTarget;
	TargetFunc DeleteCharTarget;
	TargetFunc DupeTarget;
	TargetFunc DvatTarget;
	TargetFunc DyeTarget;
	TargetFunc FollowTarget;
	TargetFunc FontTarget;
	TargetFunc FreezeTarget;
	TargetFunc FullStatsTarget;
	TargetFunc GhostTarget;
	TargetFunc GlowTarget;
	TargetFunc GmOpenTarget;
	TargetFunc GMTarget;
	TargetFunc GuardTarget;
	TargetFunc FriendTarget;
	TargetFunc HandleGuildTarget;
	TargetFunc HandleSetScpTrig;
	TargetFunc HouseBanTarget;
	TargetFunc HouseEjectTarget;
	TargetFunc HouseFriendTarget;
	TargetFunc HouseLockdown;
	TargetFunc HouseOwnerTarget;
	TargetFunc HouseRelease;
	TargetFunc HouseUnlistTarget;
	TargetFunc IncXTarget;
	TargetFunc IncYTarget;
	TargetFunc IncZTarget;
	TargetFunc InfoTarget;
	TargetFunc IstatsTarget;
	TargetFunc KeyTarget;
	TargetFunc LoadCannon;
	TargetFunc MakeShopTarget;
	TargetFunc MakeStatusTarget;
	TargetFunc MakeTownAlly;
	TargetFunc ManaTarget;
	TargetFunc MoreTarget;
	TargetFunc MoreXTarget;
	TargetFunc MoreXYZTarget;
	TargetFunc MoreYTarget;
	TargetFunc MoreZTarget;
	TargetFunc MovableTarget;
	TargetFunc MoveToBagTarget;
	TargetFunc NewXTarget;
	TargetFunc NewYTarget;
	TargetFunc NewzTarget;
	TargetFunc NpcAITarget;
	TargetFunc NpcCircleTarget;
	TargetFunc NpcRectTarget;
	TargetFunc NpcTarget;
	TargetFunc NpcTarget2;
	TargetFunc NpcWanderTarget;
	TargetFunc ObjPrivTarget;
	TargetFunc OwnerTarget;
	TargetFunc permHideTarget;
	TargetFunc PlVBuy;
	TargetFunc PossessTarget;
	TargetFunc PrivTarget;
	TargetFunc RemoveShopTarget;
	TargetFunc RemoveTarget;
	TargetFunc RenameTarget;
	TargetFunc ResurrectionTarget;
	TargetFunc SellStuffTarget;
	TargetFunc SetAdvObjTarget;
	TargetFunc SetDirTarget;
	TargetFunc SetInvulFlag;
	TargetFunc SetPoisonedTarget;
	TargetFunc SetPoisonTarget;
	TargetFunc SetRestockTarget;
	TargetFunc SetSpaDelayTarget;
	TargetFunc SetSpAttackTarget;
	TargetFunc SetSplitChanceTarget;
	TargetFunc SetSplitTarget;
	TargetFunc SetBuyValueTarget;
	TargetFunc SetSellValueTarget;
	TargetFunc SetWipeTarget;
	TargetFunc ShowDetail;
	TargetFunc ShowSkillTarget;
	TargetFunc SmeltTarget;
	TargetFunc SquelchTarg;
	TargetFunc StaminaTarget;
	TargetFunc SwordTarget;
	TargetFunc TeleStuff;
	TargetFunc TeleTarget;
	TargetFunc Tiling;
	TargetFunc TitleTarget;
	TargetFunc TransferTarget;
	TargetFunc TypeTarget;
	TargetFunc UnfreezeTarget;
	TargetFunc UnglowTarget;
	TargetFunc unHideTarget;
	TargetFunc VisibleTarget;
	TargetFunc WstatsTarget;
	TargetFunc xBankTarget;
	TargetFunc XgoTarget;
	
	void	SpawnObjTarget( cSocket *s, bool isList );

	void	KillTarget( cSocket *s, UI08 ly);
	void	newCarveTarget( cSocket *s, CItem *i );
	CChar *	NpcMenuTarget( cSocket *s );
	CItem *	AddMenuTarget( cSocket *s, bool x, char *addmitem );
public:
	TargetFunc CstatsTarget;
	TargetFunc TweakTarget;
	TargetFunc GetAccount;
	TargetFunc IDtarget;
	TargetFunc MultiTarget;
	TargetFunc Wiping;

	void	NpcResurrectTarget( CChar *s );
	void	JailTarget( cSocket *s, SERIAL c );
	void	ReleaseTarget( cSocket *s, SERIAL c );
	void	XTeleport( cSocket *s, UI08 x );
	bool	BuyShop( cSocket *s, CChar *c );
};

void	vialtarget( cSocket *nSocket );

enum TargetIDs
{
	TARGET_ADD = 0,
	TARGET_RENAME,
	TARGET_TELE,
	TARGET_REMOVE,
	TARGET_DYE,
	TARGET_NEWZ,
	TARGET_TYPE,
	TARGET_ID,
	TARGET_XGO,
	TARGET_PRIV,
	TARGET_MORE,
	TARGET_KEY,
	TARGET_ISTATS,
	TARGET_CSTATS,
	TARGET_REPAIRLEATHER,
	TARGET_REPAIRBOW,
	TARGET_KILLHAIR,
	TARGET_KILLBEARD,
	TARGET_KILLPACK,
	TARGET_FONT,
	TARGET_KILL,
	TARGET_RESURRECT,
	TARGET_BOLT,
	TARGET_AMOUNT,
	TARGET_REPAIRMETAL,
	TARGET_KICK,
	TARGET_ADDMENU,
	TARGET_NPCMENU,
	TARGET_MOVABLE,
	TARGET_ARMSLORE,
	TARGET_OWNER,
	TARGET_DYEALL,
	TARGET_DVAT,
	TARGET_ADDNPC,
	TARGET_FREEZE,
	TARGET_UNFREEZE,
	TARGET_ALLSET,
	TARGET_ANATOMY,
	TARGET_RECALL,
	TARGET_MARK,
	TARGET_ITEMID,
	TARGET_EVALINT,
	TARGET_TAME,
	TARGET_GATE,
	TARGET_HEAL,
	TARGET_FISH,
	TARGET_INFO,
	TARGET_TITLE,
	TARGET_SHOWDETAIL,
	TARGET_TOWNALLY,
	TARGET_SMITH,
	TARGET_MINE,
	TARGET_SMELTORE,
	TARGET_NPCACT,
	TARGET_WSTATS,
	TARGET_NPCFOLLOW,
	TARGET_NPCFOLLOW2,
	TARGET_NPCRESURRECT,
	TARGET_NPCCIRCLE,
	TARGET_NPCWANDER,
	TARGET_VISIBLE,
	TARGET_TWEAK,
	TARGET_MOREX,
	TARGET_MOREY,
	TARGET_MOREZ,
	TARGET_MOREXYZ,
	TARGET_NPCRECT,
	TARGET_DIVINELOCK,
	TARGET_DIVINEUNLOCK,
	TARGET_MAKESTATUS,
	TARGET_SETSCPTRIG,
	TARGET_DELETECHAR,
	TARGET_AXE,
	TARGET_DETECTHIDDEN,
	TARGET_PROVOCATION,
	TARGET_PROVOCATION2,
	TARGET_ENTICEMENT,
	TARGET_ENTICEMENT2,
	TARGET_SWORD,
	TARGET_SETDIR,
	TARGET_SETPRIVS,
	TARGET_AREACOMMAND,
	TARGET_CASTSPELL,
	TARGET_SETCOMMANDLEVEL,
	TARGET_REMOVESHOP,
	TARGET_NPCAI,
	TARGET_XBANK,
	TARGET_ALCHEMY,
	TARGET_DUPE,
	TARGET_MOVETOBAG,
	TARGET_SELL,
	TARGET_MANA,
	TARGET_STAMINA,
	TARGET_GMOPEN,
	TARGET_MAKESHOP,
	TARGET_FOLLOW,
	TARGET_ATTACK,
	TARGET_TRANSFER,
	TARGET_GUARD,
	TARGET_BUYSHOP,
	TARGET_SETBUYVALUE,
	TARGET_SETRESTOCK,
	TARGET_FRIEND,
	TARGET_SETSELLVALUE,
	TARGET_JAIL,
	TARGET_RELEASE,
	TARGET_CREATEBANDAGE,
	TARGET_HEALING,
	TARGET_PERMHIDE,
	TARGET_UNHIDE,
	TARGET_WIPABLE,
	TARGET_CARPENTRY,
	TARGET_XTELEPORT,
	TARGET_SETSPATTACK,
	TARGET_FULLSTATS,
	TARGET_BEGGING,
	TARGET_ANIMALLORE,
	TARGET_FORENSICS,
	TARGET_APPLYPOISON,
	TARGET_POISONITEM,
	TARGET_INSCRIBE,
	TARGET_VOTEFORMAYOR,
	TARGET_LOCKPICK,
	TARGET_WHEEL,
	TARGET_LOOM,
	TARGET_TAILORING,
	TARGET_COOKING,
	TARGET_LOADCANNON,
	TARGET_FLETCHING,
	TARGET_SETPOISON,
	TARGET_SETPOISONED,
	TARGET_SETSPDELAY,
	TARGET_SETADVOBJ,
	TARGET_SETINVULNFLAG,
	TARGET_TINKERING,
	TARGET_TINKERAXEL,
	TARGET_TINKERAWG,
	TARGET_TINKERCLOCK,
	TARGET_VIAL,
	TARGET_TILING,
	TARGET_WIPING,
	TARGET_STEALING,
	TARGET_CANTRAIN,
	TARGET_SETSPLIT,
	TARGET_SETSPLITCHANCE,
	TARGET_POSSESS,
	TARGET_TELESTUFF,
	TARGET_SQUELCH,
	TARGET_PLVBUY,
	TARGET_HOUSEOWNER,
	TARGET_HOUSEEJECT,
	TARGET_HOUSEBAN,
	TARGET_HOUSEFRIEND,
	TARGET_HOUSEUNLIST,
	TARGET_HOUSELOCKDOWN,
	TARGET_HOUSERELEASE,
	TARGET_BAN,
	TARGET_SMELT,
	TARGET_SHOWSKILLS,
	TARGET_UNGLOW,
	TARGET_INCZ,
	TARGET_NEWX,
	TARGET_NEWY,
	TARGET_INCX,
	TARGET_INCY,
	TARGET_GLOW,
	TARGET_SPAWNOBJ,
	TARGET_SPAWNOBJLIST,
	TARGET_NOFUNC
};

#endif
