#ifndef __UOXTYPES_H
#define __UOXTYPES_H

#ifdef __NEED_VALIST__
	typedef void *  va_list;
#endif

#if defined(__unix__)
	#define MAKEWORD(a, b)      ((UI16)(((UI08)(a)) | ((UI16)((UI08)(b))) << 8))
	#define MAKELONG(a, b)      ((UI32)(((UI16)(a)) | ((UI32)((UI16)(b))) << 16))
	#define LOWORD(l)           ((UI16)(l))
	#define HIWORD(l)           ((UI16)(((UI32)(l) >> 16) & 0xFFFF))
	#define LOBYTE(w)           ((UI08)(w))
	#define HIBYTE(w)           ((UI08)(((UI16)(w) >> 8) & 0xFF))
#endif


typedef double				R64;
typedef float				R32;
typedef unsigned long int	UI32;
typedef signed long int		SI32;
typedef unsigned short int	UI16;
typedef signed short int	SI16;
typedef unsigned char		UI08;
typedef signed char			SI08;

#if defined(__unix__)
	#define MAX_PATH		268
	//#define INVALID_SOCKET  (~0)
	//#define SOCKET_ERROR	(-1)
	#include "uoxlinux.h" //linux wrappers for windows-specific api calls
#endif

typedef UI32		TIMERVAL;
typedef UI32		UOXSOCKET;
typedef UI32		PLAYER;
typedef UI32		CHARACTER;
typedef UI16		RACEID;
typedef UI08		GENDER;
typedef UI16		COLOUR;
typedef UI08		LIGHTLEVEL;
typedef UI08		SECONDS;
typedef UI08		ARMORCLASS;
typedef UI32		ITEM;
typedef UI32		SERIAL;
typedef SI08		RACEREL;
typedef UI16		SKILLVAL;
typedef SI08		RANGE;
typedef UI08		weathID;
typedef SI16		GUILDID;

const SERIAL INVALIDSERIAL	= 0xFFFFFFFF;
const UI16 INVALIDID		= 0xFFFF;
const UI16 INVALIDCOLOUR	= 0xFFFF;
const SERIAL BASEITEMSERIAL = 0x40000000;

//
typedef std::vector< std::string >	STRINGLIST;
typedef std::vector< std::string >::iterator STRINGLIST_ITERATOR;
typedef std::vector< std::string >::const_iterator STRINGLIST_CITERATOR;
//
typedef std::vector< SERIAL > SERLIST;
typedef std::vector< SERIAL >::iterator SERLIST_ITERATOR;
typedef std::vector< SERIAL >::const_iterator SERLIST_CITERATOR;
//
typedef std::vector< CChar* > CHARLIST;
typedef std::vector< CChar* >::iterator CHARLIST_ITERATOR;
typedef std::vector< CChar* >::const_iterator CHARLIST_CITERATOR;
//
typedef std::vector< CItem* > ITEMLIST;
typedef std::vector< CItem* >::iterator ITEMLIST_ITERATOR;
typedef std::vector< CItem* >::const_iterator ITEMLIST_CITERATOR;
//
typedef std::map< cBaseObject *, UI32 > QUEUEMAP;
typedef std::map< cBaseObject *, UI32 >::iterator QUEUEMAP_ITERATOR;
typedef std::map< cBaseObject *, UI32 >::const_iterator QUEUEMAP_CITERATOR;

struct FirewallEntry
{
	SI16 b[4];
	FirewallEntry( SI16 p1, SI16 p2, SI16 p3, SI16 p4 )
	{
		b[0] = p1; b[1] = p2; b[2] = p3; b[3] = p4; 
	}
};

typedef FirewallEntry *LPFirewallEntry;

// December 27, 2000
typedef struct __STARTLOCATIONDATA__
{
	__STARTLOCATIONDATA__()
	{
		memset( this, 0x00, sizeof( __STARTLOCATIONDATA__ ) );
	}
	char	town[32];
	char	description[32];
	SI16	x;
	SI16	y;
	SI16	z;
} STARTLOCATION, *LPSTARTLOCATION;
//	EviLDeD	-	End

#define PACK_NEEDED

#define MAX_LASTON			30
#define MAX_NAME			30
#define MAX_TITLE			50
#define MAX_GUILDTITLE		21
#define MAX_STACK			0xFFFF
#define MAX_REGIONNAME		128
#define MAX_FAMETITLE		128
#define MAX_VISRANGE		20
#define MAX_Z_STEP			9
#define MAX_TRACKINGTARGETS	128
#define MAXBUFFER			2560	// Buffer Size (For socket operations)
#define MAXPOSTS			128

const SI08 ILLEGAL_Z = -128;
const UI08 MAXLAYERS = 30;			// Maximum number of Layers in paperdolls (max seems to be 0x1D)

// these are the fixed record lengths as determined by the .mul files from OSI
// i made them longs because they are used to calculate offsets into the files
const UI32 VersionRecordSize = 20L;
const UI32 MultiRecordSize = 12L;
const UI32 LandRecordSize = 26L;
const UI32 TileRecordSize = 37L;
const UI32 MapRecordSize = 3L;
const UI32 MultiIndexRecordSize = 12L;
const UI32 StaticRecordSize = 7L;

#define TRUESKILLS ALLSKILLS //#skills+1

#define DOORTYPES 19

#define MAP0CACHE 300

#define ITEMMENUOFFSET		256
#define TRACKINGMENUOFFSET	4096
#define POLYMORPHMENUOFFSET 8192

const UI08 NORTH		= 0;
const UI08 NORTHEAST	= 1;
const UI08 EAST			= 2;
const UI08 SOUTHEAST	= 3;
const UI08 SOUTH		= 4;
const UI08 SOUTHWEST	= 5;
const UI08 WEST			= 6;
const UI08 NORTHWEST	= 7;
const UI08 UNKNOWNDIR	= 0xFF;

// Line Of Sight
#define ITEM_TYPE_CHOICES	6
#define TREES_BUSHES		1 // Trees and other large vegetaion in the way
#define WALLS_CHIMNEYS		2  // Walls, chimineys, ovens, etc... in the way
#define DOORS				4 // Doors in the way
#define ROOFING_SLANTED		8  // So can't tele onto slanted roofs, basically
#define FLOORS_FLAT_ROOFING 16  //  For attacking between floors
#define LAVA_WATER			32  // Don't know what all to use this for yet

#endif
