#ifndef __UOXSTRUCT_H
#define __UOXSTRUCT_H

#include "cAccountClass.h"

struct creat_st
{
private:
	UI16 basesound;
	UI08 soundflag;
	UI08 who_am_i; 
	UI16 icon;
public:
			creat_st() : basesound( 0 ), soundflag( 0 ), who_am_i( 0 ), icon( 0 )
			{
			}
	UI16	BaseSound( void )
	{
		return basesound;
	}
	UI16	Icon( void )
	{
		return icon;
	}
	UI08	SoundFlag( void )
	{
		return soundflag;
	}
	UI08	WhoAmI( void )
	{
		return who_am_i;
	}

	void	BaseSound( UI16 value )
	{
		basesound = value;
	}
	void	Icon( UI16 value )
	{
		icon = value;
	}
	void	SoundFlag( UI08 value )
	{
		soundflag = value;
	}
	void	WhoAmI( UI08 value )
	{
		who_am_i = value;
	}

	bool	IsAnimal( void )
	{
		return ( ( who_am_i & 4 ) == 4 );
	}
	bool	AntiBlink( void )
	{
		return ( ( who_am_i & 2 ) == 2 );
	}
	bool	CanFly( void )
	{
		return ( ( who_am_i & 1 ) == 1 );
	}
	bool	IsWater( void )
	{
		return ( ( who_am_i & 8 ) == 8 );
	}
	void	IsAnimal( bool value )
	{
		if( value )
			who_am_i |= 4;
		else
			who_am_i &= 0xFB;
	}
	void	AntiBlink( bool value )
	{
		if( value )
			who_am_i |= 2;
		else
			who_am_i &= 0xFD;
	}
	void	CanFly( bool value )
	{
		if( value )
			who_am_i |= 1;
		else
			who_am_i &= 0xFE;
	}
	void	IsWater( bool value )
	{
		if( value )
			who_am_i |= 8;
		else
			who_am_i &= 0xF7;
	}
};

typedef const char *CLPSTR;

struct commandLevel_st
{
	char name[17];		// name of level
	UI08 commandLevel;	// upper limit of level
	UI16 defaultPriv;	// default privs associated with it
	UI16 nickColour;	// colour of a person's name
	UI16 allSkillVals;	// if 0, skills left same, if not, all skills set to this value
	UI16 targBody;		// target body value
	UI16 bodyColour;	// target body colour
	bool stripOff;		// strips off hair, beard and clothes
};

struct vector2D
{
	R32 x;
	R32 y;
	vector2D()
	{
	}
	vector2D( R32 X, R32 Y ) : x(X), y(Y)
	{
	}
};

struct vector3D
{
	SI32 x;
	SI32 y;
	SI08 z;
	vector3D()
	{
	}
	vector3D( SI32 X, SI32 Y, SI08 Z ) : x(X), y(Y), z(Z)
	{
	}
};

inline bool operator== (vector3D const &a, vector3D const &b )
{
	return ( ( a.x == b.x ) && ( a.y == b.y ) && ( a.z == b.z ) );
}

inline bool operator< (vector3D const &a, vector3D const &b )
{
	return ( ( a.x < b.x ) && ( a.y < b.y ) && ( a.z < b.z ) );
}

struct line2D
{
	vector2D loc;
	vector2D dir;
	line2D()
	{
	}
	line2D( vector2D LOC, vector2D DIR ) : loc(LOC), dir(DIR)
	{
	}
	vector2D CollideLines2D( line2D toCollide ) const;
};

inline vector2D line2D::CollideLines2D( line2D toCollide ) const
{
	if( ( ( dir.x == 0 ) && ( toCollide.dir.x == 0 ) ) ||
		( ( dir.y == 0 ) && ( toCollide.dir.y == 0 ) ) )
		return vector2D( -1.0f, -1.0f ); // error, parallel or invalid lines
	if( ( ( dir.x * toCollide.dir.y ) - ( toCollide.dir.x * dir.y ) ) == 0 )
		return vector2D( -1.0f, -1.0f ); // error, parallel lines
		
	R32 t = 0.0f; // parameter of toCollide-line
	// linear evaluation of extended 2x2 matrix
	t = ( ( ( ( loc.x - toCollide.loc.x ) * (- dir.y) ) + ( dir.x * ( loc.y - toCollide.loc.y ) ) ) /
		( ( dir.x * toCollide.dir.y ) - ( toCollide.dir.x * dir.y ) ) );

	return vector2D( ( toCollide.loc.x + t * toCollide.dir.x ), ( toCollide.loc.y + t * toCollide.dir.y ) );
}

struct line3D
{
	vector3D loc;
	vector3D dir;
	line3D()
	{
	}
	line3D( vector3D LOC, vector3D DIR ) : loc(LOC), dir(DIR)
	{
	}
	R32 dzInDirectionX( void ) const;
	R32 dzInDirectionY( void ) const;
	line2D Projection2D( void ) const;
};

inline R32 line3D::dzInDirectionX( void ) const
{
	if( dir.x == 0 )
		return (R32)( dir.z );
	else
		return (R32)( (R32)( dir.z ) / (R32)( dir.x ) );
}

inline R32 line3D::dzInDirectionY( void ) const
{
	if( dir.y == 0 )
		return (R32)( dir.z );
	else
		return (R32)( (R32)( dir.z ) / (R32)( dir.y ) );
}

inline line2D line3D::Projection2D( void ) const
{
	if( ( dir.x == 0 ) && ( dir.y == 0 ) )
		return line2D( vector2D( -1.0f, -1.0f ), vector2D( -1.0f, -1.0f ) );
	else
		return line2D( vector2D( (R32)loc.x, (R32)loc.y ), vector2D( (R32)dir.x, (R32)dir.y ) );
}

struct point3
{
	R32		x, y, z;
			point3()
			{
			}
			point3( UI16 X, UI16 Y, SI08 Z ) : x( X ), y( Y ), z( Z )
			{
			}
			point3( R32 X, R32 Y, R32 Z ) : x( X ), y( Y ), z( Z )
			{
			}
	void	Assign( UI16 X, UI16 Y, SI08 Z );
	void	Assign( R32 X, R32 Y, R32 Z );
	R32		Mag( void ) const;
	R32		MagSquared( void ) const;
	R32		Mag3D( void ) const;
	R32		MagSquared3D( void ) const;
	void	Normalize( void );
};

inline point3 operator+( point3 const &a, point3 const &b )
{
	return (point3( a.x + b.x, a.y + b.y, a.z + b.z ));
}

inline point3 operator-( point3 const &a, point3 const &b )
{
	return (point3( a.x - b.x, a.y - b.y, a.z - b.z ));
}
inline point3 operator*( point3 const &a, R32 const &b )
{
	return point3( a.x*b, a.y*b, a.z*b );
}
inline point3 operator*( R32 const &a, point3 const &b )
{
	return point3( a * b.x, a * b.y, a * b.z );
}
inline point3 operator/( point3 const &a, R32 const &b )
{
	R32 inv = 1.f / b;
	return point3( a.x * inv, a.y * inv, a.z * inv );
}
inline void point3::Assign( UI16 X, UI16 Y, SI08 Z )
{
	x = X;
	y = Y;
	z = Z;
}
inline void point3::Assign( R32 X, R32 Y, R32 Z )
{
	x = X;
	y = Y;
	z = Z;
}
inline R32 point3::Mag3D( void ) const
{
	return (R32)sqrt( x*x + y*y + z*z );
}
inline R32 point3::MagSquared3D( void ) const
{
	return ( x*x + y*y + z*z );
}

inline R32 point3::Mag( void ) const
{
	return (R32)sqrt( x*x + y*y );
}
inline R32 point3::MagSquared( void ) const
{
	return ( x*x + y*y );
}

inline void point3::Normalize( void )
{
	R32 foo = 1 / Mag3D();
	x *= foo;
	y *= foo;
	z *= foo;
}

// create.scp revisions
struct resAmountPair
{
	UI16 itemID;
	UI08 amountNeeded;
	UI16 colour;
	resAmountPair()
	{
		itemID = 0; amountNeeded = 1; colour = 0;
	};
};

struct resSkillReq
{
	UI08 skillNumber;
	UI16 minSkill;
	UI16 maxSkill;
};

struct createEntry
{
	UI16 colour;
	UI16 targID;
	UI16 soundPlayed;
	UI08 minRank;
	UI08 maxRank;
	std::string addItem;
	SI16 delay;
	UI16 spell;
	std::vector< resAmountPair > resourceNeeded;
	std::vector< resSkillReq > skillReqs;
	std::string name;
	createEntry() : colour( 0 ), targID( 0 ), soundPlayed( 0 ), minRank( 1 ), maxRank( 10 ), addItem( "" ), delay( 0 ), name( "" )
	{
	}
	R32 AverageMinSkill( void ) 
	{ 
		R32 sum = 0;
		for( UI32 i = 0; i < skillReqs.size(); ++i )
			sum += skillReqs[i].minSkill;
		return sum / skillReqs.size();
	}
	R32 AverageMaxSkill( void ) 
	{ 
		R32 sum = 0;
		for( UI32 i = 0; i < skillReqs.size(); ++i )
			sum += skillReqs[i].maxSkill;
		return sum / skillReqs.size();
	}

};

struct TeleLocationEntry
{
	SI16 src[3];
	SI16 srcWorld;
	SI16 trg[3];
	UI08 trgWorld;
	TeleLocationEntry() 
	{ 
		src[0] = src[1] = src[2] = 0; 
		trg[0] = trg[1] = trg[2] = 0; 
		srcWorld = -1;	// -1 indicates all worlds
		trgWorld = 0;
	}
};

struct UOXFileWrapper
{
	FILE *mWrap;
};

#endif
