#include <algorithm>
#include "uox3.h"
#include "targeting.h"
#include "commands.h"
#include "cEffects.h"
#include "packets.h"
#include "classes.h"

#undef DBGFILE
#define DBGFILE "vendor.cpp"

//o---------------------------------------------------------------------------o
//|   Function    :  void PlVGetgold( cSocket *mSock, CChar *v )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Get gold when player buys an item off a player vendor
//o---------------------------------------------------------------------------o
void PlVGetgold( cSocket *mSock, CChar *v )
{
	CChar *mChar = mSock->CurrcharObj();
	UI32 pay = 0, give = v->GetHoldG(), t = 0;
	if( mChar == v->GetOwnerObj() )
	{
		if( v->GetHoldG() <= 0 )
		{
			v->talk( mSock, 1326, false );
			v->SetHoldG( 0 );
			return;
		} 
		else if( v->GetHoldG() > 0 && v->GetHoldG() <= MAX_STACK )
		{
			if( v->GetHoldG() > 9 )
			{
				pay = (int)( v->GetHoldG() / 10 );
				give = v->GetHoldG() - pay;
			} 
			else 
			{
				pay = v->GetHoldG();
				give = 0;
			}
			v->SetHoldG( 0 );
		}
		else 
		{
			t = v->GetHoldG() - MAX_STACK;	// yank of 65 grand, then do calculations
			v->SetHoldG( t );
			pay = 6554;
			give = 58981;
			if( t > 0 )
				v->talk( mSock, 1327, false );
		}
		if( give ) 
			Items->SpawnItem( mSock, mChar, give, "#", 1, 0x0EED, 0, true, true);
		
		v->talk( mSock, 1328, false, v->GetHoldG(), pay, give );
	} 
	else 
		v->talk( mSock, 1329, false );
}

//o---------------------------------------------------------------------------o
//|   Function    :  void buyItem( cSocket *mSock )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Called when player buys an item from a vendor
//o---------------------------------------------------------------------------o
void buyItem( cSocket *mSock )
{
	int i, j;
	int itemtotal;
	UI32 playergoldtotal, goldtotal = 0;
	bool soldout = false, clear = false;
	CChar *mChar = mSock->CurrcharObj();
	CItem *p = getPack( mChar );
	if( p == NULL ) 
		return;

	std::vector< int > bitems, amount, layer;

	CChar *npc = calcCharObjFromSer( mSock->GetDWord( 3 ) );
	
	itemtotal = (mSock->GetWord( 1 ) - 8) / 7;
	if( itemtotal > 511 ) 
		return;
	bitems.resize( itemtotal );
	amount.resize( itemtotal );
	layer.resize( itemtotal );
	int baseOffset = 0;
	for( i = 0; i < itemtotal; ++i )
	{
		baseOffset	= 7 * i;
		layer[i]	= mSock->GetByte( 8 + baseOffset );
		bitems[i]	= calcItemFromSer( mSock->GetDWord( 9 + baseOffset ) );
		amount[i]	= mSock->GetWord( 13 + baseOffset );
		goldtotal	+= ( amount[i] * ( items[bitems[i]].GetBuyValue() ) );
	}
	bool useBank = (goldtotal >= static_cast<UI32>(cwmWorldState->ServerData()->BuyThreshold() ));
	if( useBank )
		playergoldtotal = GetBankCount( mChar, 0x0EED );
	else
		playergoldtotal = GetAmount( mChar, 0x0EED );
	if( playergoldtotal >= goldtotal || mChar->IsGM() )
	{
		for( i = 0; i < itemtotal; ++i )
		{
			if( items[bitems[i]].GetAmount() < amount[i] )
				soldout = true;
		}
		if( soldout )
		{
			npc->talk( mSock, 1336, false );
			clear = true;
		}
		else
		{
			if( mChar->IsGM() )
				npc->talkAll( 1337, false, mChar->GetName().c_str() );
			else
			{
				if( goldtotal == 1 )
					npc->talkAll( 1338, false, mChar->GetName().c_str(), goldtotal );
				else
					npc->talkAll( 1339, false, mChar->GetName().c_str(), goldtotal );

				Effects->goldSound( mSock, goldtotal );
			}
			
			clear = true;
			if( !mChar->IsGM() ) 
			{
				if( useBank )
					DeleteBankItem( mChar, 0x0EED, 0, goldtotal );
				else
					DeleteQuantity( mChar, 0x0EED, goldtotal );
			}
			int biTemp;
			CItem *iMade = NULL;
			for( i = 0; i < itemtotal; ++i )
			{
				biTemp = bitems[i];
				iMade = NULL;
				if( items[biTemp].GetAmount() > amount[i] )
				{
					if( items[biTemp].isPileable() )
					{
						iMade = Commands->DupeItem( mSock, &items[biTemp], amount[i] );
						if( iMade != NULL )
						{
							iMade->SetX( (SI16)( 20 + ( RandomNum( 0, 49 ) ) ) );
							iMade->SetY( (SI16)( 85 + ( RandomNum( 0, 75 ) ) ) );
							iMade->SetCont( p );
						}
					}
					else
					{
						for( j = 0; j < amount[i]; ++j )
						{
							iMade = Commands->DupeItem( mSock, &items[biTemp], 1 );
							if( iMade != NULL )
							{
								iMade->SetX( (SI16)( 20 + ( RandomNum( 0, 49 ) ) ) );
								iMade->SetY( (SI16)( 85 + ( RandomNum( 0, 75 ) ) ) );
								iMade->SetCont( p );
							}
						}
					}
					items[biTemp].SetAmount( items[biTemp].GetAmount() - amount[i] );
					items[biTemp].SetRestock( items[biTemp].GetRestock() + amount[i] );
				}
				else
				{
					switch( layer[i] )
					{
						case 0x1A: // Buy Container
							if( items[biTemp].isPileable() )
							{
								iMade = Commands->DupeItem( mSock, &items[biTemp], amount[i] );
								if( iMade != NULL )
								{
									iMade->SetX( (SI16)( 20 + ( RandomNum( 0, 49 ) ) ) );
									iMade->SetY( (SI16)( 85 + ( RandomNum( 0, 75 ) ) ) );
									iMade->SetCont( p );
								}
							}
							else
							{
								for( j = 0; j < amount[i]; ++j )
								{
									iMade = Commands->DupeItem( mSock, &items[biTemp], 1 );
									if( iMade != NULL )
									{
										iMade->SetX( (SI16)( 20 + ( RandomNum( 0, 49 ) ) ) );
										iMade->SetY( (SI16)( 85 + ( RandomNum( 0, 75 ) ) ) );
										iMade->SetCont( p );
									}
								}
								iMade = NULL;
							}
							items[biTemp].SetAmount( items[biTemp].GetAmount() - amount[i] );
							items[biTemp].SetRestock( items[biTemp].GetRestock() + amount[i] );
							break;
						case 0x1B: // Bought Container
							if( items[biTemp].isPileable() )
								items[biTemp].SetCont( p );
							else
							{
								for( j = 0; j < amount[i]-1; ++j )
								{
									iMade = Commands->DupeItem( mSock, &items[biTemp], 1 );
									if( iMade != NULL )
									{
										iMade->SetX( (SI16)( 20 + ( RandomNum( 0, 49 ) ) ) );
										iMade->SetY( (SI16)( 85 + ( RandomNum( 0, 75 ) ) ) );
										iMade->SetCont( p );
									}
								}

								items[biTemp].SetCont( p );
								items[biTemp].SetAmount( 1 );
							}
							break;
						default:
							Console.Error( 2, " Fallout of switch statement without default. vendor.cpp, buyItem()" );
							break;
					}
				}
				/*if( iMade != NULL )
				{
					iMade->SetX( (SI16)( 20 + ( RandomNum( 0, 49 ) ) ) );
					iMade->SetY( (SI16)( 85 + ( RandomNum( 0, 75 ) ) ) );
					iMade->SetCont( p );
				}*/
			}
		}
	}
	else
		npc->talkAll( 1340, false );
	
	if( clear )
	{
		CPBuyItem clrSend;
		clrSend.Serial( mSock->GetDWord( 3 ) );
		mSock->Send( &clrSend );
	}
	mSock->statwindow( mChar );
}

//o---------------------------------------------------------------------------o
//|   Function    :  void sendSellSubItem( CChar *npc, CItem *p, CItem *q, UI08 *m1, int &m1t)
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Send available sell items to client for Sell list
//o---------------------------------------------------------------------------o
void sendSellSubItem( CChar *npc, CItem *p, CItem *q, UI08 *m1, int &m1t)
{
	UI32 value;
	int z;
	char ciname[MAX_NAME];
	char cinam2[MAX_NAME];
	std::string itemname;
	itemname.reserve( MAX_NAME );
	
	for( CItem *i = p->FirstItem(); !p->FinishedItems(); i = p->NextItem() )
	{
		if( i != NULL )
		{
			strcpy( ciname, i->GetName().c_str() );
			strcpy( cinam2, q->GetName().c_str() );
			strupr( ciname );
			strupr( cinam2 );
			
			if( i->GetType() == 1 )
				sendSellSubItem( npc, i, q, m1, m1t );
			else if( i->GetID() == q->GetID() && i->GetType() == q->GetType() &&
				m1[8] < 60 && ( !cwmWorldState->ServerData()->SellByNameStatus() ||
				( cwmWorldState->ServerData()->SellByNameStatus() && !strcmp( ciname, cinam2 ) ) ) )
			{
				m1[m1t+0] = i->GetSerial( 1 );
				m1[m1t+1] = i->GetSerial( 2 );
				m1[m1t+2] = i->GetSerial( 3 );
				m1[m1t+3] = i->GetSerial( 4 );
				m1[m1t+4] = i->GetID( 1 );
				m1[m1t+5] = i->GetID( 2 );
				m1[m1t+6] = i->GetColour( 1 );
				m1[m1t+7] = i->GetColour( 2 );
				m1[m1t+8] = (UI08)(i->GetAmount()>>8);
				m1[m1t+9] = (UI08)(i->GetAmount()%256);
				value = calcValue( i, (UI32)q->GetBuyValue() );
				if( cwmWorldState->ServerData()->TradeSystemStatus() )
					value = calcGoodValue( npc, q, value, true );
				m1[m1t+10] = (UI08)(value>>8);
				m1[m1t+11] = (UI08)(value%256);
				m1[m1t+12] = 0;// Unknown... 2nd length byte for string?
				m1[m1t+13] = (UI08)(getTileName( i, itemname ));
				m1t += 14;
				for( z = 0; z < m1[m1t-1]; ++z )
					m1[m1t+z] = itemname[z];

				m1t += m1[m1t-1];
				++m1[8];
			}
		}
	}
}

//o---------------------------------------------------------------------------o
//|   Function    :  bool sendSellStuff( cSocket *s, CChar *i )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Send Vendor Sell List to client
//o---------------------------------------------------------------------------o
bool sendSellStuff( cSocket *s, CChar *i )
{
	std::string itemname;
	UI32 value;
	UI08 m1[2048];
	char ciname[256];
	char cinam2[256];
	
	CItem *vendorPack = i->GetItemAtLayer( 0x1C );	// find the acceptable sell layer
	if( vendorPack == NULL ) 
		return false;	// no layer
	
	CPPauseResume prPause( 1 );
	CChar *mChar = s->CurrcharObj();
	s->Send( &prPause );
	
	CItem *pack = getPack( mChar );				// no pack for the player
	if( pack == NULL ) 
		return false;
	
	m1[0] = 0x9E; // Header
	m1[1] = 0; // Size
	m1[2] = 0; // Size
	m1[3] = i->GetSerial( 1 );
	m1[4] = i->GetSerial( 2 );
	m1[5] = i->GetSerial( 3 );
	m1[6] = i->GetSerial( 4 );
	m1[7] = 0; // Num items
	m1[8] = 0; // Num items
	int m1t = 9;

	for( CItem *q = vendorPack->FirstItem(); !vendorPack->FinishedItems(); q = vendorPack->NextItem() )
	{
		if( q != NULL )
		{
			for( CItem *j = pack->FirstItem(); !pack->FinishedItems(); j = pack->NextItem() )
			{
				if( j != NULL )
				{
					strcpy( ciname, j->GetName().c_str() );
					strcpy( cinam2, q->GetName().c_str() );
					strupr( ciname );
					strupr( cinam2 );
					if( j->GetType() == 1 )
						sendSellSubItem( i, j, q, m1, m1t );
					else if( ( j->GetID() == q->GetID() && j->GetType() == q->GetType() &&
						m1[8] < 60 && !cwmWorldState->ServerData()->SellByNameStatus() ) || ( cwmWorldState->ServerData()->SellByNameStatus() && 
						!strcmp( ciname, cinam2 ) ) )
					{
						m1[m1t+0] = j->GetSerial( 1 );
						m1[m1t+1] = j->GetSerial( 2 );
						m1[m1t+2] = j->GetSerial( 3 );
						m1[m1t+3] = j->GetSerial( 4 );
						m1[m1t+4] = j->GetID( 1 );
						m1[m1t+5] = j->GetID( 2 );
						m1[m1t+6] = j->GetColour( 1 );
						m1[m1t+7] = j->GetColour( 2 );
						m1[m1t+8] = (UI08)(j->GetAmount()>>8);
						m1[m1t+9] = (UI08)(j->GetAmount()%256);
						value = calcValue( j, (UI32)q->GetBuyValue() );
						if( cwmWorldState->ServerData()->TradeSystemStatus() )
							value = calcGoodValue( i, j, value, true );
						m1[m1t+10] = (UI08)(value>>8);
						m1[m1t+11] = (UI08)(value%256);
						m1[m1t+12] = 0;// Unknown... 2nd length byte for string?
						m1[m1t+13] = (UI08)(getTileName( j, itemname ));
						m1t += 14;
						for( int z = 0; z < m1[m1t-1]; ++z )
							m1[m1t+z]=itemname[z];

						m1t += m1[m1t-1];
						++m1[8];
					}
				}
			}
		}
	}
	
	m1[1] = (UI08)(m1t>>8);
	m1[2] = (UI08)(m1t%256);
	if( m1[8] != 0 )
	{
		s->Send( m1, m1t );
#if defined( _MSC_VER )
#pragma note( "Flush location" )
#endif
		s->FlushBuffer();
	}
	else
		i->talkAll( 1341, false );
	CPPauseResume prResume( 0 );
	s->Send( &prResume );
	return true;
}

//o---------------------------------------------------------------------------o
//|   Function    :  void sellItem( cSocket *mSock )
//|   Date        :  Unknown
//|   Programmer  :  Unknown
//o---------------------------------------------------------------------------o
//|   Purpose     :  Player sells an item to the vendor
//o---------------------------------------------------------------------------o
void sellItem( cSocket *mSock )
{
	if( mSock->GetByte( 8 ) != 0 )
	{
		CChar *mChar = mSock->CurrcharObj();
		CChar *n			= calcCharObjFromSer( mSock->GetDWord( 3 ) );
		if( n == NULL || mChar == NULL )
			return;
		CItem *sellPack		= n->GetItemAtLayer( 0x1A );
		CItem *boughtPack	= n->GetItemAtLayer( 0x1B );
		CItem *buyPack		= n->GetItemAtLayer( 0x1C );
		CItem *j, *k;
		UI16 i, amt, maxsell = 0;
		UI32 totgold = 0, value = 0;
		for( i = 0; i < mSock->GetByte( 8 ); ++i )
		{
			j = calcItemObjFromSer( mSock->GetDWord( 9 + (6*i) ) );
			amt = mSock->GetWord( 13 + (6*i) );
			maxsell += amt;
		}

		if( maxsell > cwmWorldState->ServerData()->SellMaxItemsStatus() )
		{
			n->talkAll( 1342, false, mChar->GetName().c_str(), cwmWorldState->ServerData()->SellMaxItemsStatus() );
			return;
		}

		for( i = 0; i < mSock->GetByte( 8 ); ++i )
		{
			j = calcItemObjFromSer( mSock->GetDWord( 9 + (6*i) ) );
			amt = mSock->GetWord( 13 + (6*i) );
			if( j != NULL )
			{
				if( j->GetAmount() < amt )
				{
					n->talkAll( 1343, false );
					return;
				}
				CItem *join = NULL;
				for( k = sellPack->FirstItem(); !sellPack->FinishedItems(); k = sellPack->NextItem() )
				{
					if( k != NULL )
					{
						if( k->GetID() == j->GetID() && j->GetType() == k->GetType() )
							join = k;
					}
				}
				for( k = buyPack->FirstItem(); !buyPack->FinishedItems(); k = buyPack->NextItem() )
				{
					if( k != NULL )
					{
						if( k->GetID() == j->GetID() && j->GetType() == k->GetType() )
							value = calcValue( j, (UI32)k->GetBuyValue() );
					}
				}
				if( join != NULL )
				{
					join->SetAmount( join->GetAmount() + amt );
					join->SetRestock( join->GetRestock() - amt );
					totgold += ( amt * value );
					if( j->GetAmount() == amt )
						Items->DeleItem( j );
					else
						j->SetAmount( j->GetAmount() - amt );
				}
				else
				{
					totgold += ( amt * value );
					j->SetCont( boughtPack );
//					j->RemoveFromSight();

					if( j->GetAmount() != amt ) 
						Commands->DupeItem( mSock, j, j->GetAmount() - amt );
				}
			} 
		}
		Items->addGold( mSock, totgold );
		Effects->goldSound( mSock, totgold );
	}
	
	CPBuyItem clrSend;
	clrSend.Serial( mSock->GetDWord( 3 ) );
	mSock->Send( &clrSend );
}

//o---------------------------------------------------------------------------o
//|   Function    :  void restock( bool stockAll )
//|   Date        :  3/15/2003
//|   Programmer  :	 Zane
//o---------------------------------------------------------------------------o
//|   Purpose     :  Restock all NPC Vendors
//o---------------------------------------------------------------------------o
void restock( bool stockAll )
{
	for( CHARACTER c = 0; c < cwmWorldState->GetCharCount(); ++c )
	{
		if( c != INVALIDSERIAL && chars[c].IsShop() )
			restockNPC( &chars[c], stockAll );
	}
}

//o---------------------------------------------------------------------------o
//|   Function    :  void restockNPC( CChar *i, bool stockAll )
//|   Date        :  Unknown
//|   Programmer  :  UOX3 DevTeam
//o---------------------------------------------------------------------------o
//|   Purpose     :  Restock NPC Vendors
//o---------------------------------------------------------------------------o
void restockNPC( CChar *i, bool stockAll )
{
	if( i == NULL || !i->IsShop() )
		return;	// if we aren't a shopkeeper, why bother?

	CItem *ci = i->GetItemAtLayer( 0x1A );
	if( ci != NULL )
	{
		for( CItem *c = ci->FirstItem(); !ci->FinishedItems(); c = ci->NextItem() )
		{
			if( c != NULL )
			{
				if( stockAll )
				{
					c->SetAmount( c->GetAmount() + c->GetRestock() );
					c->SetRestock( 0 );
				}
				else if( c->GetRestock() )
				{
					UI16 stockAmt = UOX_MIN( c->GetRestock(), static_cast<UI16>(( c->GetRestock() / 2 ) + 1) );
					c->SetAmount( c->GetAmount() + stockAmt );
					c->SetRestock( c->GetRestock() - stockAmt );
				}
				if( cwmWorldState->ServerData()->TradeSystemStatus() ) 
					Items->StoreItemRandomValue( c, calcRegionFromXY( i->GetX(), i->GetY(), i->WorldNumber() ) );
			}
		}
	}
}
